<?php
function woo_pd_generate_categories() {

	global $wpdb, $import;

	@ini_set( 'memory_limit', WP_MAX_MEMORY_LIMIT );

	$i = 0;
	$base_categories = array();
	// Check if Categories is empty
	if( !empty( $import->csv_category ) ) {
		// Check if Categories only contains a single header
		$size = count( $import->csv_category );
		if( $import->skip_first && $size == 1 ) {
			$import->log .= "<br />" . __( 'No Categories were provided', 'woocommerce-product-importer' );
			return;
		}
		for( ; $i < $size; $i++ ) {
			if( isset( $import->csv_category[$i] ) && strpos( $import->csv_category[$i], $import->category_separator ) ) {
				$base_categories_explode = explode( $import->category_separator, $import->csv_category[$i] );
				$base_categories_explode_size = count( $base_categories_explode );
				for( $j = 0; $j < $base_categories_explode_size; $j++ )
					$base_categories[] = $base_categories_explode[$j];
			} else {
				if( isset( $import->csv_category_1[$i] ) && isset( $import->csv_category_2[$i] ) && isset( $import->csv_category_3[$i] ) ) {
					$base_categories[] = $import->csv_category[$i] . $import->parent_child_delimiter . $import->csv_category_1[$i] . $import->parent_child_delimiter . $import->csv_category_2[$i] . $import->parent_child_delimiter . $import->csv_category_3[$i];
				} else if( isset( $import->csv_category_1[$i] ) && isset( $import->csv_category_2[$i] ) ) {
					$base_categories[] = $import->csv_category[$i] . $import->parent_child_delimiter . $import->csv_category_1[$i] . $import->parent_child_delimiter . $import->csv_category_2[$i];
				} else if( isset( $import->csv_category_1[$i] ) ) {
					$base_categories[] = $import->csv_category[$i] . $import->parent_child_delimiter . $import->csv_category_1[$i];
				} else if( isset( $import->csv_category[$i] ) ) {
					// Check if we are nuking Category associations for this Product
					if( $import->csv_category[$i] <> '-' )
						$base_categories[] = $import->csv_category[$i];
				}
			}
		}
		unset( $size );
		if( $import->skip_first )
			$i = 1;
		else
			$i = 0;
		$term_taxonomy = 'product_cat';
		$size = count( $base_categories );
		$count = 0;
		$include_log = true;
		if( $size > 1000 ) {
			$import->log .= "<br />>>> " . sprintf( __( 'We have just processed and generated so many Product Categories that we couldn\'t actually show you it in real-time, %d to be precise...', 'woocommerce-product-importer' ), $size );
			$include_log = false;
		}
		for( ; $i < $size; $i++ ) {
			$base_categories_explode = explode( $import->parent_child_delimiter, $base_categories[$i] );
			$base_categories_explode_size = count( $base_categories_explode );
			// Scan Categories for empty values before proceeding
			for( $j = 0; $j < $base_categories_explode_size; $j++ ) {
				if( strlen( utf8_decode( $base_categories_explode[$j] ) ) == false ) {
					unset( $base_categories_explode[$j] );
					$base_categories_explode_size--;
				}
			}
			for( $j = 0; $j < $base_categories_explode_size; $j++ ) {
				$category = new stdClass;
				$category->contents = $base_categories_explode;
				switch( $j ) {

					// Category
					case '0':
						if( $include_log )
							$import->log .= "<br />>>> " . sprintf( __( 'Category: %s', 'woocommerce-product-importer' ), trim( $category->contents[0] ) );
						if( WOO_PD_DEBUG !== true ) {
							if( !term_exists( trim( $category->contents[0] ), $term_taxonomy ) ) {
								$term = wp_insert_term( htmlspecialchars( trim( $category->contents[0] ) ), $term_taxonomy );
								$count++;
							}
						}
						if( $include_log ) {
							if( isset( $term ) && $term )
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Created Category: %s', 'woocommerce-product-importer' ), trim( $category->contents[0] ) );
							else
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Duplicate of Category detected: %s', 'woocommerce-product-importer' ), trim( $category->contents[0] ) );
						}
						break;

					// Category > Category
					case '1':
						if( $include_log )
							$import->log .= "<br />>>> " . sprintf( __( 'Category: %s > %s', 'woocommerce-product-importer' ), trim( $category->contents[0] ), trim( $category->contents[1] ) );
						$category->category_1 = get_term_by( 'name', trim( $category->contents[0] ), $term_taxonomy );
						if( $category->category_1 ) {
							if( WOO_PD_DEBUG !== true ) {
								if( !term_exists( trim( $category->contents[1] ), $term_taxonomy, $category->category_1->term_id ) ) {
									$term = wp_insert_term( htmlspecialchars( trim( $category->contents[1] ) ), $term_taxonomy, array( 'parent' => $category->category_1->term_id ) );
									$count++;
								}
							}
						}
						if( $include_log ) {
							if( isset( $term ) && $term )
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Created Category: %s', 'woocommerce-product-importer' ), trim( $category->contents[1] ) );
							else
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Duplicate of Category detected: %s', 'woocommerce-product-importer' ), trim( $category->contents[1] ) );
						}
						break;

					// Category > Category > Category
					case '2':
						if( $include_log )
							$import->log .= "<br />>>> " . sprintf( __( 'Category: %s > %s > %s', 'woocommerce-product-importer' ), trim( $category->contents[0] ), trim( $category->contents[1] ), trim( $category->contents[2] ) );
						$category->category_1 = get_term_by( 'name', htmlspecialchars( trim( $category->contents[0] ) ), $term_taxonomy );
						if( $category->category_1 ) {
							$category_2_sql = $wpdb->prepare( "SELECT terms.`term_id` FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`parent` = %d AND terms.`name` = %s AND term_taxonomy.`taxonomy` = %s LIMIT 1", $category->category_1->term_id, htmlspecialchars( trim( $category->contents[1] ) ), $term_taxonomy );
							$category->category_2 = $wpdb->get_var( $category_2_sql );
							$wpdb->flush();
						}
/*
						// WordPress standards method of accessing term, not working
						$args = array(
							'number' => 1,
							'search' => htmlspecialchars( trim( $category->contents[1] ) ),
							'child_of' => $category->category_1->term_id
						);
						$category->category_2 = get_terms( $term_taxonomy, $args );
*/
						if( $category->category_1 && $category->category_2 ) {
							if( WOO_PD_DEBUG !== true ) {
								if( !term_exists( trim( $category->contents[2] ), $term_taxonomy, $category->category_2 ) ) {
									$term = wp_insert_term( htmlspecialchars( trim( $category->contents[2] ) ), $term_taxonomy, array( 'parent' => $category->category_2 ) );
									$count++;
								}
							}
						}
						if( $include_log ) {
							if( isset( $term ) && $term )
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Created Category: %s', 'woocommerce-product-importer' ), trim( $category->contents[2] ) );
							else
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Duplicate of Category detected: %s', 'woocommerce-product-importer' ), trim( $category->contents[2] ) );
						}
						break;

					// Category > Category > Category > Category
					case '3':
						if( $include_log )
							$import->log .= "<br />>>> " . sprintf( __( 'Category: %s > %s > %s > %s', 'woocommerce-product-importer' ), trim( $category->contents[0] ), trim( $category->contents[1] ), trim( $category->contents[2] ), trim( $category->contents[3] ) );
						$category->category_1 = get_term_by( 'name', htmlspecialchars( trim( $category->contents[0] ) ), $term_taxonomy );
						if( $category->category_1 ) {
							$category_2_sql = $wpdb->prepare( "SELECT terms.`term_id` FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`parent` = %d AND terms.`name` = %s AND term_taxonomy.`taxonomy` = %s LIMIT 1", $category->category_1->term_id, htmlspecialchars( trim( $category->contents[1] ) ), $term_taxonomy );
							$category->category_2 = $wpdb->get_var( $category_2_sql );
						}
						if( $category->category_1 && $category->category_2 ) {
							$category_3_sql = $wpdb->prepare( "SELECT terms.`term_id` FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`parent` = %d AND terms.`name` = %s AND term_taxonomy.`taxonomy` = %s LIMIT 1", $category->category_2, htmlspecialchars( trim( $category->contents[2] ) ), $term_taxonomy );
							$category->category_3 = $wpdb->get_var( $category_3_sql );
							$wpdb->flush();
						}
						if( $category->category_1 && $category->category_2 && $category->category_3 ) {
							if( WOO_PD_DEBUG !== true ) {
								if( !term_exists( trim( $category->contents[3] ), $term_taxonomy, $category->category_3 ) ) {
									$term = wp_insert_term( htmlspecialchars( trim( $category->contents[3] ) ), $term_taxonomy, array( 'parent' => $category->category_3 ) );
									$count++;
								}
							}
						}
						if( $include_log ) {
							if( isset( $term ) && $term )
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Created Category: %s', 'woocommerce-product-importer' ), trim( $category->contents[3] ) );
							else
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Duplicate of Category detected: %s', 'woocommerce-product-importer' ), trim( $category->contents[3] ) );
						}
						break;

					// Category > Category > Category > Category > Category
					case '4':
						if( $include_log )
							$import->log .= "<br />>>> " . sprintf( __( 'Category: %s > %s > %s > %s > %s', 'woocommerce-product-importer' ), trim( $category->contents[0] ), trim( $category->contents[1] ), trim( $category->contents[2] ), trim( $category->contents[3] ), trim( $category->contents[4] ) );
						$category->category_1 = get_term_by( 'name', htmlspecialchars( trim( $category->contents[0] ) ), $term_taxonomy );
						if( $category->category_1 ) {
							$category_2_sql = $wpdb->prepare( "SELECT terms.`term_id` FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`parent` = %d AND terms.`name` = %s AND term_taxonomy.`taxonomy` = %s LIMIT 1", $category->category_1->term_id, htmlspecialchars( trim( $category->contents[1] ) ), $term_taxonomy );
							$category->category_2 = $wpdb->get_var( $category_2_sql );
						}
						if( $category->category_1 && $category->category_2 ) {
							$category_3_sql = $wpdb->prepare( "SELECT terms.`term_id` FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`parent` = %d AND terms.`name` = %s AND term_taxonomy.`taxonomy` = %s LIMIT 1", $category->category_2, htmlspecialchars( trim( $category->contents[2] ) ), $term_taxonomy );
							$category->category_3 = $wpdb->get_var( $category_3_sql );
							$wpdb->flush();
						}
						if( $category->category_2 && $category->category_3 ) {
							$category_4_sql = $wpdb->prepare( "SELECT terms.`term_id` FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`parent` = %d AND terms.`name` = %s AND term_taxonomy.`taxonomy` = %s LIMIT 1", $category->category_3, htmlspecialchars( trim( $category->contents[3] ) ), $term_taxonomy );
							$category->category_4 = $wpdb->get_var( $category_4_sql );
							$wpdb->flush();
						}
						if( $category->category_1 && $category->category_2 && $category->category_3 && $category->category_4 ) {
							if( WOO_PD_DEBUG !== true ) {
								if( !term_exists( trim( $category->contents[4] ), $term_taxonomy, $category->category_4 ) ) {
									$term = wp_insert_term( htmlspecialchars( trim( $category->contents[4] ) ), $term_taxonomy, array( 'parent' => $category->category_4 ) );
									$count++;
								}
							}
						}
						if( $include_log ) {
							if( isset( $term ) && $term )
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Created Category: %s', 'woocommerce-product-importer' ), trim( $category->contents[4] ) );
							else
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Duplicate of Category detected: %s', 'woocommerce-product-importer' ), trim( $category->contents[4] ) );
						}
						break;

					// Category > Category > Category > Category > Category > Category
					case '5':
						if( $include_log )
							$import->log .= "<br />>>> " . sprintf( __( 'Category: %s > %s > %s > %s > %s > %s', 'woocommerce-product-importer' ), trim( $category->contents[0] ), trim( $category->contents[1] ), trim( $category->contents[2] ), trim( $category->contents[3] ), trim( $category->contents[4] ), trim( $category->contents[5] ) );
						$category->category_1 = get_term_by( 'name', htmlspecialchars( trim( $category->contents[0] ) ), $term_taxonomy );
						if( $category->category_1 ) {
							$category_2_sql = $wpdb->prepare( "SELECT terms.`term_id` FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`parent` = %d AND terms.`name` = %s AND term_taxonomy.`taxonomy` = %s LIMIT 1", $category->category_1->term_id, htmlspecialchars( trim( $category->contents[1] ) ), $term_taxonomy );
							$category->category_2 = $wpdb->get_var( $category_2_sql );
						}
						if( $category->category_1 && $category->category_2 ) {
							$category_3_sql = $wpdb->prepare( "SELECT terms.`term_id` FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`parent` = %d AND terms.`name` = %s AND term_taxonomy.`taxonomy` = %s LIMIT 1", $category->category_2, htmlspecialchars( trim( $category->contents[2] ) ), $term_taxonomy );
							$category->category_3 = $wpdb->get_var( $category_3_sql );
							$wpdb->flush();
						}
						if( $category->category_2 && $category->category_3 ) {
							$category_4_sql = $wpdb->prepare( "SELECT terms.`term_id` FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`parent` = %d AND terms.`name` = %s AND term_taxonomy.`taxonomy` = %s LIMIT 1", $category->category_3, htmlspecialchars( trim( $category->contents[3] ) ), $term_taxonomy );
							$category->category_4 = $wpdb->get_var( $category_4_sql );
							$wpdb->flush();
						}
						if( $category->category_3 && $category->category_4 ) {
							$category_5_sql = $wpdb->prepare( "SELECT terms.`term_id` FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`parent` = %d AND terms.`name` = %s AND term_taxonomy.`taxonomy` = %s LIMIT 1", $category->category_4, htmlspecialchars( trim( $category->contents[4] ) ), $term_taxonomy );
							$category->category_5 = $wpdb->get_var( $category_5_sql );
							$wpdb->flush();
						}
						if( $category->category_1 && $category->category_2 && $category->category_3 && $category->category_4 && $category->category_5 ) {
							if( WOO_PD_DEBUG !== true ) {
								if( !term_exists( trim( $category->contents[5] ), $term_taxonomy, $category->category_5 ) ) {
									$term = wp_insert_term( htmlspecialchars( trim( $category->contents[5] ) ), $term_taxonomy, array( 'parent' => $category->category_5 ) );
									$count++;
								}
							}
						}
						if( $include_log ) {
							if( isset( $term ) && $term )
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Created Category: %s', 'woocommerce-product-importer' ), trim( $category->contents[5] ) );
							else
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Duplicate of Category detected: %s', 'woocommerce-product-importer' ), trim( $category->contents[5] ) );
						}
						break;

					default:
						$skipped_category_size = $j;
						if( $include_log ) {
							$import->log .= "<br />>>> " . sprintf( __( 'Category: %s', 'woocommerce-product-importer' ), trim( $category->contents[$j] ) );
							for( $k = 0; $k <= $skipped_category_size; $k++ )
								$import->log .= trim( $category->contents[$k] ) . ' > ';
							$import->log = substr( $import->log, 0, -3 );
							$import->log .= "<br />>>>>>> " . sprintf( __( 'Skipped Category: %s', 'woocommerce-product-importer' ), trim( $category->contents[$j] ) );
						}
						break;

				}
				unset( $category, $term );
			}
		}
		unset( $size );
		if( $count )
			$import->log .= "<br />" . __( 'Categories have been generated', 'woocommerce-product-importer' );
		else
			$import->log .= "<br />" . __( 'No Categories were generated', 'woocommerce-product-importer' );
	} else {
		$import->log .= "<br />" . __( 'No Categories were provided', 'woocommerce-product-importer' );
	}

}

function woo_pd_process_categories() {

	global $wpdb, $product, $import;

	// Category association
	$product->category_term_id = array();
	$pid_categories = array();
	if( isset( $product->category ) ) {

		if( strpos( $product->category, $import->category_separator ) ) {
			$pid_categories_explode = explode( $import->category_separator, $product->category );
			$size = count( $pid_categories_explode );
			for( $i = 0; $i < $size; $i++ )
				$pid_categories[] = $pid_categories_explode[$i];
			unset( $pid_categories_explode, $size );
		} else {
			$pid_categories[] = trim( $product->category );
		}

		// Check if we are nuking Category associations for this Product
		if( $product->category == '-' ) {
			$product->category_term_id[] = '-';
			return;
		}

		$term_taxonomy = 'product_cat';
		// Get a list of Product Categories
		$db_categories_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`taxonomy` = %s", $term_taxonomy );
		$db_categories = $wpdb->get_results( $db_categories_sql );
		$wpdb->flush();
		foreach( $pid_categories as $pid_category ) {
			$pid_categorydata = explode( $import->parent_child_delimiter, $pid_category );
			// Scan Categories for empty values before proceeding
			$pid_categorydata_size = count( $pid_categorydata );
			for( $k = 0; $k < $pid_categorydata_size; $k++ ) {
				if( strlen( utf8_decode( $pid_categorydata[$k] ) ) == false ) {
					unset( $pid_categorydata[$k] );
					$pid_categorydata_size--;
				}
			}
			for( $k = 0; $k < $pid_categorydata_size; $k++ ) {
				if( $import->special_category_assignment )
					$k = ( $pid_categorydata_size - 1 );
				switch( $k ) {

					// Category
					case '0':
						foreach( $db_categories as $db_category ) {
							if( ( htmlspecialchars( $pid_categorydata[$k] ) == $db_category->name ) && ( $db_category->category_parent == '0' ) ) {
								$product->category_term_id[] = $db_category->term_id;
								break;
							}
						}
						break;

					// Category > Category
					case '1':
						$pid_1_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s LIMIT 1", trim( $pid_categorydata[$k-1] ) );
						$pid_1 = $wpdb->get_row( $pid_1_sql );
						$wpdb->flush();
						if( is_object( $pid_1 ) ) {
							foreach( $db_categories as $db_category ) {
								if( $pid_1->term_id == $db_category->category_parent ) {
									if( htmlspecialchars( trim( $pid_categorydata[$k] ) ) == $db_category->name ) {
										$product->category_term_id[] = $db_category->term_id;
										break;
									}
								}
							}
						}
						break;

					// Category > Category > Category
					case '2':
						$pid_1_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s LIMIT 1", trim( $pid_categorydata[$k-2] ) );
						$pid_1 = $wpdb->get_row( $pid_1_sql );
						$wpdb->flush();
						if( is_object( $pid_1 ) ) {
							$pid_2_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s AND term_taxonomy.`parent` = %d LIMIT 1", trim( $pid_categorydata[$k-1] ), $pid_1->term_id );
							$pid_2 = $wpdb->get_row( $pid_2_sql );
							$wpdb->flush();
							if( is_object( $pid_2 ) ) {
								foreach( $db_categories as $db_category ) {
									if( $pid_2->term_id == $db_category->category_parent ) {
										if( htmlspecialchars( trim( $pid_categorydata[$k] ) ) == $db_category->name ) {
											$product->category_term_id[] = $db_category->term_id;
											break;
										}
									}
								}
							}
						}
						break;

					// Category > Category > Category > Category
					case '3':
						$pid_1_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s LIMIT 1", trim( $pid_categorydata[$k-3] ) );
						$pid_1 = $wpdb->get_row( $pid_1_sql );
						$wpdb->flush();
						if( is_object( $pid_1 ) ) {
							$pid_2_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s AND term_taxonomy.`parent` = %d LIMIT 1", trim( $pid_categorydata[$k-2] ), $pid_1->term_id );
							$pid_2 = $wpdb->get_row( $pid_2_sql );
							$wpdb->flush();
							if( is_object( $pid_2 ) ) {
								$pid_3_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s AND term_taxonomy.`parent` = %d LIMIT 1", trim( $pid_categorydata[$k-1] ), $pid_2->term_id );
								$pid_3 = $wpdb->get_row( $pid_3_sql );
								$wpdb->flush();
								if( is_object( $pid_3 ) ) {
									foreach( $db_categories as $db_category ) {
										if( $pid_3->term_id == $db_category->category_parent ) {
											if( htmlspecialchars( trim( $pid_categorydata[$k] ) ) == $db_category->name ) {
												$product->category_term_id[] = $db_category->term_id;
												break;
											}
										}
									}
								}
							}
						}
						break;

					// Category > Category > Category > Category > Category
					case '4':
						$pid_1_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s LIMIT 1", trim( $pid_categorydata[$k-4] ) );
						$pid_1 = $wpdb->get_row( $pid_1_sql );
						$wpdb->flush();
						if( is_object( $pid_1 ) ) {
							$pid_2_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s AND term_taxonomy.`parent` = %d LIMIT 1", trim( $pid_categorydata[$k-3] ), $pid_1->term_id );
							$pid_2 = $wpdb->get_row( $pid_2_sql );
							$wpdb->flush();
							if( is_object( $pid_2 ) ) {
								$pid_3_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s AND term_taxonomy.`parent` = %d LIMIT 1", trim( $pid_categorydata[$k-2] ), $pid_2->term_id );
								$pid_3 = $wpdb->get_row( $pid_3_sql );
								$wpdb->flush();
								if( is_object( $pid_3 ) ) {
									$pid_4_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s AND term_taxonomy.`parent` = %d LIMIT 1", trim( $pid_categorydata[$k-1] ), $pid_3->term_id );
									$pid_4 = $wpdb->get_row( $pid_4_sql );
									$wpdb->flush();
									if( is_object( $pid_4 ) ) {
										foreach( $db_categories as $db_category ) {
											if( $pid_4->term_id == $db_category->category_parent ) {
												if( htmlspecialchars( trim( $pid_categorydata[$k] ) ) == $db_category->name ) {
													$product->category_term_id[] = $db_category->term_id;
													break;
												}
											}
										}
									}
								}
							}
						}
						break;

					// Category > Category > Category > Category > Category > Category
					case '5':
						$pid_1_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s LIMIT 1", trim( $pid_categorydata[$k-5] ) );
						$pid_1 = $wpdb->get_row( $pid_1_sql );
						$wpdb->flush();
						if( is_object( $pid_1 ) ) {
							$pid_2_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s AND term_taxonomy.`parent` = %d LIMIT 1", trim( $pid_categorydata[$k-4] ), $pid_1->term_id );
							$pid_2 = $wpdb->get_row( $pid_2_sql );
							$wpdb->flush();
							if( is_object( $pid_2 ) ) {
								$pid_3_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s AND term_taxonomy.`parent` = %d LIMIT 1", trim( $pid_categorydata[$k-3] ), $pid_2->term_id );
								$pid_3 = $wpdb->get_row( $pid_3_sql );
								$wpdb->flush();
								if( is_object( $pid_3 ) ) {
									$pid_4_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s AND term_taxonomy.`parent` = %d LIMIT 1", trim( $pid_categorydata[$k-2] ), $pid_3->term_id );
									$pid_4 = $wpdb->get_row( $pid_4_sql );
									$wpdb->flush();
									if( is_object( $pid_4 ) ) {
										$pid_5_sql = $wpdb->prepare( "SELECT terms.`term_id`, terms.`name`, term_taxonomy.`parent` as category_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s AND term_taxonomy.`parent` = %d LIMIT 1", trim( $pid_categorydata[$k-1] ), $pid_4->term_id );
										$pid_5 = $wpdb->get_row( $pid_5_sql );
										$wpdb->flush();
										if( is_object( $pid_5 ) ) {
											foreach( $db_categories as $db_category ) {
												if( $pid_5->term_id == $db_category->category_parent ) {
													if( htmlspecialchars( trim( $pid_categorydata[$k] ) ) == $db_category->name ) {
														$product->category_term_id[] = $db_category->term_id;
														break;
													}
												}
											}
										}
									}
								}
							}
						}
						break;

				}
			}
		}
	}

}
?>