<?php
include_once( WOO_PD_PATH . 'includes/product.php' );
include_once( WOO_PD_PATH . 'includes/product-new.php' );
include_once( WOO_PD_PATH . 'includes/product-merge.php' );
include_once( WOO_PD_PATH . 'includes/product-extend.php' );
include_once( WOO_PD_PATH . 'includes/category.php' );
include_once( WOO_PD_PATH . 'includes/tag.php' );
include_once( WOO_PD_PATH . 'includes/shipping_class.php' );
include_once( WOO_PD_PATH . 'includes/brand.php' );
include_once( WOO_PD_PATH . 'includes/brand-extend.php' );
include_once( WOO_PD_PATH . 'includes/product_vendor.php' );

if( is_admin() ) {

	/* Start of: WordPress Administration */

	include_once( WOO_PD_PATH . 'includes/admin.php' );

	function woo_pd_import_init() {

		global $import, $wpdb, $woocommerce;

		$troubleshooting_url = 'http://www.visser.com.au/documentation/product-importer-deluxe/usage/';

		// Process any pre-import notice confirmations
		$action = ( function_exists( 'woo_get_action' ) ? woo_get_action() : false );
		switch( $action ) {

			// Prompt on Import screen when memory cannot be increased
			case 'dismiss_memory_prompt':
				// We need to verify the nonce.
				if( !empty( $_GET ) && check_admin_referer( 'woo_pd_dismiss_memory_prompt' ) ) {
					// Remember that we've dismissed this notice
					woo_pd_update_option( 'dismiss_memory_prompt', 1 );
					$url = add_query_arg( array( 'action' => null, '_wpnonce' => null ) );
					wp_redirect( $url );
					exit();
				}
				break;

			// Prompt on Import screen when insufficient memory (less than 64M is allocated)
			case 'dismiss_minimum_memory_prompt':
				// We need to verify the nonce.
				if( !empty( $_GET ) && check_admin_referer( 'woo_pd_dismiss_minimum_memory_prompt' ) ) {
					// Remember that we've dismissed this notice
					woo_pd_update_option( 'dismiss_minimum_memory_prompt', 1 );
					$url = add_query_arg( array( 'action' => null, '_wpnonce' => null ) );
					wp_redirect( $url );
					exit();
				}
				break;

			// Prompt on Import screen when PHP Safe Mode is detected
			case 'dismiss_safe_mode_prompt':
				// We need to verify the nonce.
				if( !empty( $_GET ) && check_admin_referer( 'woo_pd_dismiss_safe_mode_prompt' ) ) {
					// Remember that we've dismissed this notice
					woo_pd_update_option( 'dismiss_safe_mode_prompt', 1 );
					$url = add_query_arg( array( 'action' => null, '_wpnonce' => null ) );
					wp_redirect( $url );
					exit();
				}
				break;

			// Prompt on Import screen when mb_convert() is not available
			case 'dismiss_mb_convert_prompt':
				// We need to verify the nonce.
				if( !empty( $_GET ) && check_admin_referer( 'woo_pd_dismiss_mb_convert_prompt' ) ) {
					// Remember that we've dismissed this notice
					woo_pd_update_option( 'dismiss_mb_convert_prompt', 1 );
					$url = add_query_arg( array( 'action' => null, '_wpnonce' => null ) );
					wp_redirect( $url );
					exit();
				}
				break;

			// Prompt on Import screen when mb_list() is not available
			case 'dismiss_mb_list_prompt':
				// We need to verify the nonce.
				if( !empty( $_GET ) && check_admin_referer( 'woo_pd_dismiss_mb_list_prompt' ) ) {
					// Remember that we've dismissed this notice
					woo_pd_update_option( 'dismiss_mb_list_prompt', 1 );
					$url = add_query_arg( array( 'action' => null, '_wpnonce' => null ) );
					wp_redirect( $url );
					exit();
				}
				break;

			// Prompt on Import screen when str_getcsv() is not available
			case 'dismiss_str_getcsv_prompt':
				// We need to verify the nonce.
				if( !empty( $_GET ) && check_admin_referer( 'woo_pd_dismiss_str_getcsv_prompt' ) ) {
					// Remember that we've dismissed this notice
					woo_pd_update_option( 'dismiss_str_getcsv_prompt', 1 );
					$url = add_query_arg( array( 'action' => null, '_wpnonce' => null ) );
					wp_redirect( $url );
					exit();
				}
				break;

			// Prompt on Import screen if W3 Total Cache is installed
			case 'dismiss_w3tc_prompt':
				// We need to verify the nonce.
				if( !empty( $_GET ) && check_admin_referer( 'woo_ce_dismiss_w3tc_prompt' ) ) {
					// Remember that we've dismissed this notice
					woo_pd_update_option( 'dismiss_w3tc_prompt', 1 );
					$url = add_query_arg( array( 'action' => null, '_wpnonce' => null ) );
					wp_redirect( $url );
					exit();
				}
				break;

			// Prompt on Import screen to install Store Exporter
			case 'dismiss_exporter_prompt':
				// We need to verify the nonce.
				if( !empty( $_GET ) && check_admin_referer( 'woo_pd_dismiss_exporter_prompt' ) ) {
					// Remember that we've dismissed this notice
					woo_pd_update_option( 'dismiss_exporter_prompt', 1 );
					$url = add_query_arg( array( 'action' => null, '_wpnonce' => null ) );
					wp_redirect( $url );
					exit();
				}
				break;

			// Prompt on Import screen where encoding does not match
			case 'dismiss_encoding_prompt':
				// We need to verify the nonce.
				if( !empty( $_GET ) && check_admin_referer( 'woo_pd_dismiss_encoding_prompt' ) ) {
					// Remember that we've dismissed this notice
					woo_pd_update_option( 'dismiss_encoding_prompt', 1 );
					$url = add_query_arg( array( 'action' => null, '_wpnonce' => null ) );
					wp_redirect( $url );
					exit();
				}
				break;

			// Empty the CSV option
			case 'dismiss_resume_prompt':
				// We need to verify the nonce.
				if( !empty( $_GET ) && check_admin_referer( 'woo_pd_dismiss_resume_prompt' ) ) {
					// Remember that we've dismissed this notice
					woo_pd_update_option( 'csv', '' );
					$url = add_query_arg( array( 'action' => null, '_wpnonce' => null ) );
					wp_redirect( $url );
					exit();
				}
				break;

			case 'refresh_module_counts':
				// We need to verify the nonce.
				if( !empty( $_GET ) && check_admin_referer( 'woo_pd_refresh_module_counts' ) ) {
					// Delete the existing count Transients
					delete_transient( WOO_PD_PREFIX . '_modules_active' );
					delete_transient( WOO_PD_PREFIX . '_modules_all_count' );
					delete_transient( WOO_PD_PREFIX . '_modules_active_count' );
					delete_transient( WOO_PD_PREFIX . '_modules_inactive_count' );
					// Refresh the count Transients
					woo_pd_modules_list();
					$url = add_query_arg( array( 'action' => null, '_wpnonce' => null ) );
					wp_redirect( $url );
					exit();
				}
				break;

			// Save skip overview preference
			case 'skip_overview':
				// We need to verify the nonce.
				if( !empty( $_POST ) && check_admin_referer( 'skip_overview', 'woo_pd_skip_overview' ) ) {
					$skip_overview = false;
					if( isset( $_POST['skip_overview'] ) )
						$skip_overview = 1;
					// Remember that we've dismissed this notice
					woo_pd_update_option( 'skip_overview', $skip_overview );

					if( $skip_overview == 1 ) {
						$url = add_query_arg( array( 'tab' => 'import', '_wpnonce' => null ) );
						wp_redirect( $url );
						exit();
					}
				}
				break;

			// Remove import from Past Imports list
			case 'remove_past_import':
				// We need to verify the nonce.
				if( !empty( $_GET ) && check_admin_referer( 'woo_pd_remove_past_import' ) ) {
					$file_id = ( isset( $_GET['file_id'] ) ? absint( $_GET['file_id'] ) : 0 );
					$past_imports = maybe_unserialize( woo_pd_get_option( 'past_imports' ) );
					if( !empty( $past_imports ) ) {
						if( isset( $past_imports[$file_id]['filename'] ) ) {
							$file = $past_imports[$file_id]['filename'];
							$upload_dir = wp_upload_dir();
							if( file_exists( $file ) ) {
								unlink( $file );
								$message = sprintf( __( '%s has been removed from Past Imports.', 'woocommerce-product-importer' ), '<em>' . basename( $file ) . '</em>' );
								woo_pd_admin_notice( $message );
							}
						}
						unset( $past_imports[$file_id] );
						woo_pd_update_option( 'past_imports', $past_imports );
					}
				}
				break;

		}

		// Notice that we cannot increase memory limits
		if( !ini_get( 'memory_limit' ) && !woo_pd_get_option( 'dismiss_memory_prompt', false ) ) {
			$message = sprintf( __( 'Your WordPress site does not allow changes to allocated memory limits, because of this memory-related errors are likely to be encountered for large imports. %s', 'woocommerce-product-importer' ), '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
			$dismiss_url = add_query_arg( array( 'page' => 'woo_pd', 'action' => 'dismiss_memory_prompt', '_wpnonce' => wp_create_nonce( 'woo_pd_dismiss_memory_prompt' ) ), 'admin.php' );
			$dismiss_link = '<span style="float:right;"><a href="' . $dismiss_url . '">' . __( 'Dismiss', 'woocommerce-product-importer' ) . '</a></span>';
			woo_pd_admin_notice( $message . $dismiss_link, 'error' );
		}

		// Notice to increase WordPress memory allocation
		if( !woo_pd_get_option( 'dismiss_minimum_memory_prompt', 0 ) ) {
			$memory_limit = absint( ini_get( 'memory_limit' ) );
			$minimum_memory_limit = 64;
			if( $memory_limit < $minimum_memory_limit ) {
				$message = sprintf( __( 'We recommend setting memory to at least %dMB prior to importing, your site has only %dMB allocated to it. See <a href="%s" target="_blank">Increasing memory allocated to PHP</a> for more information.', 'woocommerce-product-importer' ), $minimum_memory_limit, $memory_limit, $troubleshooting_url );
				$dismiss_url = add_query_arg( array( 'page' => 'woo_pd', 'action' => 'dismiss_minimum_memory_prompt', '_wpnonce' => wp_create_nonce( 'woo_pd_dismiss_minimum_memory_prompt' ) ), 'admin.php' );
				$dismiss_link = '<span style="float:right;"><a href="' . $dismiss_url . '">' . __( 'Dismiss', 'woocommerce-product-importer' ) . '</a></span>';
				woo_pd_admin_notice( $message . $dismiss_link, 'notice' );
			}
		}

		// Notice that PHP safe mode is active
		if( ini_get( 'safe_mode' ) && !woo_pd_get_option( 'dismiss_safe_mode_prompt', false ) ) {
			$message = sprintf( __( 'Your WordPress site appears to be running PHP in \'Safe Mode\', because of this the script timeout cannot be adjusted. This will limit the importing of large catalogues. %s', 'woocommerce-product-importer' ), '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
			$dismiss_url = add_query_arg( array( 'page' => 'woo_pd', 'action' => 'dismiss_safe_mode_prompt', '_wpnonce' => wp_create_nonce( 'woo_pd_dismiss_safe_mode_prompt' ) ), 'admin.php' );
			$dismiss_link = '<span style="float:right;"><a href="' . $dismiss_url . '">' . __( 'Dismiss', 'woocommerce-product-importer' ) . '</a></span>';
			woo_pd_admin_notice( $message . $dismiss_link, 'notice' );
		}

		// Notice that mb_convert_encoding() does not exist
		if( !function_exists( 'mb_convert_encoding' ) && !woo_pd_get_option( 'dismiss_mb_convert_prompt', false ) ) {
			$message = sprintf( __( 'The function mb_convert_encoding() requires the mb_strings extension to be enabled, multi-lingual import support has been disabled. %s', 'woocommerce-product-importer' ), '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
			$dismiss_url = add_query_arg( array( 'page' => 'woo_pd', 'action' => 'dismiss_mb_convert_prompt', '_wpnonce' => wp_create_nonce( 'woo_pd_dismiss_mb_convert_prompt' ) ), 'admin.php' );
			$dismiss_link = '<span style="float:right;"><a href="' . $dismiss_url . '">' . __( 'Dismiss', 'woocommerce-product-importer' ) . '</a></span>';
			woo_pd_admin_notice( $message . $dismiss_link, 'error' );
		}

		// Notice that mb_list_encodings() does not exist
		if( !function_exists( 'mb_list_encodings' ) && !woo_pd_get_option( 'dismiss_mb_list_prompt', false ) ) {
			$message = sprintf( __( 'The function mb_list_encodings() requires the mb_strings extension to be enabled, if you are importing non-English and/or special characters the WordPress Transients we use during import will be corrupted and cause the import to fail.', 'woocommerce-product-importer' ), '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
			$dismiss_url = add_query_arg( array( 'page' => 'woo_pd', 'action' => 'dismiss_mb_list_prompt', '_wpnonce' => wp_create_nonce( 'woo_pd_dismiss_mb_list_prompt' ) ), 'admin.php' );
			$dismiss_link = '<span style="float:right;"><a href="' . $dismiss_url . '">' . __( 'Dismiss', 'woocommerce-product-importer' ) . '</a></span>';
			woo_pd_admin_notice( $message . $dismiss_link, 'error' );
		}

		// Notice that PHP version does not include required dismiss-str_getcsv()
		if( phpversion() < '5.3.0' && !woo_pd_get_option( 'dismiss_str_getcsv_prompt', false ) ) {
			$message = sprintf( __( 'Your WordPress site is running an older version of PHP which does not support the function str_getcsv(), a substitute will be used but it\'s still advised that you update PHP on your hosting server. %s', 'woocommerce-product-importer' ), '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
			$dismiss_url = add_query_arg( array( 'page' => 'woo_pd', 'action' => 'dismiss_str_getcsv_prompt', '_wpnonce' => wp_create_nonce( 'woo_pd_dismiss_str_getcsv_prompt' ) ), 'admin.php' );
			$dismiss_link = '<span style="float:right;"><a href="' . $dismiss_url . '">' . __( 'Dismiss', 'woocommerce-product-importer' ) . '</a></span>';
			woo_pd_admin_notice( $message . $dismiss_link, 'error' );
		}

		// Display notice if W3 Total Cache is installed
		if( defined( 'W3TC' ) && !woo_pd_get_option( 'dismiss_w3tc_prompt', false ) ) {
			// Check if Object Caching is turned on
			$dismiss_url = esc_url( add_query_arg( array( 'action' => 'dismiss_w3tc_prompt', '_wpnonce' => wp_create_nonce( 'woo_pd_dismiss_w3tc_prompt' ) ) ) );
			if( defined( 'W3TC_ADDIN_FILE_OBJECT_CACHE' ) && file_exists( W3TC_ADDIN_FILE_OBJECT_CACHE ) ) {
				$message = '<span style="float:right;"><a href="' . $dismiss_url . '">' . __( 'Dismiss', 'woocommerce-product-importer' ) . '</a></span>' . __( 'It looks like you have W3 Total Cache activated, the Object Caching feature of this Plugin is known to conflict with our import engine. Please disable Object Caching during imports from Performance > General Settings > Object Cache > Enable Object Cache.', 'woocommerce-product-importer' );
				woo_pd_admin_notice_html( $message, 'error' );
			} else {
				$message = '<span style="float:right;"><a href="' . $dismiss_url . '">' . __( 'Dismiss', 'woocommerce-product-importer' ) . '</a></span>' . __( 'It looks like you have W3 Total Cache activated, just a heads up that the Object Caching feature of W3 Total Cache when enabled may conflict with our import engine.', 'woocommerce-product-importer' );
				woo_pd_admin_notice_html( $message, 'notice' );
			}
		}

		// Notice to install/open Store Exporter
		if( !woo_pd_get_option( 'dismiss_exporter_prompt', false ) ) {
			$woo_ce_message = ' ';
			if( function_exists( 'woo_ce_export_dataset' ) ) {
				$woo_ce_url = add_query_arg( 'page', 'woo_ce', 'admin.php' );
				if( defined( 'WOO_CD_PREFIX' ) )
					$woo_ce_message .= sprintf( __( 'Jump over to <a href="%s">Store Exporter Deluxe</a>.', 'woocommerce-product-importer' ), $woo_ce_url );
				else
					$woo_ce_message .= sprintf( __( 'Jump over to <a href="%s">Store Exporter</a>.', 'woocommerce-product-importer' ), $woo_ce_url );
			} else {
				$woo_ce_url = 'http://www.visser.com.au/woocommerce/plugins/exporter/';
				$woo_ce_message .= sprintf( __( 'Install our free <a href="%s" target="_blank">Store Exporter</a> extension.', 'woocommerce-product-importer' ), $woo_ce_url );
			}
			$message = __( 'Would you like to export an initial CSV file of your existing WooCommerce Products which you can adjust and re-import with Product Importer Deluxe?', 'woocommerce-product-importer' ) . $woo_ce_message;
			$dismiss_url = add_query_arg( array( 'page' => 'woo_pd', 'action' => 'dismiss_exporter_prompt', '_wpnonce' => wp_create_nonce( 'woo_pd_dismiss_exporter_prompt' ) ), 'admin.php' );
			$dismiss_link = sprintf( '<span style="float:right;"><a href="%s">%s</a></span>', $dismiss_url, __( 'Dismiss', 'woocommerce-product-importer' ) );
			woo_pd_admin_notice( $message . $dismiss_link, 'notice' );
		}

		$wpdb->hide_errors();

		$timeout = 0;
		if( isset( $_POST['timeout'] ) )
			$timeout = sanitize_text_field( $_POST['timeout'] );

		if( !ini_get( 'safe_mode' ) )
			@set_time_limit( $timeout );

		@ini_set( 'memory_limit', WP_MAX_MEMORY_LIMIT );

		// Prevent header sent errors for the import
		@ob_start();

		$action = ( function_exists( 'woo_get_action' ) ? woo_get_action() : false );
		$upload_dir = wp_upload_dir();
		switch( $action ) {

			// Save changes on Settings screen
			case 'save-settings':
				woo_pd_update_option( 'delete_file', ( isset( $_POST['delete_file'] ) ? absint( $_POST['delete_file'] ) : 0 ) );
				woo_pd_update_option( 'encoding', ( isset( $_POST['encoding'] ) ? sanitize_text_field( $_POST['encoding'] ) : 'UTF-8' ) );
				woo_pd_update_option( 'timeout', ( isset( $_POST['timeout'] ) ? absint( $_POST['timeout'] ) : 0 ) );
				woo_pd_update_option( 'delimiter', ( isset( $_POST['delimiter'] ) ? sanitize_text_field( $_POST['delimiter'] ) : ',' ) );
				woo_pd_update_option( 'category_separator', ( isset( $_POST['category_separator'] ) ? sanitize_text_field( $_POST['category_separator'] ) : '|' ) );
				woo_pd_update_option( 'parent_child_delimiter', ( isset( $_POST['parent_child_delimiter'] ) ? sanitize_text_field( $_POST['parent_child_delimiter'] ) : '>' ) );
				// Display additional notice if Enabled CRON is enabled/disabled
				if( woo_pd_get_option( 'enable_cron', 0 ) <> absint( $_POST['enable_cron'] ) ) {
					$message = sprintf( __( 'CRON support has been %s.', 'woocommerce-product-importer' ), ( ( absint( $_POST['enable_cron'] ) == 1 ) ? __( 'enabled', 'woocommerce-product-importer' ) : __( 'disabled', 'woocommerce-product-importer' ) ) );
					woo_pd_admin_notice( $message );
				}
				woo_pd_update_option( 'enable_cron', absint( $_POST['enable_cron'] ) );
				woo_pd_update_option( 'secret_key', sanitize_text_field( (string)$_POST['secret_key'] ) );

				$message = __( 'Settings saved.', 'woocommerce-product-importer' );
				woo_pd_admin_notice( $message );
				break;

			// The opening Import screen
			default:
				$import = new stdClass;
				$import->cron = false;
				$import->upload_method = woo_pd_get_option( 'upload_method', 'upload' );
				$import->delimiter = woo_pd_get_option( 'delimiter', ',' );
				if( $import->delimiter == "\t" )
					$import->delimiter = 'TAB';
				if( $import->delimiter == '' || $import->delimiter == false )
					$import->delimiter = ',';
				$import->category_separator = woo_pd_get_option( 'category_separator', '|' );
				$import->parent_child_delimiter = woo_pd_get_option( 'parent_child_delimiter', '>' );
				$import->delete_file = woo_pd_get_option( 'delete_file', 0 );
				$import->encoding = woo_pd_get_option( 'encoding', 'UTF-8' );

				// Override to use Options instead of Transients to resolve object caching conflict
				if( apply_filters( 'woo_pd_override_temp_storage_method', false ) )
					delete_option( WOO_PD_PREFIX . '_import' );
				else
					delete_transient( WOO_PD_PREFIX . '_import' );

				// Display notice if an existing import can be recovered/resumed
				if( $file = woo_pd_get_option( 'csv' ) ) {
					if( file_exists( $file ) ) {
						$message = sprintf( __( 'You can resume your existing import of <code title="%s">%s</code> by <a href="%s">clicking here</a>.', 'woocommerce-product-importer' ), esc_attr( $file ), basename( $file ), add_query_arg( array( 'page' => 'woo_pd', 'action' => 'upload' ), 'admin.php' ) );
						$dismiss_url = add_query_arg( array( 'page' => 'woo_pd', 'action' => 'dismiss_resume_prompt', '_wpnonce' => wp_create_nonce( 'woo_pd_dismiss_resume_prompt' ) ), 'admin.php' );
						$dismiss_link = '<span style="float:right;"><a href="' . $dismiss_url . '">' . __( 'Dismiss', 'woocommerce-product-importer' ) . '</a></span>';
						woo_pd_admin_notice( $message . $dismiss_link );
					}
				}
				break;

			// The options screen
			case 'upload':
				$import = new stdClass;
				$import->cron = false;
				$import->cancel_import = false;
				$import->skip_first = false;
				$import->skip_category = absint( woo_pd_get_option( 'skip_category', 0 ) );
				$import->skip_product_tag = absint( woo_pd_get_option( 'skip_tag', 0 ) );
				$import->skip_shipping_class = absint( woo_pd_get_option( 'skip_shipping_class', 0 ) );
				$import->skip_brand = absint( woo_pd_get_option( 'skip_brand', 0 ) );
				$import->upload_method = ( isset( $_POST['upload_method'] ) ? sanitize_text_field( $_POST['upload_method'] ) : '' );
				$import->import_method = sanitize_text_field( woo_pd_get_option( 'import_method', 'merge' ) );
				$import->advanced_log = absint( woo_pd_get_option( 'advanced_log', 1 ) );
				$import->duplicate_image_method = woo_pd_get_option( 'duplicate_image_method', 'new' );
				$import->delimiter = ( isset( $_POST['delimiter'] ) ? substr( $_POST['delimiter'], 0, 3 ) : woo_pd_get_option( 'delimiter', ',' ) );
				if( $import->delimiter == 'TAB' )
					$import->delimiter = "\t";
				$import->category_separator = ( isset( $_POST['category_separator'] ) ? sanitize_text_field( $_POST['category_separator'] ) : '|' );
				$import->parent_child_delimiter = ( isset( $_POST['parent_child_delimiter'] ) ? sanitize_text_field( $_POST['parent_child_delimiter'] ) : '>' );
				$import->delete_file = absint( woo_pd_get_option( 'delete_file', 0 ) );
				$import->encoding = woo_pd_get_option( 'encoding', 'UTF-8' );
				$import->special_category_assignment = absint( woo_pd_get_option( 'special_category_assignment', 0 ) );
				$import->force_refresh_images = absint( woo_pd_get_option( 'force_refresh_images', 0 ) );
				$import->timeout = absint( woo_pd_get_option( 'timeout', 600 ) );
				$import->upload_mb = wp_max_upload_size();
				woo_pd_update_option( 'delimiter', $import->delimiter );
				woo_pd_update_option( 'category_separator', $import->category_separator );
				woo_pd_update_option( 'parent_child_delimiter', $import->parent_child_delimiter );

				woo_pd_upload_directories();

				switch( $import->upload_method ) {

					// Capture the CSV file uploaded
					case 'upload':
						if( !empty( $_FILES['csv_file']['name'] ) ) {
							$file = $_FILES['csv_file'];
						} else if( isset( $_POST['past_import'] ) ) {
							$import->upload_method = 'past_import';
							$past_import = $_POST['past_import'];
							if( file_exists( $past_import ) ) {
								$file = woo_pd_load_csv_file( $past_import );
							} else {
								$import->cancel_import = true;
								$message = sprintf( __( 'No past import of <code>%s</code> could be found. %s', 'woocommerce-product-importer' ), basename( $past_import ), '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
								woo_pd_admin_notice( $message, 'error' );
							}
						}
						break;

					// Capture the CSV relative file path provided
					case 'file_path':
						$file_path_relative = ( isset( $_POST['csv_file_path'] ) ? sanitize_text_field( $_POST['csv_file_path'] ) : false );
						if( file_exists( sprintf( '%s/%s', $upload_dir['basedir'], $file_path_relative ) ) ) {
							$file = woo_pd_load_csv_file( sprintf( '%s/%s', $upload_dir['basedir'], $file_path_relative ) );
						} else {
							$import->cancel_import = true;
							$message = sprintf( __( 'No import file could be found at <code>%s</code>, please check the file path is correct and that WordPress is able to read the file. %s', 'woocommerce-product-importer' ), sprintf( '%s/%s', $upload_dir['basedir'], $file_path_relative ), '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
							woo_pd_admin_notice( $message, 'error' );
						}
						break;

					// Capture the CSV absolute URL provided
					case 'url':
						$file_url = ( isset( $_POST['csv_file_url'] ) ? sanitize_text_field( $_POST['csv_file_url'] ) : false );
						if( woo_pd_http_file_exists( $file_url ) ) {
							$file = woo_pd_download_import_file( $file_url );
						} else {
							$import->cancel_import = true;
							$message = sprintf( __( 'No CSV file could be found at <code>%s</code>, please check the URL is correct and that WordPress is able to read the file. %s', 'woocommerce-product-importer' ), $file_url, '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
							woo_pd_admin_notice( $message, 'error' );
						}
						break;

					// Capture the CSV by connecting to an FTP server
					case 'ftp':
						$file_ftp = ( isset( $_POST['csv_file_ftp'] ) ? array_map( 'sanitize_text_field', $_POST['csv_file_ftp'] ) : false );
						$file = woo_pd_download_import_file( $file_ftp, 'ftp' );
						break;

					// Capture the CSV file stored in Past Imports or by restoring the last import
					default:
						if( woo_pd_get_option( 'csv', '' ) )
							$file = woo_pd_load_csv_file( woo_pd_get_option( 'csv', '' ) );
						break;

				}

				// Return an error with upload notice
				if( !isset( $file ) ) {
					$file = array(
						'name' => '',
						'size' => 0,
						'error' => ( isset( $_FILES['csv_file']['error'] ) ? $_FILES['csv_file']['error'] : 0 )
					);
				}

				// Validation of the import method chosen and uploaded file
				if( $file['size'] == 0 && $import->upload_method == 'past_import' ) {
					// User has uploaded the CSV file but it has expired, usually due to PHP timeout or completed import
					if( $file['size'] == 0 ) {
						$import->cancel_import = true;
						$message = sprintf( __( 'No CSV file could be found at that location. %s', 'woocommerce-product-importer' ), '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
						woo_pd_admin_notice( $message, 'error' );
					}
				} else if( !isset( $file['error'] ) && $file['size'] == 0 ) {
					// User has uploaded the CSV file but it has expired, usually due to PHP timeout or completed import
					$import->cancel_import = true;
					$message = sprintf( __( 'Your CSV file upload has expired, re-upload it from the opening import screen. %s', 'woocommerce-product-importer' ), '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
					woo_pd_admin_notice( $message, 'error' );
				} else if( !empty( $file['name'] ) && woo_pd_strposa( strtolower( $file['name'] ), array( 'csv', 'txt', 'tsv' ) ) === false ) {
					// Not a CSV file or lacking a *.csv file extension
					$import->cancel_import = true;
					$message = sprintf( __( 'Product Importer Deluxe requires a comma or tab-formatted import file with a *.csv, *.txt or *.tsv file extension. If you are sure this file is compatible please change the file extension to a supported file type and re-upload. %s', 'woocommerce-product-importer' ), '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
					woo_pd_admin_notice( $message, 'error' );
				} else if( $file['size'] == 0 && empty( $file['name'] ) && $import->cancel_import == false ) {
					// No file uploaded
					$import->cancel_import = true;
					$message = sprintf( __( 'No CSV file was uploaded. Please select a CSV to upload from the \'Choose File\' dialog or other available upload options. %s', 'woocommerce-product-importer' ), '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
					woo_pd_admin_notice( $message, 'error' );
				} else if( $file['size'] == 0 && $import->cancel_import == false ) {
					$import->cancel_import = true;
					$message = sprintf( __( 'There was an error while uploading your CSV file <em>%s</em> - Error: %s %s', 'woocommerce-product-importer' ), $file['name'], woo_pd_format_upload_error_code( $file['error'] ), '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
					woo_pd_admin_notice( $message, 'error' );
				}

				// Validation of the WordPress site and memory allocation against the uploaded file
				if( $file['size'] > $import->upload_mb ) {
					$import->cancel_import = true;
					$message = sprintf( __( 'The file you\'re importing exceeded the maximum allowed filesize (see Maximum size), increase the file upload limit or import a smaller CSV file. %s', 'woocommerce-product-importer' ), '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
					woo_pd_admin_notice( $message, 'error' );
				}
				// Check if the delimiter is set
				if( $import->delimiter == '' || $import->category_separator == '' ) {
					$import->cancel_import = true;
					$message = sprintf( __( 'You cannot leave the Field delimiter or Product Category separator options under Import Options empty. <a href="%s" target="_blank">Need help?</a>', 'woocommerce-product-importer' ), $troubleshooting_url );
					woo_pd_admin_notice( $message, 'error' );
				}

				if( $import->cancel_import )
					continue;

				if( in_array( $import->upload_method, array( 'upload' ) ) ) {
					$upload = wp_upload_bits( $file['name'], null, file_get_contents( $file['tmp_name'] ) );
					// Fail import if WordPress cannot save the uploaded CSV file
					if( $upload['error'] ) {
						$import->cancel_import = true;
						$message = sprintf( __( 'There was an error while uploading your CSV file, <em>%s</em>. %s', 'woocommerce-product-importer' ), $upload['error'], '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
						woo_pd_admin_notice( $message, 'error' );
					}
					if( !$import->cancel_import ) {
						$import->file = $file;
						woo_pd_update_option( 'csv', $upload['file'] );
					}
				} else {
					$import->file = $file;
				}
				break;

			// The AJAX import engine
			case 'save':

				global $product;

				$import = new stdClass;
				$import->cron = false;
				$import->cancel_import = false;
				$import->log = '';
				$import->delimiter = woo_pd_get_option( 'delimiter', ',' );
				$import->category_separator = woo_pd_get_option( 'category_separator', '|' );
				$import->parent_child_delimiter = woo_pd_get_option( 'parent_child_delimiter', '>' );
				$import->delete_file = woo_pd_get_option( 'delete_file', 0 );
				$import->encoding = woo_pd_get_option( 'encoding', 'UTF-8' );
				$import->skip_first = ( isset( $_POST['skip_first'] ) ? absint( $_POST['skip_first'] ) : false );
				$import->skip_category = ( isset( $_POST['skip_category'] ) ? absint( $_POST['skip_category'] ) : false );
				$import->skip_product_tag = ( isset( $_POST['skip_product_tag'] ) ? absint( $_POST['skip_product_tag'] ) : false );
				$import->skip_shipping_class = ( isset( $_POST['skip_shipping_class'] ) ? absint( $_POST['skip_shipping_class'] ) : false );
				$import->skip_brand = ( isset( $_POST['skip_brand'] ) ? absint( $_POST['skip_brand'] ) : false );
				$import->upload_method = woo_pd_get_option( 'upload_method', 'upload' );
				$import->import_method = ( isset( $_POST['import_method'] ) ? $_POST['import_method'] : 'merge' );
				$import->image_method = ( isset( $_POST['image_method'] ) ? sanitize_text_field( $_POST['image_method'] ) : '' );
				$import->image_filename_method = ( isset( $_POST['image_filename_method'] ) ? sanitize_text_field( $_POST['image_filename_method'] ) : '' );
				$import->duplicate_image_method = ( isset( $_POST['duplicate_image_method'] ) ? sanitize_text_field( $_POST['duplicate_image_method'] ) : '' );
				$import->special_category_assignment = ( isset( $_POST['special_category_assignment'] ) ? 1 : 0 );
				$import->force_refresh_images = ( isset( $_POST['force_refresh_images'] ) ? 1 : 0 );
				$import->advanced_log = ( isset( $_POST['advanced_log'] ) ? 1 : 0 );
				// Save the import options
				woo_pd_update_option( 'skip_first', $import->skip_first );
				woo_pd_update_option( 'skip_category', $import->skip_category );
				woo_pd_update_option( 'skip_tag', $import->skip_product_tag );
				woo_pd_update_option( 'skip_shipping_class', $import->skip_shipping_class );
				woo_pd_update_option( 'skip_brand', $import->skip_brand );
				woo_pd_update_option( 'import_method', $import->import_method );
				woo_pd_update_option( 'duplicate_image_method', $import->duplicate_image_method );
				woo_pd_update_option( 'special_category_assignment', $import->special_category_assignment );
				woo_pd_update_option( 'force_refresh_images', $import->force_refresh_images );
				woo_pd_update_option( 'advanced_log', absint( $import->advanced_log ) );
				if( isset( $_POST['timeout'] ) )
					woo_pd_update_option( 'timeout', sanitize_text_field( $_POST['timeout'] ) );

				// Check if our import has expired
				if( !woo_pd_get_option( 'csv' ) ) {
					$import->cancel_import = true;
					$message = sprintf( __( 'Your CSV file upload has expired, re-upload it from the opening import screen. %s', 'woocommerce-product-importer' ), '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'woocommerce-product-importer' ) . '</a>' );
					woo_pd_admin_notice( $message, 'error' );
				}

				if( $import->cancel_import )
					return;

				// Check if this is a resumed import
				if ( isset( $_POST['refresh_step'] ) ) {
					$step = sanitize_text_field( $_POST['refresh_step'] );
					// Override to use Options instead of Transients to resolve object caching conflict
					if( apply_filters( 'woo_pd_override_temp_storage_method', false ) )
						$transient = get_option( WOO_PD_PREFIX . '_import' );
					else
						$transient = get_transient( WOO_PD_PREFIX . '_import' );
					if( $transient == false )
						$transient = new stdClass;
					if( isset( $transient->log ) )
						$transient->log = '<br /><br />' . __( 'Resuming import...', 'woocommerce-product-importer' );
					if( sanitize_text_field( $_POST['import_method'] ) == 'update' )
						$transient->log .= "<br /><br />" . __( 'Merging Product changes...', 'woocommerce-product-importer' );
					else if( sanitize_text_field( $_POST['import_method'] ) == 'merge' )
						$transient->log .= "<br /><br />" . __( 'Generating Products and merging Product changes...', 'woocommerce-product-importer' );
					else if( sanitize_text_field( $_POST['import_method'] ) == 'new' )
						$transient->log .= "<br /><br />" . __( 'Generating Products...', 'woocommerce-product-importer' );
					$settings = array(
						'skip_first' => ( isset( $transient->skip_first ) ? $transient->skip_first : woo_pd_get_option( 'skip_first', false ) ),
						'import_method' => ( isset( $_POST['import_method'] ) ? sanitize_text_field( $_POST['import_method'] ) : 'merge' ),
						'restart_from' => ( isset( $_POST['restart_from'] ) ? absint( $_POST['restart_from'] ) : 0 ),
						'progress' => ( isset( $_POST['progress'] ) ? absint( $_POST['progress'] ) : 0 ),
						'total_progress' => ( isset( $_POST['total_progress'] ) ? absint( $_POST['total_progress'] ) : 0 ),
						'log' => __( 'Resuming import...', 'woocommerce-product-importer' )
					);
					// Override to use Options instead of Transients to resolve object caching conflict
					if( apply_filters( 'woo_pd_override_temp_storage_method', false ) )
						$response = update_option( WOO_PD_PREFIX . '_import', $transient );
					else
						$response = set_transient( WOO_PD_PREFIX . '_import', $transient, DAY_IN_SECONDS );
					// Check if the Transient was saved
					if( is_wp_error( $response ) )
						woo_pd_error_log( sprintf( '%s: Error: %s', basename( woo_pd_get_option( 'csv' ) ), __( 'Could not save the resume import Transient', 'woocommerce-product-importer' ) ) );
					unset( $transient );
				} else {
					$step = 'prepare_data';
					$settings = ( isset( $_POST ) ? $_POST : false );
				}

				wp_enqueue_script( 'jquery' );
				wp_enqueue_script( 'progressBar', plugins_url( '/js/progress.js', WOO_PD_FILE ), array( 'jquery' ) );
				wp_enqueue_script( 'ajaxUpload', plugins_url( '/js/ajaxupload.js', WOO_PD_FILE ), array( 'jquery' ) );
				// Check our import engine exists before proceeding
				if( file_exists( WOO_PD_PATH . 'js/engine.js' ) ) {
					wp_register_script( 'ajaxImporter', plugins_url( '/js/engine.js', WOO_PD_FILE ), array( 'jquery' ) );
				} else {
					$import->cancel_import = true;
					$message = sprintf( __( 'We couldn\'t load the AJAX import engine <code>%s</code> within <code>%s</code>, this file should be present.', 'woocommerce-product-importer' ), 'engine-' . $import->import_type . '.php', WOO_PD_PATH . 'js/...' ) . sprintf( __( ' <a href="%s" target="_blank">Need help?</a>', 'woocommerce-product-importer' ), $troubleshooting_url );
					woo_pd_admin_notice( $message, 'error' );
					return;
				}
				wp_enqueue_script( 'ajaxImporter' );
				wp_localize_script( 'ajaxImporter', 'ajaxImport', array(
					'settings'	=> $settings,
					'ajaxurl'	=> admin_url( 'admin-ajax.php' ),
					'step'		=> $step
				) );
				unset( $step, $settings );
				break;

		}

	}

	function woo_pd_ajax_product_importer() {

		if( isset( $_POST['step'] ) ) {

			global $import;

			if( !ini_get( 'safe_mode' ) )
				@ini_set( 'memory_limit', WP_MAX_MEMORY_LIMIT );

			ob_start();

			// Split the CSV data from the main transient
			if( $_POST['step'] != 'prepare_data' ) {
				// Override to use Options instead of Transients to resolve object caching conflict
				if( apply_filters( 'woo_pd_override_temp_storage_method', false ) )
					$import = get_option( WOO_PD_PREFIX . '_import' );
				else
					$import = get_transient( WOO_PD_PREFIX . '_import' );
				if( is_object( $import ) ) {
					if( isset( $_POST['settings'] ) && !is_string( $_POST['settings'] ) ) {
						foreach( $_POST['settings'] as $key => $value ) {
							if( is_array( $value ) ) {
								foreach( $value as $value_key => $value_value ) {
									if( !is_array( $value_value ) )
										$value[$value_key] = stripslashes( $value_value );
								}
								$import->$key = $value;
							} else {
								$import->$key = stripslashes( $value );
							}
						}
					}
					// Merge the split transients into the $import global
					if( isset( $import->headers ) ) {
						$args = array(
							'generate_categories',
							'generate_tags',
							'generate_products',
							'prepare_product_import',
							'save_product'
						);
						foreach( $import->headers as $header ) {
							// Exclude csv_category, csv_tag, csv_brand for most of the import
							if( in_array( $header, array( 'category', 'category_1', 'category_2', 'category_3', 'tag', 'brand' ) ) ) {
								if( in_array( $_POST['step'], $args ) ) {
									// Override to use Options instead of Transients to resolve object caching conflict
									if( apply_filters( 'woo_pd_override_temp_storage_method', false ) )
										$import->{'csv_' . $header} = get_option( WOO_PD_PREFIX . '_csv_' . $header );
									else
										$import->{'csv_' . $header} = get_transient( WOO_PD_PREFIX . '_csv_' . $header );
								}
							} else {
								// Override to use Options instead of Transients to resolve object caching conflict
								if( apply_filters( 'woo_pd_override_temp_storage_method', false ) )
									$import->{'csv_' . $header} = get_option( WOO_PD_PREFIX . '_csv_' . $header );
								else
									$import->{'csv_' . $header} = get_transient( WOO_PD_PREFIX . '_csv_' . $header );
							}
						}
					}
				} else {
					$import = new stdClass;
					$import->cancel_import = true;
					$troubleshooting_url = 'http://www.visser.com.au/woocommerce/documentation/plugins/product-importer-deluxe/usage/';
					$import->failed_import = sprintf( __( 'Your import file contained special characters that WordPress and Product Importer Deluxe could not filter which corrupted the import file. %s', 'woocommerce-product-importer' ), __( 'Need help?', 'woocommerce-product-importer' ) . ' ' . $troubleshooting_url );
					woo_pd_error_log( sprintf( '%s: Error: %s', basename( woo_pd_get_option( 'csv' ) ), $import->failed_import ) );
				}
			}

			$timeout = 0;
			if( isset( $import->timeout ) )
				$timeout = $import->timeout;

			if( !ini_get( 'safe_mode' ) )
				@set_time_limit( $timeout );

			switch ( $_POST['step'] ) {

				case 'prepare_data':
					$import = new stdClass;
					$import->cron = false;
					$import->start_time = time();
					$import->cancel_import = false;
					$import->failed_import = '';
					$import->log = '';
					$import->image_method = '';
					$import->image_filename_method = 'uploads';
					$import->duplicate_image_method = 'new';
					$import->timeout = ( isset( $_POST['timeout'] ) ? $_POST['timeout'] : false );
					$import->delimiter = ( isset( $_POST['delimiter'] ) ? $_POST['delimiter'] : false );
					$import->category_separator = ( isset( $_POST['category_separator'] ) ? $_POST['category_separator'] : false );
					$import->parent_child_delimiter = ( isset( $_POST['parent_child_delimiter'] ) ? $_POST['parent_child_delimiter'] : false );
					$import->default_weight_unit = get_option( 'woocommerce_weight_unit', 'kg' );
					$import->default_measurement_unit = get_option( 'woocommerce_dimension_unit', 'cm' );
					$import->delete_file = woo_pd_get_option( 'delete_file', 0 );
					$import->encoding = woo_pd_get_option( 'encoding', 'UTF-8' );
					if( $import->encoding == '' || $import->encoding == false )
						$import->encoding = 'UTF-8';
					$import->import_method = ( isset( $_POST['import_method'] ) ? $_POST['import_method'] : 'merge' );
					$import->image_method = ( isset( $_POST['image_method'] ) ? sanitize_text_field( $_POST['image_method'] ) : false );
					$import->image_filename_method = ( isset( $_POST['image_filename_method'] ) ? sanitize_text_field( $_POST['image_filename_method'] ) : '' );
					$import->duplicate_image_method = ( isset( $_POST['duplicate_image_method'] ) ? sanitize_text_field( $_POST['duplicate_image_method'] ) : '' );
					$import->advanced_log = ( isset( $_POST['advanced_log'] ) ? absint( $_POST['advanced_log'] ) : 0 );
					if( $import->advanced_log )
						$import->log .= '<br />' . sprintf( __( 'Detected import method: %s...', 'woocommerce-product-importer' ), $import->import_method );
					if( $import->advanced_log ) {
						$import->log .= '<br />' . sprintf( __( 'Detected image import method: %s...', 'woocommerce-product-importer' ), ( !empty( $import->image_method ) ? $import->image_method : 'none' ) );
						if( $import->image_method == 'csv' )
							$import->log .= '<br />' . sprintf( __( 'Detected image filename method: %s...', 'woocommerce-product-importer' ), ( !empty( $import->image_filename_method ) ? $import->image_filename_method : 'none' ) );
						if( in_array( $import->image_method, array( 'csv', 'external' ) ) )
							$import->log .= '<br />' . sprintf( __( 'Detected duplicate image method: %s...', 'woocommerce-product-importer' ), ( !empty( $import->duplicate_image_method ) ? $import->duplicate_image_method : 'none' ) );
					}
					woo_pd_prepare_data( 'prepare_data' );

					if( $import->advanced_log )
						$import->log .= "<br />" . __( 'Validating required columns... ', 'woocommerce-product-importer' );

					woo_pd_prepare_columns();
					if( $import->cancel_import == false ) {

						$import->skip_first = ( isset( $_POST['skip_first'] ) ? absint( $_POST['skip_first'] ) : 0 );
						$import->special_category_assignment = ( isset( $_POST['special_category_assignment'] ) ? absint( $_POST['special_category_assignment'] ) : 0 );
						$import->force_refresh_images = ( isset( $_POST['force_refresh_images'] ) ? absint( $_POST['force_refresh_images'] ) : 0 );
						if( !empty( $import->image_method ) ) {
							switch( $import->image_method ) {

								case 'csv':
									if( !isset( $import->csv_image ) ) {
										$import->cancel_import = true;
										$import->failed_import = __( 'If you are importing Product images you must specify the image import method and assign the image column', 'woocommerce-product-importer' );
										woo_pd_error_log( sprintf( '%s: Error: %s', basename( woo_pd_get_option( 'csv' ) ), $import->failed_import ) );
									}
									break;

							}
						}
						$import->log .= "<br />" . __( 'Product columns have been grouped', 'woocommerce-product-importer' );
						$import->log .= "<br /><br />" . __( 'Generating Categories...', 'woocommerce-product-importer' );
						$import->loading_text = __( 'Generating Categories...', 'woocommerce-product-importer' );
					}
					break;

				case 'generate_categories':
					$import->products_added = 0;
					$import->variations_added = 0;
					$import->products_deleted = 0;
					$import->products_failed = 0;
					$import->products_updated = 0;
					$import->skip_category = absint( woo_pd_get_option( 'skip_category', 0 ) );
					// Category generation; check for Category column
					if( $import->skip_category == 0 && in_array( $import->import_method, array( 'new', 'merge', 'update' ) ) && isset( $import->csv_category ) )
						woo_pd_generate_categories();
					else
						$import->log .= "<br />" . __( 'Categories skipped', 'woocommerce-product-importer' );

					// Brands
					if( woo_pd_detect_product_brands() ) {
						$import->log .= "<br /><br />" . __( 'Generating Brands...', 'woocommerce-product-importer' );
						$import->skip_brand = absint( woo_pd_get_option( 'skip_brand', 0 ) );
						// Brand generation
						if( $import->skip_brand == 0 && in_array( $import->import_method, array( 'new', 'merge', 'update' ) ) && isset( $import->csv_brand ) )
							woo_pd_generate_brands();
						else
							$import->log .= "<br />" . __( 'Brands skipped', 'woocommerce-product-importer' );
					}

					$import->log .= "<br /><br />" . __( 'Generating Tags...', 'woocommerce-product-importer' );
					$import->loading_text = __( 'Generating Tags...', 'woocommerce-product-importer' );
					break;

				case 'generate_tags':
					$import->skip_product_tag = absint( woo_pd_get_option( 'skip_tag', 0 ) );
					// Tag generation
					if( $import->skip_product_tag == 0 && in_array( $import->import_method, array( 'new', 'merge', 'update' ) ) && isset( $import->csv_tag ) )
						woo_pd_generate_tags();
					else
						$import->log .= "<br />" . __( 'Tags skipped', 'woocommerce-product-importer' );

					$import->log .= "<br /><br />" . __( 'Generating Shipping Classes...', 'woocommerce-product-importer' );
					$import->skip_shipping_class = absint( woo_pd_get_option( 'skip_shipping_class', 0 ) );
					// Shipping Class generation
					if( $import->skip_shipping_class == 0 && in_array( $import->import_method, array( 'new', 'merge', 'update' ) ) && isset( $import->csv_shipping_class ) )
						woo_pd_generate_shipping_classes();
					else
						$import->log .= "<br />" . __( 'Shipping Classes skipped', 'woocommerce-product-importer' );
					$import->loading_text = __( 'Generating Products...', 'woocommerce-product-importer' );
					break;

				case 'generate_products':
					if( $import->import_method == 'update' )
						$import->log .= "<br /><br />" . __( 'Merging Product changes...', 'woocommerce-product-importer' );
					else if( $import->import_method == 'merge' )
						$import->log .= "<br /><br />" . __( 'Generating Products and merging Product changes...', 'woocommerce-product-importer' );
					else if( $import->import_method == 'new' )
						$import->log .= "<br /><br />" . __( 'Generating Products...', 'woocommerce-product-importer' );
					else if( $import->import_method == 'delete' )
						$import->log .= "<br /><br />" . __( 'Checking for matching Products to delete...', 'woocommerce-product-importer' );
					$import->loading_text = __( 'Importing Products...', 'woocommerce-product-importer' );
					break;

				case 'prepare_product_import':

					global $import, $product;

					if( $import->advanced_log )
						$import->log .= "<br />>>> " . __( 'Including non-essential reporting in this import log', 'woocommerce-product-importer' );
					if( $import->skip_first ) {
						$import->i = 1;
						$import->log .= "<br />>>> " . __( 'Skipping import of first CSV row', 'woocommerce-product-importer' );
					} else {
						$import->i = 0;
						$import->log .= "<br />>>> " . __( 'Starting import at first CSV row', 'woocommerce-product-importer' );
					}
					if( $import->special_category_assignment )
						$import->log .= "<br />>>> " . __( 'Assigning Products to lowest sub-Category only', 'woocommerce-product-importer' );
					if( $import->force_refresh_images && in_array( $import->import_method, array( 'update', 'merge' ) ) )
						$import->log .= "<br />>>> " . __( 'Force refreshing Featured Image and Product Gallery', 'woocommerce-product-importer' );
					$import->failed_products = array();

					$i = $import->i;
					woo_pd_prepare_product( $i );

					// This runs once as part of the import preparation
					$import->active_product = $product;

					if( ( in_array( $import->import_method, array( 'update', 'merge' ) ) && $product->duplicate_exists ) || $import->import_method == 'update' ) {
						if( !empty( $product->name ) )
							$import->log .= "<br />>>> " . sprintf( __( 'Merging %s...', 'woocommerce-product-importer' ), $product->name );
						else
							$import->log .= "<br />>>> " . sprintf( __( 'Merging (no title) - SKU: %s...', 'woocommerce-product-importer' ), $product->sku );
						$import->loading_text = sprintf( __( 'Merging Product %d of %d...', 'woocommerce-product-importer' ), $i, ( $import->skip_first ? $import->rows - 1 : $import->rows ) );
					} else if( $import->import_method == 'delete' ) {
						if( !empty( $product->name ) )
							$import->log .= "<br />>>> " . sprintf( __( 'Searching for %s...', 'woocommerce-product-importer' ), $product->name );
						else
							$import->log .= "<br />>>> " . sprintf( __( 'Searching for (no title) - SKU: %s...', 'woocommerce-product-importer' ), $product->sku );
						$import->loading_text = sprintf( __( 'Searching for Product %d of %d...', 'woocommerce-product-importer' ), $i, ( $import->skip_first ? $import->rows - 1 : $import->rows ) );
					} else {
						if( !empty( $product->name ) )
							$import->log .= "<br />>>> " . sprintf( __( 'Importing %s...', 'woocommerce-product-importer' ), $product->name );
						else
							$import->log .= "<br />>>> " . sprintf( __( 'Importing (no title) - SKU: %s...', 'woocommerce-product-importer' ), $product->sku );
						$import->loading_text = sprintf( __( 'Importing Product %d of %d...', 'woocommerce-product-importer' ), $i, ( $import->skip_first ? $import->rows - 1 : $import->rows ) );
					}
					break;

				case 'save_product':

					if( $import->cancel_import && !isset( $import->active_product ) ) {
						$import->log = "<br /><br />" . __( 'Import cancelled', 'woocommerce-product-importer' );
						break;
					}

					global $product;

					$i = ( isset( $_POST['i'] ) ? $_POST['i'] : false );

					if( $import->active_product ) {
						if( !isset( $product ) )
							$product = new stdClass;
						foreach( $import->active_product as $key => $value )
							$product->$key = $value;
					}

					$import->product_start_time = microtime( true );

					if( in_array( $import->import_method, array( 'new', 'merge', 'update' ) ) ) {
						// Build Categories
						if( isset( $product->category ) )
							woo_pd_process_categories();

						// Build Tags
						if( isset( $product->tag ) )
							woo_pd_process_tags();

						// Build Shipping Classes
						woo_pd_process_shipping_classes();

						// Brands
						if( woo_pd_detect_product_brands() ) {
							// Build Brands
							woo_pd_process_brands();
						}

						// Build Vendors
						woo_pd_process_vendors();
					}

					// Check for duplicate SKU
					woo_pd_duplicate_product_exists();

					woo_pd_validate_product();

					if( $product->fail_requirements ) {

						if( $import->advanced_log )
							$import->log .= "<br />>>>>>> " . sprintf( __( 'Skipping Product, see Import Report for full explanation. Reason: %s', 'woocommerce-product-importer' ), $product->failed_reason );
						else
							$import->log .= "<br />>>>>>> " . sprintf( __( 'Skipping Product, reason: %s', 'woocommerce-product-importer' ), $product->failed_reason );
						$import->products_failed++;

					} else {

						if( in_array( $import->import_method, array( 'merge', 'update' ) ) && $product->duplicate_exists )
							woo_pd_merge_product();
						else if( $import->import_method == 'delete' && $product->duplicate_exists )
							woo_pd_delete_product();
						else if( in_array( $import->import_method, array( 'new', 'merge' ) ) )
							woo_pd_create_product();

						// Imported Product successfully
						if( in_array( $import->import_method, array( 'update', 'merge' ) ) && $product->duplicate_exists ) {
							if( $product->updated ) {
								if( !empty( $product->name ) ) {
									$import->log .= "<br />>>>>>> " . sprintf( __( '%s successfully updated', 'woocommerce-product-importer' ), $product->name );
								} else {
									$product_title = get_the_title( $product->duplicate_exists );
									if( $product_title === false )
										$product_title = __( '(no title)', 'woocommerce-product-importer' );
									$import->log .= "<br />>>>>>> " . sprintf( __( '%s - SKU: %s successfully updated', 'woocommerce-product-importer' ), $product_title, $product->sku );
								}
							} else {
								if( !empty( $product->name ) ) {
									$import->log .= "<br />>>>>>> " . sprintf( __( 'No changes were made to %s', 'woocommerce-product-importer' ), $product->name );
								} else {
									$product_title = get_the_title( $product->duplicate_exists );
									if( $product_title === false )
										$product_title = __( '(no title)', 'woocommerce-product-importer' );
									$import->log .= "<br />>>>>>> " . sprintf( __( 'No changes were made to %s - SKU: %s', 'woocommerce-product-importer' ), $product_title, $product->sku );
								}
							}
						} else if( $import->import_method == 'delete' ) {
							if( $product->deleted ) {
								if( !empty( $product->name ) ) {
									$import->log .= "<br />>>>>>> " . sprintf( __( '%s successfully deleted', 'woocommerce-product-importer' ), $product->name );
								} else {
									$product_title = get_the_title( $product->duplicate_exists );
									if( $product_title === false )
										$product_title = __( '(no title)', 'woocommerce-product-importer' );
									$import->log .= "<br />>>>>>> " . sprintf( __( '%s - SKU: %s successfully deleted', 'woocommerce-product-importer' ), $product_title, $product->sku );
								}
							} else {
								if( $import->advanced_log )
									$import->log .= "<br />>>>>>> " . sprintf( __( 'Skipping Product, see Import Report for full explanation. Reason: %s', 'woocommerce-product-importer' ), $product->failed_reason );
								else
									$import->log .= "<br />>>>>>> " . sprintf( __( 'Skipping Product, reason: %s', 'woocommerce-product-importer' ), $product->failed_reason );
							}
						} else {
							if( $product->imported ) {
								if( $import->import_method == 'new' ) {
									if( !empty( $product->name ) )
										$import->log .= "<br />>>>>>> " . sprintf( __( '%s successfully imported', 'woocommerce-product-importer' ), $product->name );
									else
										$import->log .= "<br />>>>>>> " . sprintf( __( '(no title) - SKU: %s successfully imported', 'woocommerce-product-importer' ), $product->sku );
								}
							} else {
								if( $import->advanced_log )
									$import->log .= "<br />>>>>>> " . sprintf( __( 'Skipping Product, see Import Report for full explanation. Reason: %s', 'woocommerce-product-importer' ), $product->failed_reason );
								else
									$import->log .= "<br />>>>>>> " . sprintf( __( 'Skipping Product, reason: %s', 'woocommerce-product-importer' ), $product->failed_reason );
							}
						}

					}
					$import->product_end_time = microtime( true );
					$import->product_min_time = ( isset( $import->product_min_time ) ? $import->product_min_time : ( $import->product_end_time - $import->product_start_time ) );
					$import->product_max_time = ( isset( $import->product_max_time ) ? $import->product_max_time : ( $import->product_end_time - $import->product_start_time ) );
					// Update minimum product import time if it is shorter than the last
					if( ( $import->product_end_time - $import->product_start_time ) < $import->product_min_time )
						$import->product_min_time = ( $import->product_end_time - $import->product_start_time );
					// Update maximum product import time if it is longer than the last
					if( ( $import->product_end_time - $import->product_start_time ) > $import->product_max_time )
						$import->product_max_time = ( $import->product_end_time - $import->product_start_time );

					// All import rows have been processed
					if( $i+1 == $import->rows ) {
						if( $import->import_method == 'update' )
							$import->log .= "<br />" . __( 'Product changes have been merged', 'woocommerce-product-importer' );
						else if( $import->import_method == 'merge' )
							$import->log .= "<br />" . __( 'Products have been generated and Product changes merged', 'woocommerce-product-importer' );
						else if( $import->import_method == 'new' )
							$import->log .= "<br />" . __( 'Products have been generated', 'woocommerce-product-importer' );
						else if( $import->import_method == 'delete' )
							$import->log .= "<br />" . __( 'Products have been deleted', 'woocommerce-product-importer' );
						$import->log .= "<br /><br />" . __( 'Cleaning up...', 'woocommerce-product-importer' );
						$import->loading_text = __( 'Cleaning up...', 'woocommerce-product-importer' );
					} else {
						unset( $import->active_product );

						woo_pd_prepare_product( $i + 1 );

						// This runs for each additional Product imported
						$import->active_product = $product;

						if( ( in_array( $import->import_method, array( 'update', 'merge' ) ) && $product->duplicate_exists ) || $import->import_method == 'update' ) {
							if( !empty( $product->name ) )
								$import->log .= "<br />>>> " . sprintf( __( 'Merging %s...', 'woocommerce-product-importer' ), $product->name );
							else
								$import->log .= "<br />>>> " . sprintf( __( 'Merging (no title) - SKU: %s...', 'woocommerce-product-importer' ), $product->sku );
							$import->loading_text = sprintf( __( 'Merging Product %d of %d...', 'woocommerce-product-importer' ), $i + 1, ( $import->skip_first ? $import->rows - 1 : $import->rows ) );
						} else if( $import->import_method == 'delete' ) {
							if( !empty( $product->name ) )
								$import->log .= "<br />>>> " . sprintf( __( 'Searching for %s...', 'woocommerce-product-importer' ), $product->name );
							else
								$import->log .= "<br />>>> " . sprintf( __( 'Searching for (no title) - SKU: %s...', 'woocommerce-product-importer' ), $product->sku );
							$import->loading_text = sprintf( __( 'Searching for Product %d of %d...', 'woocommerce-product-importer' ), $i + 1, ( $import->skip_first ? $import->rows - 1 : $import->rows ) );
						} else {
							if( !empty( $product->name ) )
								$import->log .= "<br />>>> " . sprintf( __( 'Importing %s...', 'woocommerce-product-importer' ), $product->name );
							else
								$import->log .= "<br />>>> " . sprintf( __( 'Importing (no title) - SKU: %s...', 'woocommerce-product-importer' ), $product->sku );
							$import->loading_text = sprintf( __( 'Importing Product %d of %d...', 'woocommerce-product-importer' ), $i + 1, ( $import->skip_first ? $import->rows - 1 : $import->rows ) );
						}
					}
					break;

				case 'clean_up':

					global $wpdb, $product;

					$post_type = 'product';

					// Organise Categories
					if( isset( $import->csv_category ) ) {
						$term_taxonomy = 'product_cat';
						// @mod - Comment out since using new taxonomy import method
						// _get_term_hierarchy( $term_taxonomy );
						$import->log .= "<br />>>> " . __( 'Organise Categories', 'woocommerce-product-importer' );
					}

					// Organise Tags
					if( isset( $import->csv_tag ) ) {
						// @mod - Comment out since using new taxonomy import method
						// $wpdb->query( "UPDATE " . $wpdb->term_taxonomy . " tt1 SET count = (SELECT count(p.ID) FROM " . $wpdb->term_relationships . " tr LEFT JOIN " . $wpdb->posts . " p ON (p.ID = tr.object_id AND p.post_type = '" . $post_type . "' AND p.post_status = 'publish') WHERE tr.term_taxonomy_id = tt1.term_taxonomy_id)" );
						$import->log .= "<br />>>> " . __( 'Organise Tags', 'woocommerce-product-importer' );
					}

					// Organise Shipping Classes
					if( isset( $import->csv_shipping_class ) ) {
						$import->log .= "<br />>>> " . __( 'Organise Shipping Classes', 'woocommerce-product-importer' );
					}

					// Brands
					if( woo_pd_detect_product_brands() ) {
						// Organise Brands
						if( isset( $import->csv_brand ) ) {
							$import->log .= "<br />>>> " . __( 'Organise Brands', 'woocommerce-product-importer' );
						}
					}

					$import->log .= "<br />>>> " . __( 'Organise Variations', 'woocommerce-product-importer' );

					$import->log .= "<br />" . __( 'Clean up has completed', 'woocommerce-product-importer' );
					$import->end_time = time();

					// Post-import Product details
					if( isset( $import->advanced_log ) && $import->advanced_log ) {
						$import->log .= "<br /><br />" . __( 'Import summary', 'woocommerce-product-importer' );
						if( in_array( $import->import_method, array( 'new', 'merge' ) ) )
							$import->log .= "<br />>>> " . sprintf( __( '%d Products added', 'woocommerce-product-importer' ), $import->products_added );
						else if( $import->import_method == 'delete' )
							$import->log .= "<br />>>> " . sprintf( __( '%d Products deleted', 'woocommerce-product-importer' ), $import->products_deleted );
						$import->log .= "<br />>>> " . sprintf( __( '%d Products updated', 'woocommerce-product-importer' ), $import->products_updated );
						$import->log .= "<br />>>> " . sprintf( __( '%d Products skipped', 'woocommerce-product-importer' ), $import->products_failed );
						$import->log .= "<br />>>> " . sprintf( __( '%d Variations added', 'woocommerce-product-importer' ), $import->variations_added );
						$import->log .= "<br />>>> " . sprintf( __( 'Import took %s to complete', 'woocommerce-product-importer' ), woo_pd_display_time_elapsed( $import->start_time, $import->end_time ) );
						$import->log .= "<br />>>> " . sprintf( __( 'Fastest Product took less than %s to process', 'woocommerce-product-importer' ), woo_pd_display_time_elapsed( time(), strtotime( sprintf( '+%d seconds', $import->product_min_time ) ) ) );
						$import->log .= "<br />>>> " . sprintf( __( 'Slowest Product took more than %s to process', 'woocommerce-product-importer' ), woo_pd_display_time_elapsed( time(), strtotime( sprintf( '+%d seconds', $import->product_max_time ) ) ) );
					}

					$import->log .= "<br /><br />" . __( 'Import complete!', 'woocommerce-product-importer' );
					$import->loading_text = __( 'Completed', 'woocommerce-product-importer' );
					break;

			}

			// Clear transients
			if( function_exists( 'wc_delete_product_transients' ) )
				wc_delete_product_transients();

			$import->step = $_POST['step'];
			$import->errors = ob_get_contents();
			ob_end_clean();

			// Encode our transients in UTF-8 before storing them
			add_filter( 'pre_set_transient_woo_pd_import', 'woo_pd_filter_set_transient' );

			// Split the import data from the main transient
			if( isset( $import->headers ) ) {
				foreach( $import->headers as $header ) {
					if( isset( $import->{'csv_' . $header} ) ) {
						// Split each import column if its too big
/*
						// @mod - Needs alot of testing before deployed
						$size = count( $import->{'csv_' . $header} );
						if( $size > 500 ) {
							error_log( $header . ': ' . print_r( $import->{'csv_' . $header}, true ) );
							exit();
						} else {
							$response = set_transient( WOO_PD_PREFIX . '_csv_' . $header, $import->{'csv_' . $header}, DAY_IN_SECONDS );
						}
*/
						// Override to use Options instead of Transients to resolve object caching conflict
						if( apply_filters( 'woo_pd_override_temp_storage_method', false ) )
							$response = update_option( WOO_PD_PREFIX . '_csv_' . $header, $import->{'csv_' . $header} );
						else
							$response = set_transient( WOO_PD_PREFIX . '_csv_' . $header, $import->{'csv_' . $header}, DAY_IN_SECONDS );
						// Check if the Transient was saved
						if( is_wp_error( $response ) )
							woo_pd_error_log( sprintf( '%s: Error: %s', basename( woo_pd_get_option( 'csv' ) ), ( sprintf( __( 'Could not save the import data Transient for the column %s', 'woocommerce-product-importer' ), $header ) ) ) );
						unset( $import->{'csv_' . $header} );
					}
				}
			}
			// Override to use Options instead of Transients to resolve object caching conflict
			if( apply_filters( 'woo_pd_override_temp_storage_method', false ) )
				$response = update_option( WOO_PD_PREFIX . '_import', $import );
			else
				$response = set_transient( WOO_PD_PREFIX . '_import', $import, DAY_IN_SECONDS );
			// Check if the Transient was saved
			if( is_wp_error( $response ) )
				woo_pd_error_log( sprintf( '%s: Error: %s', basename( woo_pd_get_option( 'csv' ) ), __( 'Could not save the import Transient prior to starting AJAX import engine', 'woocommerce-product-importer' ) ) );

			$return = array();
			if( isset( $import->log ) )
				$return['log'] = $import->log;
			if( isset( $import->rows ) )
				$return['rows'] = $import->rows;
			if( isset( $import->skip_first ) )
				$return['skip_first'] = $import->skip_first;
			if( isset( $import->loading_text ) )
				$return['loading_text'] = $import->loading_text;
			if( isset( $import->cancel_import ) )
				$return['cancel_import'] = $import->cancel_import;
			if( isset( $import->failed_import ) )
				$return['failed_import'] = $import->failed_import;
			if( isset( $i ) )
				$return['i'] = $i;
			if( isset( $import->next ) )
				$return['next'] = $import->next;
			if( isset( $import->html ) )
				$return['html'] = $import->html;
			if( isset( $import->step ) )
				$return['step'] = $import->step;

			@array_map( 'utf8_encode', $return );

			header( "Content-type: application/json" );
			echo json_encode( $return );
		}
		die();	

	}
	add_action( 'wp_ajax_product_importer', 'woo_pd_ajax_product_importer' );

	function woo_pd_ajax_finish_import() {

		global $import;

		$return = array();

		ob_start();

		// Override to use Options instead of Transients to resolve object caching conflict
		if( apply_filters( 'woo_pd_override_temp_storage_method', false ) )
			$import = get_option( WOO_PD_PREFIX . '_import' );
		else
			$import = get_transient( WOO_PD_PREFIX . '_import' );
		foreach( $_POST['settings'] as $key => $value ) {
			if( is_array( $value ) ) {
				foreach( $value as $value_key => $value_value )
					if( !is_array( $value_value ) ) $value[$value_key] = stripslashes( $value_value );
/*
				foreach( $value as $value_key => $value_value ) {
					if( !is_array( $value_value ) )
						$value[$value_key] = stripslashes( $value_value );
				}
*/
				$import->$key = $value;
			} else {
				if( isset( $import ) )
					$import->$key = stripslashes( $value );
			}
		}
		$return['next'] = 'finish-import';
		$post_type = 'product';
		$manage_products_url = add_query_arg( 'post_type', $post_type, 'edit.php' );

		// Terminate import session as Products have been imported/merged
		if( apply_filters( 'woo_pd_ajax_finish_import_terminate_session', true ) ) {

			// Override to use Options instead of Transients to resolve object caching conflict
			if( apply_filters( 'woo_pd_override_temp_storage_method', false ) ) {
				delete_option( WOO_PD_PREFIX . '_import' );
				if( isset( $import->headers ) ) {
					foreach( $import->headers as $header )
						delete_option( WOO_PD_PREFIX . '_csv_' . $header );
				}
			} else {
				delete_transient( WOO_PD_PREFIX . '_import' );
				if( isset( $import->headers ) ) {
					foreach( $import->headers as $header )
						delete_transient( WOO_PD_PREFIX . '_csv_' . $header );
				}
			}
			woo_pd_delete_file();

		}

		include_once( WOO_PD_PATH . 'templates/admin/import_finish.php' );

		$return['html'] = ob_get_clean();
		header( "Content-type: application/json" );
		echo json_encode( $return );

		die();

	}
	add_action( 'wp_ajax_finish_import', 'woo_pd_ajax_finish_import' );

	function woo_pd_finish_message() {

		global $import;

		$message = '';
		if( !$import->failed_products ) {
			if( $import->import_method == 'merge' )
				$message = apply_filters( 'woo_pd_finish_success_merge', __( 'Good news! All of your Products have been successfully merged into WooCommerce.', 'woocommerce-product-importer' ) );
			else if( $import->import_method == 'delete' )
				$message = apply_filters( 'woo_pd_finish_success_delete', __( 'Good news! All of your matched Products have been successfully deleted from WooCommerce.', 'woocommerce-product-importer' ) );
			else if( $import->import_method == 'new' )
				$message = apply_filters( 'woo_pd_finish_success_import', __( 'Good news! All of your Products have been successfully imported into WooCommerce.', 'woocommerce-product-importer' ) );
		} else {
			if( $import->products_added || $import->products_deleted || $import->products_updated ) {
				if( $import->import_method == 'merge' )
					$message = apply_filters( 'woo_pd_finish_partial_merge', __( 'Here\'s the news. Some of your Products have been successfully merged into WooCommerce.', 'woocommerce-product-importer' ) );
				else if( $import->import_method == 'delete' )
					$message = apply_filters( 'woo_pd_finish_partial_delete', __( 'Here\'s the news. Some of your Products have been successfully removed from WooCommerce.', 'woocommerce-product-importer' ) );
				else if( $import->import_method == 'new' )
					$message = apply_filters( 'woo_pd_finish_partial_import', __( 'Here\'s the news. Some of your Products have been successfully imported into WooCommerce.', 'woocommerce-product-importer' ) );
			} else {
				if( $import->import_method == 'merge' )
					$message = apply_filters( 'woo_pd_finish_fail_merge', __( 'Here\'s the news. No Product changes were into WooCommerce.', 'woocommerce-product-importer' ) );
				else if( $import->import_method == 'new' )
					$message = apply_filters( 'woo_pd_finish_fail_import', __( 'Here\'s the news. No new Products were imported into WooCommerce.', 'woocommerce-product-importer' ) );
				else if( $import->import_method == 'delete' )
					$message = apply_filters( 'woo_pd_finish_fail_delete', __( 'Here\'s the news. No matched Products were removed from WooCommerce.', 'woocommerce-product-importer' ) );
			}
		}
		if( $message ) { ?>
<div class="updated settings-error below-h2">
	<p><?php echo $message; ?></p>
</div>
<?php
		}

	}

	// Increase memory for AJAX importer process and Product Importer screens
	function woo_pd_init_memory() {

		$page = $_SERVER['SCRIPT_NAME'];
		if( isset( $_POST['action'] ) )
			$action = $_POST['action'];
		elseif( isset( $_GET['action'] ) )
			$action = $_GET['action'];
		else
			$action = '';

		$allowed_actions = array( 'product_importer', 'finish_import', 'upload_image' );

		if( $page == '/wp-admin/admin-ajax.php' && in_array( $action, $allowed_actions ) )
			@ini_set( 'memory_limit', WP_MAX_MEMORY_LIMIT );

	}
	add_action( 'plugins_loaded', 'woo_pd_init_memory' );

	// Returns the number of columns detected within a CSV file
	function woo_pd_total_columns() {

		global $import;

		if( $import->rows ) {
			if( $import->skip_first )
				$message = sprintf( __( '%s rows have been detected within this import file, and by the looks of it the first row contains the column headers. Let\'s get started!', 'woocommerce-product-importer' ), $import->rows );
			else
				$message = sprintf( __( '%s rows have been detected within this import file. Let\'s get started!', 'woocommerce-product-importer' ), $import->rows );
			woo_pd_admin_notice_html( $message );
		}

	}

	function woo_pd_options_open_optgroup( $option = array() ) {

		if( isset( $option['group_open'] ) )
			echo $option['group_open'];

	}

	function woo_pd_options_close_optgroup( $option = array() ) {

		if( isset( $option['group_close'] ) )
			echo $option['group_close'];

	}

	// Searches an array for a needle and returns the results
	function woo_pd_array_search( $array, $key, $value ) {

		$results = array();
		if( is_array( $array ) ) {
			if( isset( $array[$key] ) && $array[$key] == $value )
			$results[] = $array;
			foreach( $array as $subarray )
				$results = array_merge( $results, woo_pd_array_search( $subarray, $key, $value ) );
		}
		return $results;

	}

	function woo_pd_load_csv_file( $file_path = '' ) {

		$file = array(
			'size' => 0
		);
		if( !empty( $file_path ) ) {
			if( file_exists( $file_path ) ) {
				woo_pd_update_option( 'csv', $file_path );
				$upload_dir = wp_upload_dir();
				$file = array(
					'name' => basename( $file_path ),
					'type' => 'application/vnd.ms-excel',
					'tmp_name' => $file_path,
					'error' => 0,
					'size' => filesize( $file_path )
				);
				// If available check the import file type
				if( function_exists( 'finfo_open' ) && !ini_get( 'open_basedir' ) ) {
					$finfo = finfo_open( FILEINFO_MIME );
					if( $finfo !== false ) {
						$mime = finfo_file( $finfo, realpath( $file_path ) );
						finfo_close( $finfo );
						$file['type'] = $mime;
					}
				}
			}
		}
		return $file;

	}

	// Frees up memory after importing Products
	function woo_pd_destroy_global( $object ) {

		global $import, $product;

		unset( $object );

	}

	/* End of: WordPress Administration */

}

function woo_pd_download_import_file( $file_url = '', $import_method = 'external' ) {

	global $import;

	$troubleshooting_url = 'http://www.visser.com.au/documentation/product-importer-deluxe/usage/';

	// Create our default file to return
	$file = array(
		'size' => 0,
		'name' => '',
		'type' => 'application/vnd.ms-excel',
		'tmp_name' => '',
		'error' => 0,
		'size' => 0
	);

	if( $file_url ) {

		woo_pd_upload_directories();

		if( $import_method == 'external' ) {

			// Make consistant
			$site_url = trailingslashit( str_replace( 'www.', '', site_url() ) );
			$url = str_replace( 'www.', '', $file_url );

			// Same host
			if( strstr( $url, $site_url ) ) {
				$url = str_replace( $site_url, ABSPATH, $url );
				$fp = fopen( $url, 'rb' );
				$bits = '';
				if( $fp ) {
					while( !feof( $fp ) )
						$bits .= fread( $fp, 1024 );
				}
				fclose( $fp );
				$filename = woo_pd_get_filename( $file_url );
				$file['name'] = $filename;
				$file_path = $import->uploads_path . $filename;
				$fp2 = @fopen( $file_path, 'wb' );
				fwrite( $fp2, $bits );
				fclose( $fp2 );
				$size = @filesize( $file_path );
				// The function filesize() is known to fail so let's do a workaround
				if( $size == 0 && !empty( $bits ) )
					$size = count( $bits );
				// Check if the supplied download is not empty
				if( $size ) {
					$file['tmp_name'] = $file_path;
					$file['size'] = $size;
					woo_pd_update_option( 'csv', $file_path );
				} else {
					if( file_exists( $file_path ) )
						@unlink( $file_path );
				}
			} else {
				$bits = wp_remote_fopen( $file_url );
				$filename = woo_pd_get_filename( $file_url );
				$file['name'] = $filename;
				$size = @filesize( $bits );
				// The function filesize() is known to fail so let's do a workaround
				if( $size == 0 && !empty( $bits ) )
					$size = count( $bits );
				// Check if the supplied download is not empty
				if( $size ) {
					$file['size'] = $size;
					// Check if the filename and file is populated
					if( $filename && $bits ) {
						$upload = wp_upload_bits( $filename, null, $bits );
						if( $upload['error'] ) {
							$file['error'] = $upload['error'];
						} else {
							$file['tmp_name'] = $upload['file'];
							woo_pd_update_option( 'csv', $file_path );
						}
					}
				}
			}

		} else if( $import_method == 'ftp' ) {

			extract( $file_url );
			// Trim any slash from the start of the file path
			$remote_file_path = ltrim( $remote_file_path, '/' );
			$filename = woo_pd_get_filename( $remote_file_path );
			$file['name'] = $filename;
			// Check if ftp_connect() is available
			if( function_exists( 'ftp_connect' ) ) {
				$port = ( !empty( $port ) ? absint( $port ) : false );
				if( $connection = ftp_connect( $host, $port ) ) {
					// Update the FTP timeout if available and if a timeout was provided at import
					$remote_timeout = ftp_get_option( $connection, FTP_TIMEOUT_SEC );
					$timeout = absint( $timeout );
					if( $remote_timeout !== false && !empty( $timeout ) ) {
						// Compare the server timeout and the timeout provided at import
						if( $remote_timeout <> $timeout ) {
							if( ftp_set_option( $connection, FTP_TIMEOUT_SEC, $timeout ) == false )
								woo_pd_error_log( sprintf( '%s: Error: %s', basename( woo_pd_get_option( 'csv' ) ), sprintf( __( 'Could not change the timeout on %s', 'woocommerce-product-importer' ), $host ) ) );
						}
					}
					unset( $remote_timeout );
					if( @ftp_login( $connection, $user, $pass ) ) {
						// Check if Transfer Mode is set to Auto/Pasive and if passive mode is available
						if( in_array( $passive, array( 'auto', 'passive' ) ) ) {
							$features = ftp_raw( $connection, 'FEAT' );
							if( !empty( $features ) ) {
								if( in_array( 'PASV', $features ) ) {
									if( ftp_pasv( $connection, true ) == false )
										woo_pd_error_log( sprintf( '%s: Error: %s', basename( woo_pd_get_option( 'csv' ) ), sprintf( __( 'Could not switch to passive mode on %s', 'woocommerce-product-importer' ), $host ) ) );
								}
							}
						}
						$file_path = $import->uploads_path . $filename;
						// Check if the file exists before downloading
						if( @ftp_size( $connection, $remote_file_path ) != '-1' ) {
							@ftp_get( $connection, $file_path, $remote_file_path, FTP_ASCII );
							$size = @filesize( $file_path );
							// Check if the supplied download is not empty
							if( $size ) {
								$file['tmp_name'] = $file_path;
								$file['size'] = $size;
								woo_pd_update_option( 'csv', $file_path );
							} else {
								if( file_exists( $file_path ) )
									@unlink( $file_path );
							}
						} else {
							$file['error'] = sprintf( __( 'No CSV file could be found at <code>%s</code>, please check the remote file path is correct.', 'woocommerce-product-importer' ), $remote_file_path );
						}
					} else {
						$file['error'] = sprintf( __( 'Login incorrect for user <code>%s</code> on FTP server at <code>%s</code>', 'woocommerce-product-importer' ), $user, $host );
					}
					ftp_close( $connection );
				} else {
					$file['error'] = sprintf( __( 'Could not connect to FTP server at <code>%s</code>, confirm the host, port and transfer mode are correct.', 'woocommerce-product-importer' ), $host );
				}
			} else {
				$file['error'] = __( 'The function ftp_connect() is disabled within your WordPress site. Contact your hosting provider for more information.', 'woocommerce-product-importer' );
			}

		}
	} else {
		$file['error'] = 4;
	}
	return $file;

}

/*
 * By default the character encoding - $to_encoding - is set to ISO-8859-1, change this if you experience
 * character encoding issues. There is also an alternative character encoding method available which some
 * store owners have had success with. Use with caution.
 *
 * Since: 1.6.8
 *
 */
function woo_pd_prepare_data( $step = false ) {

	global $import;

	$import->skip_first = false;
	if( $file = woo_pd_get_option( 'csv' ) ) {
		ini_set( 'auto_detect_line_endings', true );
		if( @filesize( $file ) > 0 ) {
			// Skip generating first and second rows for AJAX import engine
			if( $step == false ) {
				if( $handle = @fopen( $file, 'r' ) ) {
					$import->lines = array();
					$line = 0;
					while( ( $buffer = fgetcsv( $handle, 0, $import->delimiter ) ) !== false ) {
						// First row of import file
						if( $line == 0 ) {
							// Save the first row intact for later import column detection
							$import->raw = implode( $import->delimiter, $buffer );
							$import->lines[0] = woo_pd_encode_transient( $buffer );
						}
						// Second row of import file
						if( $line == 1 ) {
							$import->raw .= implode( $import->delimiter, $buffer );
							$import->lines[1] = woo_pd_encode_transient( $buffer );
							break;
						}
						$line++;
					}
					fclose( $handle );
				}
			}
			if( $handle = @fopen( $file, 'r' ) ) {
				$data = array();
				while( ( $csv_data = @fgetcsv( $handle, filesize( $handle ), $import->delimiter ) ) !== false ) {
					$size = count( $csv_data );
					for( $i = 0; $i < $size; $i++ ) {
						if( !isset( $data[$i] ) || !is_array( $data[$i] ) )
							$data[$i] = array();
						$csv_data[$i] = woo_pd_encode_transient( trim( $csv_data[$i] ) );
						array_push( $data[$i], $csv_data[$i] );
					}
					unset( $csv_data );
				}
				fclose( $handle );
				$import->csv_data = $data;
				unset( $csv_data, $data );
				$import->rows = count( $import->csv_data[0] );

				if( $import->advanced_log && isset( $import->log ) ) {
					$import->log .= "<br />" . sprintf( __( 'Detected import rows... %d', 'woocommerce-product-importer' ), $import->rows );
					$import->log .= "<br />" . sprintf( __( 'Sufficient memory is available... %s', 'woocommerce-product-importer' ), woo_pd_current_memory_usage() );
				}
			} else {
				$import->cancel_import = true;
				$import->failed_import = __( 'Could not read file. Could not open the import file or URL.', 'woocommerce-product-importer' );
				woo_pd_error_log( sprintf( '%s: Error: %s', basename( woo_pd_get_option( 'csv' ) ), $import->failed_import ) );
			}
		} else {
			$import->cancel_import = true;
			$import->failed_import = __( 'Could not read file. An empty import file was detected.', 'woocommerce-product-importer' );
			woo_pd_error_log( sprintf( '%s: Error: %s', basename( woo_pd_get_option( 'csv' ) ), $import->failed_import ) );
		}
		ini_set( 'auto_detect_line_endings', false );
		unset( $handle );
	} else {
		$import->cancel_import = true;
		$import->failed_import = __( 'Could not read file. Product Importer Deluxe doesn\'t have a record of this import file.', 'woocommerce-product-importer' );
	}

}

function woo_pd_filter_set_transient( $var ) {

	if( is_object( $var ) ) {
		foreach( $var as $key => $value )
			$var->$key = woo_pd_encode_transient( $value );
	} else if( is_array( $var ) ) {
		foreach( $var as $key => $value )
			$var[$key] = woo_pd_encode_transient( $value );
	}
	return $var;

}

function woo_pd_encode_transient( $var = null ) {

	// Check that the Encoding class by Sebastin Grignoli exists
	if( file_exists( WOO_PD_PATH . 'classes/Encoding.php' ) ) {
		if( !class_exists( 'Encoding' ) ) {
			include_once( WOO_PD_PATH . 'classes/Encoding.php' );
			$encoding = new Encoding();
			return $encoding->toUTF8( $var );
		} else {
			// Check if it is the same Class
			if( method_exists( 'Encoding', 'toUTF8' ) ) {
				$encoding = new Encoding();
				return $encoding->toUTF8( $var );
			} else {
				return $var;
			}
		}
	} else {
		return $var;
	}

}

function woo_pd_format_path( $path = '' ) {

	if( strtoupper( substr( PHP_OS, 0, 3 ) ) == 'WIN' ) {
		$path = str_replace( '\\', '/', $path );
		$path = str_replace( '//', '/', $path );
	} else {
		$path = preg_replace( '#/+#', '/', $path );
	}
	return $path;

}

function woo_pd_format_upload_error_code( $error_code = 0 ) {

	$error_codes = array(
		1 => __( 'The uploaded file exceeds the upload_max_filesize directive in php.ini', 'woocommerce-product-importer' ),
		2 => __( 'The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form', 'woocommerce-product-importer' ),
		3 => __( 'The uploaded file was only partially uploaded', 'woocommerce-product-importer' ),
		4 => __( 'No file was uploaded', 'woocommerce-product-importer' ),
		6 => __( 'Missing a temporary folder', 'woocommerce-product-importer' ),
		7 => __( 'Failed to write file to disk', 'woocommerce-product-importer' ),
		8 => __( 'A PHP extension stopped the file upload', 'woocommerce-product-importer' )
	);
	if( empty( $error_code ) )
		$error_code = __( 'Unknown upload error', 'woocommerce-product-importer' );
	$output = ( isset( $error_codes[$error_code] ) ? $error_codes[$error_code] : $error_code );
	return $output; 

}

// Format import file column names so we can match them against import type columns
function woo_pd_format_column( $column ) {

	$output = $column;
	$output = strtolower( $output );
	$output = str_replace( array( 'attribute: ' ), 'pa_', $output );
	// Strip out any WC import prefixes
	$output = str_replace( array( 'meta:', 'tax:', 'attribute:', 'attribute_data:', 'attribute_default:' ), '', $output );
	// Strip out any confusing characters
	$output = str_replace( ' - ', '_', $output );
	$output = str_replace( array( ' ', '-' ), '_', $output );
	$output = str_replace( array( ':', '(', ')', '/' ), '', $output );
	return $output;

}

function woo_pd_search_column( $option = array(), $cell = '' ) {

	$column = woo_pd_format_column( $option['name'] );
	// Check if the alias key exists
	if( isset( $option['alias'] ) ) {
		// Check if the cell name is within the alias list
		$key = array_search( $cell, $option['alias'] );
		if( $key !== false )
			$column = $option['alias'][$key];
	}
	return $column;

}

function woo_pd_format_cell_preview( $value = '', $key = '', $cell = '' ) {

	global $import;

	$output = '';
	$placeholder = WC()->plugin_url() . '/assets/images/placeholder.png';
	$matches = array(
		'image',
		'product_gallery',
		'category',
		'tag',
		'up_sells',
		'cross_sells'
	);
	foreach( $matches as $match ) {
		if( strpos( woo_pd_format_column( $cell ), $match ) !== false ) {
			// Skip the following exceptions
			if( strpos( woo_pd_format_column( $cell ), 'clear' ) !== false )
				continue;
			// Count the number of Category separators
			$size = ( substr_count( $value, $import->category_separator ) + 1 );
			if( !empty( $value ) ) {
				// See if we can generate image previews for images
				if( in_array( $match, array( 'image', 'product_gallery' ) ) ) {
					$thumbnail_size_h = get_option( 'thumbnail_size_h', true );
					if( $size > 1 ) {
						$array = explode( $import->category_separator, $value );
						if( !empty( $array ) ) {
							for( $i = 0; $i < $size; $i++ ) {
								if( isset( $array[$i] ) && !empty( $array[$i] ) ) {
									if( strstr( $array[$i], 'http' ) || file_exists( $array[$i] ) ) {
										if( $i == 0 )
											$output .= __( 'Preview', 'woocommerce-product-importer' ) . ': ';
										if( strstr( $array[$i], 'http' ) && woo_pd_http_file_exists( $array[$i] ) ) {
											$output .= '<img src="' . $array[$i] . '" height="' . $thumbnail_size_h . '" alt="' . $array[$i] . '" title="' . basename( $array[$i] ) . '" />';
											if( $match == 'image' )
												$output .= '<br />';
										} else if( file_exists( $value ) ) {
											$output .= '<img src="' . $array[$i] . '" height="' . $thumbnail_size_h . '" alt="' . $array[$i] . '" title="' . basename( $array[$i] ) . '" />';
											if( $match == 'image' )
												$output .= '<br />';
										} else {
											$output .= '<img src="' . $placeholder . '" height="' . $thumbnail_size_h . '" alt="' . $array[$i] . '" title="' . __( 'Image could not be found', 'woocommerce-product-importer' ) . '" />';
											if( $match == 'image' )
												$output .= '<br />';
										}
									}
								}
							}
						}
					} else {
						$value = str_replace( $import->category_separator, "<br />", $value );
						if( strstr( $value, 'http' ) || file_exists( $value ) ) {
							$output .= __( 'Preview', 'woocommerce-product-importer' ) . ': ';
							// Check if the first image URL exists
							if( strstr( $value, 'http' ) && woo_pd_http_file_exists( $value ) )
								$output .= '<img src="' . $value . '" height="' . $thumbnail_size_h . '" alt="' . $value . '" /><br />';
							else if( file_exists( $value ) )
								$output .= '<img src="' . $value . '" height="' . $thumbnail_size_h . '" alt="' . $value . '" /><br />';
							else
								$output .= '<img src="' . $placeholder . '" height="' . $thumbnail_size_h . '" alt="' . $value . '" title="' . __( 'Image could not be found', 'woocommerce-product-importer' ) . '" />';
							$output .= '<br />';
						}
					}
				} else {
					$value = str_replace( $import->category_separator, "<br />", $value );
				}
				$output .= $value;
				if( $size > 1 )
					$output .= "<br />" . sprintf( __( '(Detected %d %s\'s)', 'woocommerce-product-importer' ), $size, $cell );
				else
					$output .= "<br />" . sprintf( __( '(Detected %d %s)', 'woocommerce-product-importer' ), $size, $cell );
			}
			break;
		}
	}
	if( empty( $output ) )
		$output .= $value;
	echo $output;

}

function woo_pd_prepare_columns( $value_data = array() ) {

	global $import;

	if( !$value_data )
		$value_data = $_POST['value_name'];
	if( $value_data ) {
		$csv_data = array();
		foreach( $value_data as $key => $value ) {
			if( isset( $import->csv_data[$key] ) )
				$csv_data[$value] = $import->csv_data[$key];
		}
	}
	unset( $import->csv_data );

	$import->rows = 0;
	if( woo_pd_validate_columns( $csv_data ) ) {
		$import->cancel_import = true;
		$import->log .= ' ' . __( 'import file column validation failed', 'woocommerce-product-importer' );
		$import->log .= "<br /><br />" . __( 'Import cancelled', 'woocommerce-product-importer' );
		unset( $csv_data );
		return;
	} else {
		$import->log .= ' ' . __( 'sufficient data was provided', 'woocommerce-product-importer' );
		$import->log .= "<br />" . __( 'Beginning import...', 'woocommerce-product-importer' );
	}
	if( WOO_PD_DEBUG == true )
		$import->log .= "<br /><br />*** " . __( 'PID debugging mode is enabled, no record changes will be made till WOO_PD_DEBUG is de-activated from product-importer-deluxe.php on line #22', 'woocommerce-product-importer' ) . " ***";

	$import->log .= "<br /><br />" . __( 'Detect and group Product columns...', 'woocommerce-product-importer' );

	$import->headers = array();
	if( isset( $csv_data['id'] ) ) {
		$import->headers[] = 'id';
		$count = count( $csv_data['id'] );
		$import->csv_id = array_filter( $csv_data['id'], 'mb_strlen' );
		$import->rows = count( $import->csv_id );
		// Check if the row count has adjusted since scrubbing the array
		if( $count > $import->rows ) {
			$import->rows = $count;
		}
		if( $import->advanced_log )
			$import->log .= "<br />>>> " . sprintf( __( 'Rows count set by Product ID: %d', 'woocommerce-product-importer' ), $import->rows );
		$import->log .= "<br />>>> " . __( 'Product ID has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['sku'] ) ) {
		$import->headers[] = 'sku';
		$count = count( $csv_data['sku'] );
		$import->csv_sku = array_filter( $csv_data['sku'], 'mb_strlen' );
		$import->rows = count( $import->csv_sku );
		// Check if the row count has adjusted since scrubbing the array
		if( $count > $import->rows ) {
			$import->rows = $count;
		}
		if( $import->advanced_log )
			$import->log .= "<br />>>> " . sprintf( __( 'Rows count set by SKU: %d', 'woocommerce-product-importer' ), $import->rows );
		$import->log .= "<br />>>> " . __( 'SKU has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['new_sku'] ) ) {
		$import->headers[] = 'new_sku';
		$count = count( $csv_data['new_sku'] );
		$import->csv_new_sku = array_filter( $csv_data['new_sku'], 'mb_strlen' );
		$import->rows = count( $import->csv_new_sku );
		// Check if the row count has adjusted since scrubbing the array
		if( $count > $import->rows ) {
			$import->rows = $count;
		}
		if( $import->advanced_log )
			$import->log .= "<br />>>> " . sprintf( __( 'Rows count set by SKU (Update): %d', 'woocommerce-product-importer' ), $import->rows );
		$import->log .= "<br />>>> " . __( 'SKU (Update) has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['name'] ) ) {
		$import->headers[] = 'name';
		$count = count( $csv_data['name'] );
		$import->csv_name = array_filter( $csv_data['name'], 'mb_strlen' );
		array_walk_recursive( $import->csv_name, 'woo_pd_prepare_columns_filter' );
		// Use Product ID or SKU row count if it is higher
		if( count( $import->csv_name ) > $import->rows ) {
			$import->rows = count( $import->csv_name );
			if( $import->advanced_log )
				$import->log .= "<br />>>> " . sprintf( __( 'Rows count set by Product Name: %d', 'woocommerce-product-importer' ), $import->rows );
		}
		$import->log .= "<br />>>> " . __( 'Product Name has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( $import->rows == 0 ) {
		$import->cancel_import = true;
		$import->failed_import = __( 'The Product ID, SKU or Product Name column depending on the import method chosen must be selected to initiate an import. Press \'Return to options screen\' and select one of these required columns.', 'woocommerce-product-importer' );
		woo_pd_error_log( sprintf( '%s: Error: %s', basename( woo_pd_get_option( 'csv' ) ), $import->failed_import ) );
	}
	if( isset( $csv_data['description'] ) ) {
		$import->headers[] = 'description';
		$import->csv_description = array_filter( $csv_data['description'] );
		array_walk_recursive( $import->csv_description, 'woo_pd_prepare_columns_filter' );
		$import->log .= "<br />>>> " . __( 'Description has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['excerpt'] ) ) {
		$import->headers[] = 'excerpt';
		$import->csv_excerpt = array_filter( $csv_data['excerpt'] );
		array_walk_recursive( $import->csv_excerpt, 'woo_pd_prepare_columns_filter' );
		$import->log .= "<br />>>> " . __( 'Excerpt has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['price'] ) ) {
		$import->headers[] = 'price';
		// Accept empty/null values for this field
		if( $import->import_method == 'update' )
			$import->csv_price = $csv_data['price'];
		else
			$import->csv_price = array_filter( $csv_data['price'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Price has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['sale_price'] ) ) {
		$import->headers[] = 'sale_price';
		// Accept empty/null values for this field
		if( $import->import_method == 'update' )
			$import->csv_sale_price = $csv_data['sale_price'];
		else
			$import->csv_sale_price = array_filter( $csv_data['sale_price'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Sale Price has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['sale_price_dates_from'] ) ) {
		$import->headers[] = 'sale_price_dates_from';
		if( $import->import_method == 'update' )
			$import->csv_sale_price_dates_from = $csv_data['sale_price_dates_from'];
		else
			$import->csv_sale_price_dates_from = array_filter( $csv_data['sale_price_dates_from'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Sale Price Dates From has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['sale_price_dates_to'] ) ) {
		$import->headers[] = 'sale_price_dates_to';
		if( $import->import_method == 'update' )
			$import->csv_sale_price_dates_to = $csv_data['sale_price_dates_to'];
		else
			$import->csv_sale_price_dates_to = array_filter( $csv_data['sale_price_dates_to'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Sale Price Dates To has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['slug'] ) ) {
		$import->headers[] = 'slug';
		$import->csv_slug = array_filter( $csv_data['slug'] );
		$import->log .= "<br />>>> " . __( 'Slug has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['post_parent'] ) ) {
		$import->headers[] = 'post_parent';
		$import->csv_post_parent = array_filter( $csv_data['post_parent'] );
		$import->log .= "<br />>>> " . __( 'Parent ID has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['post_parent_sku'] ) ) {
		$import->headers[] = 'post_parent_sku';
		$import->csv_post_parent_sku = array_filter( $csv_data['post_parent_sku'] );
		$import->log .= "<br />>>> " . __( 'Parent SKU has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['type'] ) ) {
		$import->headers[] = 'type';
		$import->csv_type = array_filter( $csv_data['type'] );
		$import->log .= "<br />>>> " . __( 'Type has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['featured'] ) ) {
		$import->headers[] = 'featured';
		$import->csv_featured = array_filter( $csv_data['featured'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Featured has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['virtual'] ) ) {
		$import->headers[] = 'virtual';
		$import->csv_virtual = array_filter( $csv_data['virtual'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Virtual has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['downloadable'] ) ) {
		$import->headers[] = 'downloadable';
		$import->csv_downloadable = array_filter( $csv_data['downloadable'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Downloadable has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['weight'] ) ) {
		$import->headers[] = 'weight';
		$import->csv_weight = array_filter( $csv_data['weight'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Weight has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['height'] ) ) {
		$import->headers[] = 'height';
		$import->csv_height = array_filter( $csv_data['height'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Height has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['width'] ) ) {
		$import->headers[] = 'width';
		$import->csv_width = array_filter( $csv_data['width'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Width has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['length'] ) ) {
		$import->headers[] = 'length';
		$import->csv_length = array_filter( $csv_data['length'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Length has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['post_date'] ) ) {
		$import->headers[] = 'post_date';
		$import->csv_post_date = array_filter( $csv_data['post_date'] );
		$import->log .= "<br />>>> " . __( 'Product Date has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['post_modified'] ) ) {
		$import->headers[] = 'post_modified';
		$import->csv_post_modified = array_filter( $csv_data['post_modified'] );
		$import->log .= "<br />>>> " . __( 'Product Modified has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['image'] ) ) {
		$import->headers[] = 'image';
		$import->csv_image = array_filter( $csv_data['image'] );
		$import->log .= "<br />>>> " . __( 'Featured Image has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['image_nuke'] ) ) {
		$import->headers[] = 'image_nuke';
		$import->csv_image_nuke = array_filter( $csv_data['image_nuke'] );
		$import->log .= "<br />>>> " . __( 'Clear Featured Image has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['featured_image_title'] ) ) {
		$import->headers[] = 'featured_image_title';
		$import->csv_featured_image_title = array_filter( $csv_data['featured_image_title'] );
		$import->log .= "<br />>>> " . __( 'Featured Image Title has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['featured_image_caption'] ) ) {
		$import->headers[] = 'featured_image_caption';
		$import->csv_featured_image_caption = array_filter( $csv_data['featured_image_caption'] );
		$import->log .= "<br />>>> " . __( 'Featured Image Caption has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['featured_image_alt_text'] ) ) {
		$import->headers[] = 'featured_image_alt_text';
		$import->csv_featured_image_alt_text = array_filter( $csv_data['featured_image_alt_text'] );
		$import->log .= "<br />>>> " . __( 'Featured Image Alternative Text has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['featured_image_description'] ) ) {
		$import->headers[] = 'featured_image_description';
		$import->csv_featured_image_description = array_filter( $csv_data['featured_image_description'] );
		$import->log .= "<br />>>> " . __( 'Featured Image Description has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['product_gallery'] ) ) {
		$import->headers[] = 'product_gallery';
		$import->csv_product_gallery = array_filter( $csv_data['product_gallery'] );
		$import->log .= "<br />>>> " . __( 'Product Gallery has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['product_gallery_nuke'] ) ) {
		$import->headers[] = 'product_gallery_nuke';
		$import->csv_product_gallery_nuke = array_filter( $csv_data['product_gallery_nuke'] );
		$import->log .= "<br />>>> " . __( 'Clear Product Gallery has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['image_product_gallery_nuke'] ) ) {
		$import->headers[] = 'image_product_gallery_nuke';
		$import->csv_image_product_gallery_nuke = array_filter( $csv_data['image_product_gallery_nuke'] );
		$import->log .= "<br />>>> " . __( 'Clear Featured Image & Product Gallery has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['category'] ) ) {
		$import->headers[] = 'category';
		$import->csv_category = array_filter( $csv_data['category'] );
		$import->log .= "<br />>>> " . __( 'Category has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['category_1'] ) ) {
		$import->headers[] = 'category_1';
		$import->csv_category_1 = array_filter( $csv_data['category_1'] );
		$import->log .= "<br />>>> " . __( 'Category > Child has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['category_2'] ) ) {
		$import->headers[] = 'category_2';
		$import->csv_category_2 = array_filter( $csv_data['category_2'] );
		$import->log .= "<br />>>> " . __( 'Category > Child > Child has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['category_3'] ) ) {
		$import->headers[] = 'category_3';
		$import->csv_category_3 = array_filter( $csv_data['category_3'] );
		$import->log .= "<br />>>> " . __( 'Category > Child > Child > Child has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['tag'] ) ) {
		$import->headers[] = 'tag';
		$import->csv_tag = array_filter( $csv_data['tag'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Tag has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['shipping_class'] ) ) {
		$import->headers[] = 'shipping_class';
		$import->csv_shipping_class = array_filter( $csv_data['shipping_class'] );
		$import->log .= "<br />>>> " . __( 'Shipping Class has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['vendor'] ) ) {
		$import->headers[] = 'vendor';
		$import->csv_vendor = array_filter( $csv_data['vendor'] );
		$import->log .= "<br />>>> " . __( 'Product Vendor has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['tax_status'] ) ) {
		$import->headers[] = 'tax_status';
		$import->csv_tax_status = array_filter( $csv_data['tax_status'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Tax Status has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['tax_class'] ) ) {
		$import->headers[] = 'tax_class';
		$import->csv_tax_class = array_filter( $csv_data['tax_class'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Tax Class has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['manage_stock'] ) ) {
		$import->headers[] = 'manage_stock';
		$import->csv_manage_stock = array_filter( $csv_data['manage_stock'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Manage Stock has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['stock_status'] ) ) {
		$import->headers[] = 'stock_status';
		$import->csv_stock_status = array_filter( $csv_data['stock_status'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Stock Status has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['quantity'] ) ) {
		$import->headers[] = 'quantity';
		$import->csv_quantity = array_filter( $csv_data['quantity'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Quantity has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['allow_backorders'] ) ) {
		$import->headers[] = 'allow_backorders';
		$import->csv_allow_backorders = array_filter( $csv_data['allow_backorders'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Allow Backorders has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['sold_individually'] ) ) {
		$import->headers[] = 'sold_individually';
		$import->csv_sold_individually = array_filter( $csv_data['sold_individually'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Sold Individually has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['upsells'] ) ) {
		$import->headers[] = 'upsells';
		$import->csv_upsells = array_filter( $csv_data['upsells'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Up-Sells has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['crosssells'] ) ) {
		$import->headers[] = 'crosssells';
		$import->csv_crosssells = array_filter( $csv_data['crosssells'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Cross-Sells has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['sort'] ) ) {
		$import->headers[] = 'sort';
		$import->csv_sort = array_filter( $csv_data['sort'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Sort Order has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['download_file_name'] ) ) {
		$import->headers[] = 'download_file_name';
		$import->csv_download_file_name = array_filter( $csv_data['download_file_name'] );
		$import->log .= "<br />>>> " . __( 'Download File Name has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['download_file_url'] ) ) {
		$import->headers[] = 'download_file_url';
		$import->csv_download_file_url = array_filter( $csv_data['download_file_url'] );
		$import->log .= "<br />>>> " . __( 'Download File URL Path has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['download_limit'] ) ) {
		$import->headers[] = 'download_limit';
		$import->csv_download_limit = array_filter( $csv_data['download_limit'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Download Limit has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['product_url'] ) ) {
		$import->headers[] = 'product_url';
		$import->csv_product_url = array_filter( $csv_data['product_url'] );
		$import->log .= "<br />>>> " . __( 'Product URL has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['button_text'] ) ) {
		$import->headers[] = 'button_text';
		$import->csv_button_text = array_filter( $csv_data['button_text'] );
		$import->log .= "<br />>>> " . __( 'Button Text has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['visibility'] ) ) {
		$import->headers[] = 'visibility';
		$import->csv_visibility = array_filter( $csv_data['visibility'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Visibility has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['status'] ) ) {
		$import->headers[] = 'status';
		$import->csv_status = array_filter( $csv_data['status'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Product Status has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['comment_status'] ) ) {
		$import->headers[] = 'comment_status';
		$import->csv_comment_status = array_filter( $csv_data['comment_status'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Enable Reviews has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['purchase_note'] ) ) {
		$import->headers[] = 'purchase_note';
		$import->csv_purchase_note = array_filter( $csv_data['purchase_note'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Purchase Note has been detected and grouped', 'woocommerce-product-importer' );
	}
	if( isset( $csv_data['total_sales'] ) ) {
		$import->headers[] = 'total_sales';
		$import->csv_total_sales = array_filter( $csv_data['total_sales'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Total Sales has been detected and grouped', 'woocommerce-product-importer' );
	}

	// Product Attributes
	if( $import->attributes = woo_pd_get_product_attributes() ) {
		foreach( $import->attributes as $attribute ) {
			if( isset( $csv_data[sprintf( 'pa_%s', $attribute['name'] )] ) ) {
				$import->headers[] = sprintf( 'pa_%s', $attribute['name'] );
				$import->csv_attributes[$attribute['name']] = array_filter( $csv_data[sprintf( 'pa_%s', $attribute['name'] )] );
				$import->log .= "<br />>>> ". sprintf( __( 'Attribute: %s has been detected and grouped', 'woocommerce-product-importer' ), $attribute['label'] );
			}
		}
	}

	if( isset( $csv_data['default_attributes'] ) ) {
		$import->headers[] = 'default_attributes';
		$import->csv_default_attributes = array_filter( $csv_data['default_attributes'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Default Attributes has been detected and grouped', 'woocommerce-product-importer' );
	}

	// Allow Plugin/Theme authors to add support for additional import details
	$import = apply_filters( 'woo_pd_import_addons', $import, $csv_data );
	unset( $csv_data );

	return true;

}

function woo_pd_prepare_columns_filter( $var = null ) {

	$var = filter_var( $var, FILTER_SANITIZE_ENCODED );
	return $var;

}

// An early validation check of required columns based on the import method
function woo_pd_validate_columns( $csv_data = array() ) {

	global $import;

	$import_method = $import->import_method;
	$is_empty = ( empty( $csv_data ) ? true : false );
	$has_id = ( isset( $csv_data['id'] ) ? true : false );
	$has_name = ( isset( $csv_data['name'] ) ? true : false );
	$has_sku = ( isset( $csv_data['sku'] ) ? true : false );

	$status = false;
	$failed_reason = array();

	// 'new': Import new Products only
	// 'merge': Import new Products and merge Product changes
	// 'update': Merge Product changes only
	// 'delete': Delete matching Products

	if( $is_empty ) {
		$status = true;
		if( $import->columns == 1 )
			$failed_reason[] = __( 'Only a single column was detected, is the field delimiter set correctly?', 'woocommerce-product-importer' );
		else
			$failed_reason[] = __( 'Your CSV file upload has expired, re-upload it from the opening import screen', 'woocommerce-product-importer' );
	} else {
		if( in_array( $import_method, array( 'merge', 'update', 'delete' ) ) ) {
			// 'update': Merge Product changes only
			// 'delete': Delete matching Products
			if( !$has_id && !$has_sku ) {
				$status = true;
				// Override if import method is merge or delete
				if( in_array( $import_method, array( 'merge', 'delete' ) ) ) {
					// Create new Product - Requires either Product Name or SKU
					if( ( $has_name || $has_sku ) )
						$status = false;
				}
			}
		} else {
			// 'new': Import new Products only
			if( !$has_name || !$has_sku ) {
				$status = true;
				if( ( $has_name && !$has_sku ) || ( $has_sku && !$has_name ) )
					$status = false;
			}
		}
	}

	if( $status ) {
		if( in_array( $import_method, array( 'merge', 'update', 'delete' ) ) ) {
			// Merge details
			if( !$has_id && !$has_sku && in_array( $import_method, array( 'update', 'delete' ) ) )
				$failed_reason[] = __( 'No SKU was provided. The SKU column is required for the update, merge or delete import methods', 'woocommerce-product-importer' );
			else if( !$has_name )
				$failed_reason[] = __( 'No Product Name was provided', 'woocommerce-product-importer' );
		} else {
			// Create new Product
			if( !$has_sku )
				$failed_reason[] = __( 'No SKU was provided', 'woocommerce-product-importer' );
			if( !$has_name )
				$failed_reason[] = __( 'No Product Name was provided', 'woocommerce-product-importer' );
		}
		if( empty( $failed_reason ) )
			$failed_reason[] = __( 'No specific reason was given for why the provided columns from this import file could not be validated.<br /><br />This is not a normal behaviour and means that our import column validator failed for an unknown reason, please raise this as a Premium Support issue with our team who will be able to determine what went wrong and get your imports up and running :)', 'woocommerce-product-importer' );
		$size = ( count( $failed_reason ) - 1 );
		for( $i = 0; $i <= $size; $i++ ) {
			if( $failed_reason[$i] ) {
				$import->loading_text = __( 'Import validation failed', 'woocommerce-product-importer' );
				$import->failed_import = sprintf( __( 'Import validation issue: %s', 'woocommerce-product-importer' ), $failed_reason[$i] );
				woo_pd_error_log( sprintf( '%s: Error: %s', basename( woo_pd_get_option( 'csv' ) ), $import->failed_import ) );
			}
		}
		return true;
	}

}

function woo_pd_upload_directories() {

	global $import;

	$upload_dir = wp_upload_dir();
	$import->uploads_path = woo_pd_format_path( sprintf( '%s/', $upload_dir['path'] ) );
	$import->uploads_basedir = woo_pd_format_path( sprintf( '%s/', $upload_dir['basedir'] ) );
	$import->uploads_subdir = woo_pd_format_path( $upload_dir['subdir'] );
	$import->uploads_url = sprintf( '%s/', $upload_dir['baseurl'] );
	$import->date_directory = ( get_option( 'uploads_use_yearmonth_folders', 0 ) ? date( 'Y/m/', strtotime( current_time( 'mysql' ) ) ) : false );

}

function woo_pd_force_update_post( $post_id = 0, $column = '', $value = '' ) {

	global $wpdb;

	if( $post_id && !empty( $column ) ) {
		$wpdb->show_errors = true;
		$response = $wpdb->update( $wpdb->posts, array(
			($column) => $value
		), array( 'ID' => $post_id ), array(
			'%s'
		) );
		if( $response !== false )
			return true;
	}

}

function woo_pd_get_filename( $filename = '', $filetype = 'image' ) {

	$output = '';
	if( $filename ) {
		// Check for an Attachment ID
		if( is_numeric( $filename ) ) {
			$output = get_attached_file( $filename );
			if( !empty( $output ) ) {
				// Return just the filename
				$output = basename( $output );
			}
		} else {
			// We're likely dealing with a dynamic external URL
			if( strpos( $filename, '?' ) && strpos( $filename, '=' ) ) {
				$file_data = parse_url( $filename );
				$output = substr( $file_data['query'], ( strpos( $file_data['query'], '=' ) + 1 ), 100 );
			} else if( strpos( $filename, '/' ) == false ) {
				$output = $filename;
			} else {
				$output = substr( $filename, strrpos( $filename, '/' ) + 1, strlen( $filename ) - strrpos( $filename, '/' ) );
			}
		}
		// Check if filename has a file extension
		if( !empty( $output ) && ( strpos( $output, '.' ) === false ) ) {
			switch( $filetype ) {

				case 'image':
					$output .= '.jpg';
					break;

			}
		}
	}
	return $output;

}

// Check if a file exists at the given URL, also checks for local WordPress filepath
function woo_pd_http_file_exists( $url = '' ) {

	// Allow Allow Plugin/Theme authors to force accept URL's as is
	if( apply_filters( 'woo_pd_http_file_exists_force_exists', false ) )
		return true;

	// Make consistant
	$site_url = trailingslashit( str_replace( 'www.', '', site_url() ) );
	$url = str_replace( 'www.', '', $url );

	// Same host
	if( strstr( $url, $site_url ) && apply_filters( 'woo_pd_http_file_exists_same_host', true ) ) {
		$url = str_replace( $site_url, ABSPATH, $url );
		if( file_exists( $url ) ) {
			return true;
		} else {
			$message = sprintf( __( 'file_exists() returned false checking for image file at %s', 'woocommerce-product-importer' ), $url );
			woo_pd_error_log( sprintf( '%s: Warning: %s', basename( woo_pd_get_option( 'csv' ) ), $message ) );
			return false;
		}
	} else {
		$args = array(
			'sslverify' => false,
			'timeout' => 20,
			'user-agent' => 'Product Importer Deluxe'
		);

		// Allow Plugin/Theme authors to override the wp_remote_head() args
		$args = apply_filters( 'woo_pd_http_file_exists_args', $args, $url );

		$response = wp_remote_head( $url, $args );
		if( is_wp_error( $response ) ) {
			$error_string = $response->get_error_message();
			$message = sprintf( __( 'wp_remote_head() returned false checking for image file at %s, reason: %s', 'woocommerce-product-importer' ), $url, $error_string );
			woo_pd_error_log( sprintf( '%s: Warning: %s', basename( woo_pd_get_option( 'csv' ) ), $message ) );
			return false;
		} else {
			// Check for 404's and 301's that can slip through
			if( isset( $response['response']['code'] ) ) {

				// Allow Plugin/Theme authors to override the default error codes
				$response_codes = apply_filters( 'woo_pd_http_file_exists_response_codes', array( 301, 404 ), $url );

				if( in_array( $response['response']['code'], $response_codes ) ) {
					$message = sprintf( __( 'wp_remote_head() returned true but we detected a %s response code checking for image file at %s', 'woocommerce-product-importer' ),  $response['response']['code'], $url );
					woo_pd_error_log( sprintf( '%s: Warning: %s', basename( woo_pd_get_option( 'csv' ) ), $message ) );
					return false;
				}

			}
			return true;
		}
	}

}

function woo_pd_detect_file_delimiter( $row = '' ) {

	$delimiters = array(
		'semicolon' => ";",
		'tab'       => "\t",
		'comma'     => ",",
	);
	$count = array();
	foreach( $delimiters as $key => $delimiter )
		$count[$key] = substr_count( $row, $delimiter );
	arsort( $count );
	reset( $count );
	$first_key = key( $count );
	return $delimiters[$first_key]; 

}

function woo_pd_detect_image_method() {

	global $import;

	$import->image_method = '';
	$import->image_filename_method = 'uploads';
	$import->duplicate_image_method = woo_pd_get_option( 'duplicate_image_method', 'new' );
	if( !$import->duplicate_image_method )
		$import->duplicate_image_method = 'new';
	for( $i = 0; $i < $import->options_size; $i++ ) {
		if( isset( $import->csv_data[$i] ) ) {
			if( $import->options[$i]['name'] == $import->csv_data[$i][0] )
				$import->skip_first = true;
			// Check for Featured Image column
			if( strpos( strtolower( $import->csv_data[$i][0] ), 'image' ) !== false ) {
				$needle = $i;
				break;
			}
			// Check for Product Gallery column
			if( strpos( strtolower( $import->csv_data[$i][0] ), 'gallery' ) !== false ) {
				$needle = $i;
				break;
			}
		}
	}
	if( isset( $needle ) ) {
		if( $import->skip_first )
			$i = '1';
		else
			$i = '0';
		if( $import->csv_data[$needle][$i] ) {
			if( strstr( $import->csv_data[$needle][$i], 'http' ) )
				$import->image_method = 'external';
			else
				$import->image_method = 'csv';
		}
	}
	if( !empty( $import->image_method ) && $import->advanced_log ) {
		if( isset( $import->log ) == false )
			$import->log = '';
		$import->log .= '<br />' . sprintf( __( 'Detected image import method: %s...', 'woocommerce-product-importer' ), ( !empty( $import->image_method ) ? $import->image_method : 'none' ) );
	}

}

// Deletes the temporary CSV file used at import time
function woo_pd_delete_file() {

	global $import;

	switch( $import->delete_file ) {

		case '1':
			// Delete CSV from /wp-content/uploads/
			if( $file = woo_pd_get_option( 'csv' ) ) {
				if( file_exists( $file ) )
					@unlink( $file );
			}
			if( $import->advanced_log )
				$import->log .= "<br /><br />" . __( 'Temporary CSV deleted', 'woocommerce-product-importer' );
			break;

		case '0':
		default:
			// Add CSV to Past Imports
			if( $file = woo_pd_get_option( 'csv' ) )
				woo_pd_add_past_import( $file );
			break;

	}
	woo_pd_update_option( 'csv', '' );

}

function woo_pd_wp_image_memory_limit( $memory_limit ) {

	$page = $_SERVER['SCRIPT_NAME'];
	if( isset( $_POST['action'] ) )
		$action = $_POST['action'];
	elseif( isset( $_GET['action'] ) )
		$action = $_GET['action'];
	else
		$action = '';

	$allowed_actions = array( 'product_importer', 'finish_import', 'upload_image' );

	if( $page == '/wp-admin/admin-ajax.php' && in_array( $action, $allowed_actions ) )
		$memory_limit = '256M';
	return $memory_limit;

}
add_filter( 'image_memory_limit', 'woo_pd_wp_image_memory_limit' );

if( !function_exists( 'str_getcsv' ) ) {

	function str_getcsv( $input, $delimiter = ",", $enclosure = '"', $escape = "\\" ) {

		$fp = fopen( "php://memory", 'r+' );
		fputs( $fp, $input );
		rewind( $fp );
		$data = fgetcsv( $fp, null, $delimiter, $enclosure ); // $escape only got added in 5.3.0
		fclose( $fp );
		return $data;

	}

}

// Returns the current memory usage at that moment
function woo_pd_current_memory_usage( $echo = false ) {

	$output = sprintf( '%d Mb / %d Mb', round( memory_get_usage( true ) / 1024 / 1024, 2 ), (int)ini_get( 'memory_limit' ) );
	if( $echo )
		echo $output;
	else
		return $output;

}

// Provided by Pippin Williamson, mentioned on WP Beginner (http://www.wpbeginner.com/wp-tutorials/how-to-display-a-users-ip-address-in-wordpress/)
function woo_pd_get_visitor_ip_address() {

	if( !empty( $_SERVER['HTTP_CLIENT_IP'] ) ) {
		//check ip from share internet
		$ip = $_SERVER['HTTP_CLIENT_IP'];
	} elseif ( ! empty( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ) {
		//to check ip is pass from proxy
		$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
	} else {
		$ip = $_SERVER['REMOTE_ADDR'];
	}
	return apply_filters( 'woo_pd_get_visitor_ip_address', $ip );

}

function woo_pd_strposa( $haystack, $needles = array(), $offset = 0 ) {

	$chr = array();
	foreach( $needles as $needle ) {
		$res = strpos( $haystack, $needle, $offset );
		if( $res !== false )
			$chr[$needle] = $res;
	}
	if( empty( $chr ) )
		return false;
	return min( $chr );

}

// Return whether WPML exists
function woo_pd_detect_wpml() {

	if( defined( 'ICL_LANGUAGE_CODE' ) )
		return true;

}

function woo_pd_enable_wpml_api_access() {

	// Check the User has the manage_woocommerce_products capability
	if( current_user_can( 'manage_woocommerce' ) == false )
		return;

	// We need to enable WPML API support as soon as possible
	if( !defined( 'WPML_LOAD_API_SUPPORT' ) )
		define('WPML_LOAD_API_SUPPORT', true);

}
add_action( 'wpml_before_init', 'woo_pd_enable_wpml_api_access' );

// List of WordPress Plugins that Product Importer Deluxe integrates with
function woo_pd_modules_list( $module_status = false ) {

	$modules = array();
	$modules[] = array(
		'name' => 'aioseop',
		'title' => __( 'All in One SEO Pack', 'woocommerce-product-importer' ),
		'description' => __( 'Optimize your WooCommerce Products for Search Engines. Requires Store Toolkit for All in One SEO Pack integration.', 'woocommerce-product-importer' ),
		'url' => 'http://wordpress.org/extend/plugins/all-in-one-seo-pack/',
		'slug' => 'all-in-one-seo-pack',
		'function' => array( 'aioseop_activate', 'aioseop_get_version' )
	);
	$modules[] = array(
		'name' => 'wc_brands',
		'title' => __( 'WooCommerce Brands Addon', 'woocommerce-product-importer' ),
		'description' => __( 'Create, assign and list brands for products, and allow customers to filter by brand.', 'woocommerce-product-importer' ),
		'url' => 'http://www.woothemes.com/products/brands/',
		'class' => 'WC_Brands'
	);
	$modules[] = array(
		'name' => 'vendors',
		'title' => __( 'Product Vendors', 'woocommerce-product-importer' ),
		'description' => __( 'Turn your store into a multi-vendor marketplace (such as Etsy or Creative Market).', 'woocommerce-product-importer' ),
		'url' => 'http://www.woothemes.com/products/product-vendors/',
		'class' => 'WooCommerce_Product_Vendors'
	);
	$modules[] = array(
		'name' => 'store_toolkit',
		'title' => __( 'Store Toolkit', 'woocommerce-product-importer' ),
		'description' => __( 'Store Toolkit includes a growing set of commonly-used WooCommerce administration tools aimed at web developers and store maintainers.', 'woocommerce-product-importer' ),
		'url' => 'http://wordpress.org/extend/plugins/woocommerce-store-toolkit/',
		'slug' => 'woocommerce-store-toolkit',
		'function' => 'woo_st_admin_init'
	);
	$modules[] = array(
		'name' => 'ultimate_seo',
		'title' => __( 'SEO Ultimate', 'woocommerce-product-importer' ),
		'description' => __( 'This all-in-one SEO plugin gives you control over Product details.', 'woocommerce-product-importer' ),
		'url' => 'http://wordpress.org/extend/plugins/seo-ultimate/',
		'slug' => 'seo-ultimate',
		'function' => 'su_wp_incompat_notice'
	);
	$modules[] = array(
		'name' => 'gpf',
		'title' => __( 'Advanced Google Product Feed', 'woocommerce-product-importer' ),
		'description' => __( 'Easily configure data to be added to your Google Merchant Centre feed.', 'woocommerce-product-importer' ),
		'url' => 'http://www.leewillis.co.uk/wordpress-plugins/',
		'function' => 'woocommerce_gpf_install'
	);
	$modules[] = array(
		'name' => 'wpseo',
		'title' => __( 'WordPress SEO by Yoast', 'woocommerce-product-importer' ),
		'description' => __( 'The first true all-in-one SEO solution for WordPress.', 'woocommerce-product-importer' ),
		'url' => 'http://yoast.com/wordpress/seo/#utm_source=wpadmin&utm_medium=plugin&utm_campaign=wpseoplugin',
		'slug' => 'wordpress-seo',
		'function' => 'wpseo_admin_init'
	);
	$modules[] = array(
		'name' => 'wc_cog',
		'title' => __( 'Cost of Goods', 'woocommerce-product-importer' ),
		'description' => __( 'Easily track total profit and cost of goods by adding a Cost of Good field to simple and variable products.', 'woocommerce-product-importer' ),
		'url' => 'http://www.skyverge.com/product/woocommerce-cost-of-goods-tracking/',
		'class' => 'WC_COG'
	);
	$modules[] = array(
		'name' => 'wc_msrp',
		'title' => __( 'MSRP Pricing', 'woocommerce-product-importer' ),
		'description' => __( 'Define and display MSRP prices (Manufacturer\'s suggested retail price) to your customers.', 'woocommerce-product-importer' ),
		'url' => 'http://www.woothemes.com/products/msrp-pricing/',
		'function' => 'woocommerce_msrp_activate'
	);
	$modules[] = array(
		'name' => 'woocommerce_brands',
		'title' => __( 'WooCommerce Brands', 'woocommerce-product-importer' ),
		'description' => __( 'Woocommerce Brands Plugin. After Install and active this plugin you\'ll have some shortcode and some widget for display your brands in fornt-end website.', 'woocommerce-product-importer' ),
		'url' => 'http://proword.net/Woocommerce_Brands/',
		'class' => 'woo_brands'
	);
	$modules[] = array(
		'name' => 'woocommerce_bookings',
		'title' => __( 'WooCommerce Bookings', 'woocommerce-product-importer' ),
		'description' => __( 'Setup bookable products such as for reservations, services and hires.', 'woocommerce-product-importer' ),
		'url' => 'http://www.woothemes.com/products/woocommerce-bookings/',
		'class' => 'WC_Bookings'
	);
	$modules[] = array(
		'name' => 'wc_posr',
		'title' => __( 'WooCommerce Profit of Sales Report', 'woocommerce-product-importer' ),
		'description' => __( 'This plugin provides Profit of Sales Report based on Cost of Goods.', 'woocommerce-product-importer' ),
		'url' => 'http://codecanyon.net/item/woocommerce-profit-of-sales-report/9190590',
		'function' => 'POSRFront'
	);
	$modules[] = array(
		'name' => 'yith_brands_pro',
		'title' => __( 'YITH WooCommerce Brands Add-On', 'woocommerce-product-importer' ),
		'description' => __( 'YITH WooCommerce Brands Add-on allows you to add brands functionality to the default WooCommerce Plugin.', 'woocommerce-product-importer' ),
		'url' => 'http://yithemes.com/themes/plugins/yith-woocommerce-brands-add-on/',
		'function' => 'yith_brands_constructor'
	);
	$modules[] = array(
		'name' => 'wc_customfields',
		'title' => __( 'WooCommerce Custom Fields', 'woocommerce-product-importer' ),
		'description' => __( 'Create custom fields for WooCommerce product, checkout, order and customer pages.', 'woocommerce-product-importer' ),
		'url' => 'http://www.rightpress.net/woocommerce-custom-fields',
		'class' => array( 'RP_WCCF', 'WCCF' )
	);
	$modules[] = array(
		'name' => 'subscriptions',
		'title' => __( 'WooCommerce Subscriptions', 'woocommerce-product-importer' ),
		'description' => __( 'WC Subscriptions makes it easy to create and manage products with recurring payments.', 'woocommerce-product-importer' ),
		'url' => 'http://www.woothemes.com/products/woocommerce-subscriptions/',
		'class' => array( 'WC_Subscriptions', 'WC_Subscriptions_Manager' )
	);
	$modules[] = array(
		'name' => 'wc_umcs',
		'title' => __( 'WooCommerce Ultimate Multi Currency Suite', 'woocommerce-product-importer' ),
		'description' => __( 'Multi currency e-commerce plugin for WordPress-WooCommerce systems.', 'woocommerce-product-importer' ),
		'url' => 'https://codecanyon.net/item/woocommerce-ultimate-multi-currency-suite/11997014',
		'class' => 'WooCommerce_Ultimate_Multi_Currency_Suite_Main'
	);
	$modules[] = array(
		'name' => 'wpml',
		'title' => __( 'WPML Multilingual CMS', 'woocommerce-product-importer' ),
		'description' => __( 'WPML Multilingual CMS.', 'woocommerce-product-importer' ),
		'url' => 'https://wpml.org/',
		'function' => 'icl_sitepress_activate'
	);
	$modules[] = array(
		'name' => 'wpml_wc',
		'title' => __( 'WooCommerce Multilingual', 'woocommerce-product-importer' ),
		'description' => __( 'Allows running fully multilingual e-Commerce sites with WooCommerce and WPML.', 'woocommerce-product-importer' ),
		'url' => 'https://wordpress.org/plugins/woocommerce-multilingual/',
		'slug' => 'woocommerce-multilingual',
		'function' => 'wpml_wcml_startup'
	);
	$modules[] = array(
		'name' => 'wc_wholesale_prices',
		'title' => __( 'WooCommerce Wholesale Prices', 'woocommerce-product-importer' ),
		'description' => __( 'WooCommerce Extension to provide Wholesale Prices functionality.', 'woocommerce-product-importer' ),
		'url' => 'https://wordpress.org/plugins/woocommerce-wholesale-prices/',
		'slug' => 'woocommerce-wholesale-prices',
		'function' => 'wwp_global_plugin_deactivate'
	);
	$modules[] = array(
		'name' => 'wc_show_single_variations',
		'title' => __( 'WooCommerce Show Single Variations', 'woocommerce-product-importer' ),
		'description' => __( 'Show product variations in the main product loops.', 'woocommerce-product-importer' ),
		'url' => 'https://codecanyon.net/item/woocommerce-show-single-variations/13523915',
		'class' => 'JCK_WSSV'
	);
	$modules[] = array(
		'name' => 'wc_tabmanager',
		'title' => __( 'WooCommerce Tab Manager', 'woocommerce-product-importer' ),
		'description' => __( 'A product tab manager for WooCommerce.', 'woocommerce-product-importer' ),
		'url' => 'http://www.woothemes.com/products/woocommerce-tab-manager/',
		'class' => 'WC_Tab_Manager'
	);

/*
	$modules[] = array(
		'name' => '',
		'title' => __( '', 'woocommerce-product-importer' ),
		'description' => __( '', 'woocommerce-product-importer' ),
		'url' => '',
		'slug' => '', // Define this if the Plugin is hosted on the WordPress repo
		'function' => '' // Define this for function detection, if Class rename attribute to class
	);
*/

	$modules = apply_filters( 'woo_pd_modules_addons', $modules );

	// Check if the existing Transient exists
	$modules_all = count( $modules );
	$cached = get_transient( WOO_PD_PREFIX . '_modules_all_count' );
	if( $cached == false ) {
		set_transient( WOO_PD_PREFIX . '_modules_all_count', $modules_all, DAY_IN_SECONDS );
	}

	$modules_active = 0;
	$modules_inactive = 0;

	if( !empty( $modules ) ) {
		$user_capability = 'install_plugins';
		foreach( $modules as $key => $module ) {
			$modules[$key]['status'] = 'inactive';
			// Check if each module is activated
			if( isset( $module['function'] ) ) {
				if( is_array( $module['function'] ) ) {
					$size = count( $module['function'] );
					for( $i = 0; $i < $size; $i++ ) {
						if( function_exists( $module['function'][$i] ) ) {
							$modules[$key]['status'] = 'active';
							$modules_active++;
							break;
						}
					}
				} else {
					if( function_exists( $module['function'] ) ) {
						$modules[$key]['status'] = 'active';
						$modules_active++;
					}
				}
			} else if( isset( $module['class'] ) ) {
				if( is_array( $module['class'] ) ) {
					$size = count( $module['class'] );
					for( $i = 0; $i < $size; $i++ ) {
						if( class_exists( $module['class'][$i] ) ) {
							$modules[$key]['status'] = 'active';
							$modules_active++;
							break;
						}
					}
				} else {
					if( class_exists( $module['class'] ) ) {
						$modules[$key]['status'] = 'active';
						$modules_active++;
					}
				}
			}
			// Filter Modules by Module Status
			if( !empty( $module_status ) ) {
				switch( $module_status ) {

					case 'active':
						if( $modules[$key]['status'] == 'inactive' )
							unset( $modules[$key] );
						break;

					case 'inactive':
						if( $modules[$key]['status'] == 'active' )
							unset( $modules[$key] );
						break;

				}
			}
			// Check that we've got these resources available
			if( isset( $modules[$key] ) && function_exists( 'current_user_can' ) && did_action( 'init' ) ) {
				// Check if the Plugin has a slug and if User can install Plugins
				if( current_user_can( $user_capability ) && isset( $module['slug'] ) )
					$modules[$key]['url'] = admin_url( sprintf( 'plugin-install.php?tab=search&type=term&s=%s', $module['slug'] ) );
			}
		}
	}

	// Check if the existing Transient exists
	$cached = get_transient( WOO_PD_PREFIX . '_modules_active_count' );
	if( $cached == false ) {
		set_transient( WOO_PD_PREFIX . '_modules_active_count', $modules_active, DAY_IN_SECONDS );
	}

	// Check if the existing Transient exists
	$cached = get_transient( WOO_PD_PREFIX . '_modules_inactive_count' );
	if( $cached == false ) {
		$modules_inactive = $modules_all - $modules_active;
		set_transient( WOO_PD_PREFIX . '_modules_inactive_count', $modules_inactive, DAY_IN_SECONDS );
	}

	return $modules;

}

// Returns whether a supported import Plugin is activated
function woo_pd_detect_import_plugin( $plugin_name = '' ) {

	if( empty( $plugin_name ) )
		return;

	// Check if a cached list of active modules is available
	if ( false === ( $active_modules = get_transient( WOO_PD_PREFIX . '_modules_active' ) ) ) {
		$active_modules = woo_pd_refresh_active_import_plugins();
	}

	// Check if the requested Plugin is in the list of active import Plugins
	if( !empty( $active_modules ) ) {
		if( in_array( $plugin_name, $active_modules ) )
			return true;
	}

}

function woo_pd_refresh_active_import_plugins() {

	// Delete the existing count Transients
	delete_transient( WOO_PD_PREFIX . '_modules_all_count' );
	delete_transient( WOO_PD_PREFIX . '_modules_active_count' );
	delete_transient( WOO_PD_PREFIX . '_modules_inactive_count' );

	// Refresh the count Transients
	$modules = woo_pd_modules_list( 'active' );

	// Create a list of active import Plugins
	$active_modules = false;
	if( !empty( $modules ) ) {
		$active_modules = array();
		foreach( $modules as $module )
			$active_modules[] = $module['name'];
	}
	unset( $modules );

	// Save the list of active import Plugins
	set_transient( WOO_PD_PREFIX . '_modules_active', $active_modules, DAY_IN_SECONDS );

	return $active_modules;

}

function woo_pd_display_time_elapsed( $from = 0, $to = 0, $output = '-' ) {

	if( $from && $to ) {
		$output = __( '1 second', 'woocommerce-product-importer' );
		$time = $to - $from;
		$tokens = array (
			31536000 => __( 'year', 'woocommerce-product-importer' ),
			2592000 => __( 'month', 'woocommerce-product-importer' ),
			604800 => __( 'week', 'woocommerce-product-importer' ),
			86400 => __( 'day', 'woocommerce-product-importer' ),
			3600 => __( 'hour', 'woocommerce-product-importer' ),
			60 => __( 'minute', 'woocommerce-product-importer' ),
			1 => __( 'second', 'woocommerce-product-importer' )
		);
		foreach ($tokens as $unit => $text) {
			if ($time < $unit) continue;
			$numberOfUnits = floor($time / $unit);
			$output = $numberOfUnits . ' ' . $text . ( ( $numberOfUnits > 1 ) ? 's' : '' );
		}
	}
	return $output;

}

function woo_pd_error_log( $message = '' ) {

	if( $message == '' )
		return;

	if( class_exists( 'WC_Logger' ) ) {
		$logger = new WC_Logger();
		$logger->add( WOO_PD_PREFIX, $message );
		return true;
	} else {
		// Fallback where the WooCommerce logging engine is unavailable
		error_log( sprintf( '[product-importer-deluxe] %s', $message ) );
	}

}

function woo_pd_get_option( $option = null, $default = false ) {

	$output = '';
	if( isset( $option ) ) {
		$separator = '_';
		$output = get_option( WOO_PD_PREFIX . $separator . $option, $default );
	}
	return $output;

}

function woo_pd_update_option( $option = null, $value = null ) {

	$output = false;
	if( isset( $option ) && isset( $value ) ) {
		$separator = '_';
		$output = update_option( WOO_PD_PREFIX . $separator . $option, $value );
	}
	return $output;

}
?>