<?php
// De-activate Product Importer to limit conflicts
function woo_pd_deactivate_pi() {

	$plugins = array(
		'woocommerce-product-importer/product-importer.php'
	);
	deactivate_plugins( $plugins, true );

}

function woo_pd_install() {

	woo_pd_create_options();

}

// Trigger the creation of Admin options for this Plugin
function woo_pd_create_options() {

	$prefix = 'woo_pd';

	if( !get_option( $prefix . '_csv' ) )
		add_option( $prefix . '_csv', '' );
	if( !get_option( $prefix . '_delete_file' ) )
		add_option( $prefix . '_delete_file', 1 );
	if( !get_option( $prefix . '_past_imports' ) )
		add_option( $prefix . '_past_imports', array() );

}

// Detect Product Importer and other platform versions
function woo_pd_detect_pi() {

	include_once( ABSPATH . 'wp-admin/includes/plugin.php' );

	// Check if basic Product Importer is activated and running
	if( is_plugin_active( 'woocommerce-product-importer/product-importer.php' ) ) {

		// De-activate basic Product Importer
		woo_pd_deactivate_pi();

	}

}
?>