<?php
function woo_pd_product_fields() {

	global $import;

	$fields = array();
	$fields[] = array(
		'name' => 'post_parent',
		'label' => __( 'Parent ID', 'woocommerce-product-importer' ),
		'alias' => array( 'parent_id' )
	);
	$fields[] = array(
		'name' => 'post_parent_sku',
		'label' => __( 'Parent SKU', 'woocommerce-product-importer' ),
		'alias' => array( 'parent_sku' )
	);
	$fields[] = array(
		'name' => 'id',
		'label' => __( 'Product ID', 'woocommerce-product-importer' ),
		'alias' => array( 'product_id' )
	);
	$fields[] = array(
		'name' => 'sku',
		'label' => __( 'SKU', 'woocommerce-product-importer' ),
		'alias' => array( 'product_sku', 'product_number', 'code' )
	);
	if( woo_pd_get_product_count() ) {
		$fields[] = array(
			'name' => 'new_sku',
			'label' => __( 'SKU (Update)', 'woocommerce-product-importer' )
		);
	}
	$fields[] = array(
		'name' => 'name',
		'label' => __( 'Product Name', 'woocommerce-product-importer' ),
		'alias' => array( 'product_name', 'product_title', 'title' )
	);
	$fields[] = array(
		'name' => 'description',
		'label' => __( 'Description', 'woocommerce-product-importer' ),
		'alias' => array( 'long_description', 'product_description', 'post_content', 'description' )
	);
	$fields[] = array(
		'name' => 'excerpt',
		'label' => __( 'Excerpt', 'woocommerce-product-importer' ),
		'alias' => array( 'additional', 'additional_description', 'short_description', 'post_excerpt' )
	);
	// General
	$fields[] = array(
		'name' => 'price',
		'label' => __( 'Price', 'woocommerce-product-importer' ),
		'alias' => array( 'prices', 'regular_price', 'product_price', 'rrp', 'suggested_retail_price' )
	);
	$fields[] = array(
		'name' => 'sale_price',
		'label' => __( 'Sale Price', 'woocommerce-product-importer' ),
		'alias' => array( 'from_price' )
	);
	$fields[] = array(
		'name' => 'sale_price_dates_from',
		'label' => __( 'Sale Price Dates From', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'sale_price_dates_to',
		'label' => __( 'Sale Price Dates To', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'slug',
		'label' => __( 'Slug', 'woocommerce-product-importer' ),
		'alias' => array( 'post_name' )
	);
	$fields[] = array(
		'name' => 'weight',
		'label' => __( 'Weight', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'length',
		'label' => __( 'Length', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'width',
		'label' => __( 'Width', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'height',
		'label' => __( 'Height', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'image',
		'label' => __( 'Featured Image', 'woocommerce-product-importer' ),
		'alias' => array( 'featured_image', 'images', 'product_image', 'product_images' )
	);
	$fields[] = array(
		'name' => 'image_nuke',
		'label' => __( 'Clear Featured Image', 'woocommerce-product-importer' ),
		'alias' => array( 'clear_featured_image' )
	);
	$fields[] = array(
		'name' => 'featured_image_title',
		'label' => __( 'Featured Image Title', 'woocommerce-product-importer' ),
	);
	$fields[] = array(
		'name' => 'featured_image_caption',
		'label' => __( 'Featured Image Caption', 'woocommerce-product-importer' ),
	);
	$fields[] = array(
		'name' => 'featured_image_alt_text',
		'label' => __( 'Featured Image Alternative Text', 'woocommerce-product-importer' ),
		'alias' => array( 'featured_image_alternative_text' )
	);
	$fields[] = array(
		'name' => 'featured_image_description',
		'label' => __( 'Featured Image Description', 'woocommerce-product-importer' ),
	);
	$fields[] = array(
		'name' => 'product_gallery',
		'label' => __( 'Product Gallery', 'woocommerce-product-importer' ),
		'alias' => array( 'gallery' )
	);
	$fields[] = array(
		'name' => 'product_gallery_nuke',
		'label' => __( 'Clear Product Gallery', 'woocommerce-product-importer' ),
		'alias' => array( 'clear_product_gallery' )
	);
	$fields[] = array(
		'name' => 'image_product_gallery_nuke',
		'label' => __( 'Clear Featured Image & Product Gallery', 'woocommerce-product-importer' ),
		'alias' => array( 'clear_featured_image_product_gallery' )
	);
	$fields[] = array(
		'name' => 'post_date',
		'label' => __( 'Product Published', 'woocommerce-product-importer' ),
		'alias' => array( 'product_published', 'date_published' )
	);
	$fields[] = array(
		'name' => 'post_modified',
		'label' => __( 'Product Modified', 'woocommerce-product-importer' ),
		'alias' => array( 'product_modified', 'date_modified' )
	);
	// Type & Visibility
	$fields[] = array(
		'name' => 'type',
		'label' => __( 'Type', 'woocommerce-product-importer' ),
		'alias' => array( 'product_type', 'product_types', 'types' )
	);
	$fields[] = array(
		'name' => 'visibility',
		'label' => __( 'Visibility', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'featured',
		'label' => __( 'Featured', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'virtual',
		'label' => __( 'Virtual', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'downloadable',
		'label' => __( 'Downloadable', 'woocommerce-product-importer' )
	);
	// Categories, Tags, Shipping Classes
	$fields[] = array(
		'name' => 'category',
		'label' => __( 'Category', 'woocommerce-product-importer' ),
		'alias' => array( 'product_category', 'product_categories', 'categories', 'product_cat' )
	);
	$fields[] = array(
		'name' => 'category_1',
		'label' => __( 'Category: Level 1', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'category_2',
		'label' => __( 'Category: Level 2', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'category_3',
		'label' => __( 'Category: Level 3', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'tag',
		'label' => __( 'Tag', 'woocommerce-product-importer' ),
		'alias' => array( 'product_tag', 'product_tags', 'tags' )
	);
	$fields[] = array(
		'name' => 'shipping_class',
		'label' => __( 'Shipping Class', 'woocommerce-product-importer' ),
		'alias' => array( 'shipping_classes', 'product_shipping_class' )
	);
	// Tax
	$fields[] = array(
		'name' => 'tax_status',
		'label' => __( 'Tax Status', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'tax_class',
		'label' => __( 'Tax Class', 'woocommerce-product-importer' )
	);
	// Inventory
	$fields[] = array(
		'name' => 'manage_stock',
		'label' => __( 'Manage Stock', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'stock_status',
		'label' => __( 'Stock Status', 'woocommerce-product-importer' ),
		'alias' => array( 'stock_info' )
	);
	$fields[] = array(
		'name' => 'quantity',
		'label' => __( 'Quantity', 'woocommerce-product-importer' ),
		'alias' => array( 'qty', 'stock' )
	);
	$fields[] = array(
		'name' => 'allow_backorders',
		'label' => __( 'Allow Backorders', 'woocommerce-product-importer' ),
		'alias' => array( 'backorders' )
	);
	$fields[] = array(
		'name' => 'sold_individually',
		'label' => __( 'Sold Individually', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'upsells',
		'label' => __( 'Up-Sells', 'woocommerce-product-importer' ),
		'alias' => array( 'up-sells', 'up_sells', 'upsell_ids' )
	);
	$fields[] = array(
		'name' => 'crosssells',
		'label' => __( 'Cross-Sells', 'woocommerce-product-importer' ),
		'alias' => array( 'cross-sells', 'cross_sells', 'crosssell_ids' )
	);
	$fields[] = array(
		'name' => 'download_file_name',
		'label' => __( 'Download File Name', 'woocommerce-product-importer' ),
		'alias' => array( 'file_download_name', 'file_downloads_name', 'download_file_name', 'download_files_name' )
	);
	$fields[] = array(
		'name' => 'download_file_url',
		'label' => __( 'Download File URL Path', 'woocommerce-product-importer' ),
		'alias' => array( 'file_download', 'file_downloads', 'download_file', 'download_file_url_path', 'download_files' )
	);
	$fields[] = array(
		'name' => 'download_limit',
		'label' => __( 'Download Limit', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'download_expiry',
		'label' => __( 'Download Expiry', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'download_type',
		'label' => __( 'Download Type', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'product_url',
		'label' => __( 'Product URL', 'woocommerce-product-importer' ),
		'alias' => array( 'external_url', 'external_link' )
	);
	$fields[] = array(
		'name' => 'button_text',
		'label' => __( 'Button Text', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'status',
		'label' => __( 'Product Status', 'woocommerce-product-importer' ),
		'alias' => array( 'product_status', 'post_status' )
	);
	$fields[] = array(
		'name' => 'purchase_note',
		'label' => __( 'Purchase Note', 'woocommerce-product-importer' )
	);
	$fields[] = array(
		'name' => 'sort',
		'label' => __( 'Sort Order', 'woocommerce-product-importer' ),
		'alias' => array( 'sort_order', 'menu_order', 'product_order' )
	);
	$fields[] = array(
		'name' => 'comment_status',
		'label' => __( 'Enable Reviews', 'woocommerce-product-importer' ),
		'alias' => array( 'enable_reviews', 'enable_review' )
	);
	$fields[] = array(
		'name' => 'total_sales',
		'label' => __( 'Total Sales', 'woocommerce-product-importer' )
	);

	// Attributes
	if( $attributes = woo_pd_get_product_attributes() ) {
		$i = 0;
		$size = count( $attributes );
		foreach( $attributes as $attribute ) {
			// Format the Attribute name to match the import column
			$field = array(
				'name' => 'pa_' . $attribute['name'],
				'label' => sprintf( __( 'Attribute: %s (%s)', 'woocommerce-product-importer' ), $attribute['label'], $attribute['name'] ),
				'alias' => array(
					sprintf( 'attribute_%s', str_replace( '-', '_', $attribute['name'] ) ),
					sprintf( 'attribute_%s', $attribute['name'] ),
					sprintf( 'variation_%s', $attribute['name'] )
				)
			);
			if( $i == 0 )
				$field['group_open'] = sprintf( '<optgroup label="%s">', __( 'Attributes', 'woocommerce-product-importer' ) );
			else if( $i == ( $size - 1 ) )
				$field['group_close'] = '</optgroup>';
			$fields[] = $field;
			unset( $field );
			$i++;
		}
	}

	$fields[] = array(
		'name' => 'default_attributes',
		'label' => __( 'Default Attributes', 'woocommerce-product-importer' )
	);

	// Allow Plugin/Theme authors to add support for additional Product details
	$fields = apply_filters( 'woo_pd_options_addons', $fields );

	return $fields;

}

function woo_pd_prepare_product( $count ) {

	global $import, $product;

	$product = new stdClass;

	// Set up empty vars
	$product->updated = false;
	$product->deleted = false;
	$product->imported = false;
	$product->duplicate_exists = false;

	$product->row_id = ( $import->skip_first ? $count : $count + 1 );
	$product->ID = ( isset( $import->csv_id ) && isset( $import->csv_id[$count] ) ? $import->csv_id[$count] : null );
	$product->type = ( isset( $import->csv_type[$count] ) ? woo_pd_is_valid_product_type( $import->csv_type[$count] ) : null );
	$product->is_variation = ( isset( $product->type ) && $product->type == 'variation' ? true : false );
	$product->sku = ( isset( $import->csv_sku ) && isset( $import->csv_sku[$count] ) ? $import->csv_sku[$count] : null );
	$product->new_sku = ( isset( $import->csv_new_sku ) && isset( $import->csv_new_sku[$count] ) ? $import->csv_new_sku[$count] : null );
	$product->name = ( isset( $import->csv_name ) && isset( $import->csv_name[$count] ) ? $import->csv_name[$count] : null );
	$product->price = ( isset( $import->csv_price ) && isset( $import->csv_price[$count] ) ? woo_pd_is_price_valid( $import->csv_price[$count], $product->type ) : null );
	$product->sale_price = ( isset( $import->csv_sale_price ) && isset( $import->csv_sale_price[$count] ) ? woo_pd_is_price_valid( $import->csv_sale_price[$count], $product->type ) : null );
	$product->sale_price_dates_from = ( isset( $import->csv_sale_price_dates_from ) && isset( $import->csv_sale_price_dates_from[$count] ) ? woo_pd_is_valid_sale_date( $import->csv_sale_price_dates_from[$count] ) : null );
	$product->sale_price_dates_to = ( isset( $import->csv_sale_price_dates_to ) && isset( $import->csv_sale_price_dates_to[$count] ) ? woo_pd_is_valid_sale_date( $import->csv_sale_price_dates_to[$count] ) : null );
	// Check if import method is set
	if( !isset( $import->image_method ) )
		$import->image_method = '';
	$product->images = null;
	$product->image = null;
	if( ( isset( $import->csv_image ) && $import->csv_image !== null ) && $import->image_method ) {
		switch( $import->image_method ) {

			case 'csv':
			case 'external':
				$product->images = array();
				if( isset( $import->csv_image[$count] ) && $import->csv_image[$count] ) {
					$product->images = explode( $import->category_separator, $import->csv_image[$count] );
					$size = count( $product->images );
					for( $i = 0; $i < $size; $i++ )
						$product->image .= $product->images[$i] . $import->category_separator;
					$product->image = substr( $product->image, 0, -1 );
					$product->featured_image_title = ( isset( $import->csv_featured_image_title ) && isset( $import->csv_featured_image_title[$count] ) ? $import->csv_featured_image_title[$count] : null );
					$product->featured_image_caption = ( isset( $import->csv_featured_image_caption ) && isset( $import->csv_featured_image_caption[$count] ) ? $import->csv_featured_image_caption[$count] : null );
					$product->featured_image_alt_text = ( isset( $import->csv_featured_image_alt_text ) && isset( $import->csv_featured_image_alt_text[$count] ) ? $import->csv_featured_image_alt_text[$count] : null );
					$product->featured_image_description = ( isset( $import->csv_featured_image_description ) && isset( $import->csv_featured_image_description[$count] ) ? $import->csv_featured_image_description[$count] : null );
				}
				break;

		}
	}
	$product->image_nuke = ( isset( $import->csv_image_nuke[$count] ) ? woo_pd_is_valid_switch( $import->csv_image_nuke[$count] ) : null );
	$product->featured = ( isset( $import->csv_featured[$count] ) ? woo_pd_is_valid_featured( $import->csv_featured[$count] ) : null );
	$product->virtual = ( isset( $import->csv_virtual[$count] ) ? woo_pd_is_valid_featured( $import->csv_virtual[$count] ) : null );
	$product->downloadable = ( isset( $import->csv_downloadable[$count] ) ? woo_pd_is_valid_featured( $import->csv_downloadable[$count] ) : null );
	$product->description = ( isset( $import->csv_description[$count] ) ? html_entity_decode( $import->csv_description[$count] ) : null );
	$product->excerpt = ( isset( $import->csv_excerpt[$count] ) ? html_entity_decode( $import->csv_excerpt[$count] ) : null );
	$product->category = null;
	if( isset( $import->csv_category[$count] ) && isset( $import->csv_category_1[$count] ) && isset( $import->csv_category_2[$count] ) && isset( $import->csv_category_3[$count] ) )
		$product->category = $import->csv_category[$count] . $import->parent_child_delimiter . $import->csv_category_1[$count] . $import->parent_child_delimiter . $import->csv_category_2[$count] . $import->parent_child_delimiter . $import->csv_category_3[$count];
	else if( isset( $import->csv_category[$count] ) && isset( $import->csv_category_1[$count] ) && isset( $import->csv_category_2[$count] ) )
		$product->category = $import->csv_category[$count] . $import->parent_child_delimiter . $import->csv_category_1[$count] . $import->parent_child_delimiter . $import->csv_category_2[$count];
	else if( isset( $import->csv_category[$count] ) && isset( $import->csv_category_1[$count] ) )
		$product->category = $import->csv_category[$count] . $import->parent_child_delimiter . $import->csv_category_1[$count];
	else if( isset( $import->csv_category[$count] ) )
		$product->category = $import->csv_category[$count];
	$product->tag = ( isset( $import->csv_tag[$count] ) ? $import->csv_tag[$count] : null );
	$product->shipping_class = ( isset( $import->csv_shipping_class[$count] ) ? $import->csv_shipping_class[$count] : null );
	$product->slug = ( isset( $import->csv_slug[$count] ) ? sanitize_title_with_dashes( $import->csv_slug[$count] ) : null );
	$product->post_parent = ( isset( $import->csv_post_parent[$count] ) ? $import->csv_post_parent[$count] : null );
	$product->post_parent_sku = ( isset( $import->csv_post_parent_sku[$count] ) ? $import->csv_post_parent_sku[$count] : null );
	$product->weight = ( isset( $import->csv_weight[$count] ) ? $import->csv_weight[$count] : null );
	$product->length = ( isset( $import->csv_length[$count] ) ? $import->csv_length[$count] : null );
	$product->width = ( isset( $import->csv_width[$count] ) ? $import->csv_width[$count] : null );
	$product->height = ( isset( $import->csv_height[$count] ) ? $import->csv_height[$count] : null );
	$product->post_date = ( isset( $import->csv_post_date[$count] ) ? woo_pd_is_valid_post_date( $import->csv_post_date[$count] ) : null );
	$product->post_modified = ( isset( $import->csv_post_modified[$count] ) ? woo_pd_is_valid_post_date( $import->csv_post_modified[$count] ) : null );
	$product->product_galleries = null;
	$product->product_gallery = ( isset( $import->csv_product_gallery[$count] ) ? woo_pd_is_valid_list( $import->csv_product_gallery[$count], 'product_galleries' ) : null );
	$product->product_gallery_nuke = ( isset( $import->csv_product_gallery_nuke[$count] ) ? woo_pd_is_valid_switch( $import->csv_product_gallery_nuke[$count] ) : null );
	$product->image_product_gallery_nuke = ( isset( $import->csv_image_product_gallery_nuke[$count] ) ? woo_pd_is_valid_switch( $import->csv_image_product_gallery_nuke[$count] ) : null );
	$product->tax_status = ( isset( $import->csv_tax_status[$count] ) ? woo_pd_is_valid_tax_status( $import->csv_tax_status[$count] ) : null );
	$product->tax_class = ( isset( $import->csv_tax_class[$count] ) ? woo_pd_is_valid_tax_class( $import->csv_tax_class[$count] ) : null );
	$product->manage_stock = ( isset( $import->csv_manage_stock[$count] ) ? woo_pd_is_valid_manage_stock( $import->csv_manage_stock[$count] ) : null );
	$product->stock_status = ( isset( $import->csv_stock_status[$count] ) ? woo_pd_is_valid_stock_status( $import->csv_stock_status[$count] ) : null );
	$product->quantity = ( isset( $import->csv_quantity[$count] ) ? woo_pd_is_valid_quantity( $import->csv_quantity[$count] ) : null );
	$product->allow_backorders = ( isset( $import->csv_allow_backorders[$count] ) ? woo_pd_is_valid_allow_backorders( $import->csv_allow_backorders[$count] ) : null );
	$product->sold_individually = ( isset( $import->csv_sold_individually[$count] ) ? woo_pd_is_valid_sold_individually( $import->csv_sold_individually[$count] ) : null );
	$product->upsells = null;
	$product->upsell = ( isset( $import->csv_upsells[$count] ) ? woo_pd_is_valid_list( $import->csv_upsells[$count], 'upsells' ) : null );
	$product->crosssells = null;
	$product->crosssell = ( isset( $import->csv_crosssells[$count] ) ? woo_pd_is_valid_list( $import->csv_crosssells[$count], 'crosssells' ) : null );
	$product->sort = ( isset( $import->csv_sort[$count] ) ? $import->csv_sort[$count] : null );
	$product->download_files = null;
	$product->download_file_urls = null;
	$product->download_file_url = ( isset( $import->csv_download_file_url[$count] ) ? woo_pd_is_valid_list( $import->csv_download_file_url[$count], 'download_file_urls' ) : null );
	$product->download_file_names = null;
	$product->download_file_name = ( isset( $import->csv_download_file_name[$count] ) ? woo_pd_is_valid_list( $import->csv_download_file_name[$count], 'download_file_names' ) : null );
	$product->download_limit = ( isset( $import->csv_download_limit[$count] ) ? $import->csv_download_limit[$count] : null );
	$product->download_expiry = ( isset( $import->csv_download_expiry[$count] ) ? $import->csv_download_expiry[$count] : null );
	$product->download_type = ( isset( $import->csv_download_type[$count] ) ? woo_pd_is_valid_download_type( $import->csv_download_type[$count] ) : null );
	$product->product_url = ( isset( $import->csv_product_url[$count] ) ? html_entity_decode( $import->csv_product_url[$count] ) : null );
	$product->button_text = ( isset( $import->csv_button_text[$count] ) ? $import->csv_button_text[$count] : null );
	$product->visibility = ( isset( $import->csv_visibility[$count] ) ? woo_pd_is_valid_visibility( $import->csv_visibility[$count] ) : null );
	$product->status = ( isset( $import->csv_status[$count] ) ? woo_pd_is_valid_post_status( $import->csv_status[$count] ) : null );
	$product->comment_status = ( isset( $import->csv_comment_status[$count] ) ? woo_pd_is_valid_comment_status( $import->csv_comment_status[$count] ) : null );
	$product->purchase_note = ( isset( $import->csv_purchase_note[$count] ) ? html_entity_decode( $import->csv_purchase_note[$count] ) : null );
	$product->total_sales = ( isset( $import->csv_total_sales[$count] ) ? $import->csv_total_sales[$count] : null );
	$product->attributes = null;
	if( !empty( $import->attributes ) ) {
		$product->attributes = array();
		foreach( $import->attributes as $attribute ) {
			if( isset( $import->csv_attributes[$attribute['name']][$count] ) )
				$product->attributes[$attribute['name']] = $import->csv_attributes[$attribute['name']][$count];
		}
	}
	$product->default_attributes = ( isset( $import->csv_default_attributes[$count] ) ? $import->csv_default_attributes[$count] : null );

	// Allow Plugin/Theme authors to add support for additional Product details
	$product = apply_filters( 'woo_pd_product_addons', $product, $import, $count );

	// Custom Product meta
	$custom_products = woo_pd_get_option( 'custom_products', '' );
	if( !empty( $custom_products ) ) {
		foreach( $custom_products as $custom_product ) {
			if( !empty( $custom_product ) ) {
				$product->{sanitize_key( $custom_product )} = null;
				if( isset( $import->{sanitize_key( sprintf( 'csv_%s', $custom_product ) )} ) )
					$product->{sanitize_key( $custom_product )} = ( isset( $import->{sanitize_key( sprintf( 'csv_%s', $custom_product ) )}[$count] ) ? $import->{sanitize_key( sprintf( 'csv_%s', $custom_product ) )}[$count] : null );
			}
		}
	}
	unset( $custom_products, $custom_product );

	// Custom Attributes
	$custom_attributes = woo_pd_get_option( 'custom_attributes', '' );
	if( !empty( $custom_attributes ) ) {
		foreach( $custom_attributes as $custom_attribute ) {
			if( !empty( $custom_attribute ) ) {
				$product->{sanitize_key( $custom_attribute )} = null;
				if( isset( $import->{sanitize_key( sprintf( 'csv_%s', $custom_attribute ) )} ) )
					$product->{sanitize_key( $custom_attribute )} = ( isset( $import->{sanitize_key( sprintf( 'csv_%s', $custom_attribute ) )}[$count] ) ? $import->{sanitize_key( sprintf( 'csv_%s', $custom_attribute ) )}[$count] : null );
			}
		}
	}
	unset( $custom_attributes, $custom_attribute );

	foreach( $product as $key => $value ) {
		if( !is_array( $value ) && $value !== null )
			$product->$key = woo_pd_encode_transient( trim( $value ) );
	}

	if( isset( $import->headers ) ) {
		foreach( $import->headers as $header ) {
			if( isset( $import->{sprintf( 'csv_%s', $header )} ) ) {
				if( isset( $import->{sprintf( 'csv_%s', $header )}[$count] ) )
					unset( $import->{sprintf( 'csv_%s', $header )}[$count] );
			}
		}
	}

}

// Scan Products by Post ID, SKU and Product Name to detect existing Products
function woo_pd_duplicate_product_exists() {

	global $import, $product;

	$post_type = array( 'product', 'product_variation' );
	if( !empty( $product ) ) {

		// Check for duplicate Product by Post ID if present
		if( isset( $product->ID ) ) {
			$args = array(
				'post_type' => $post_type,
				'post__in' => array( $product->ID ),
				'numberposts' => 1,
				'post_status' => 'any',
				'fields' => 'ids'
			);
			$products = new WP_Query( $args );
			if( !empty( $products->found_posts ) ) {
				$product->duplicate_exists = $product->ID;
				if( $product->duplicate_exists && $import->advanced_log ) {
					$product_title = get_the_title( $product->duplicate_exists );
					if( $import->cron )
						$import->log .= "<br />>>> " . sprintf( __( 'Detected %s (#%d) by Post ID: %d', 'woocommerce-product-importer' ), $product_title, $product->ID, $product->ID );
					else
						$import->log .= "<br />>>>>>> " . sprintf( __( 'Detected %s (#%d) by Post ID: %d', 'woocommerce-product-importer' ), $product_title, $product->ID, $product->ID );
					return true;
				}
			} else if( $import->advanced_log ) {
				if( $import->cron )
					$import->log .= "<br />>>> " . sprintf( __( 'Could not detect Product by Post ID: %s', 'woocommerce-product-importer' ), $product->ID );
				else
					$import->log .= "<br />>>>>>> " . sprintf( __( 'Could not detect Product by Post ID: %s', 'woocommerce-product-importer' ), $product->ID );
			}
			unset( $products );
		} else if( $import->advanced_log ) {
			if( $import->cron )
				$import->log .= "<br />>>> " . __( 'Skipping Post ID Product detection', 'woocommerce-product-importer' );
			else
				$import->log .= "<br />>>>>>> " . __( 'Skipping Post ID Product detection', 'woocommerce-product-importer' );
		}

		// Check for duplicate Product by SKU if present
		if( isset( $product->sku ) && !$product->duplicate_exists ) {
			$product->duplicate_exists = woo_pd_get_product_id_by_sku( $product->sku );
			if( $product->duplicate_exists ) {
				if( $import->advanced_log ) {
					$product_title = get_the_title( $product->duplicate_exists );
					if( $import->cron )
						$import->log .= "<br />>>> " . sprintf( __( 'Detected %s (#%d) by SKU: %s', 'woocommerce-product-importer' ), $product_title, $product->duplicate_exists, $product->sku );
					else
						$import->log .= "<br />>>>>>> " . sprintf( __( 'Detected %s (#%d) by SKU: %s', 'woocommerce-product-importer' ), $product_title, $product->duplicate_exists, $product->sku );
				}
				// Check if WPML is active
				if( $product->duplicate_exists && ( woo_pd_detect_wpml() || woo_pd_detect_import_plugin( 'wpml_wc' ) ) ) {
					// Check that the Language column has been provided
					if( $product->language !== null && $import->advanced_log ) {
						if( $import->cron )
							$import->log .= "<br />>>> " . __( 'Detected WPML Product, overriding duplicate Product detection', 'woocommerce-product-importer' );
						else
							$import->log .= "<br />>>>>>> " . __( 'Detected WPML Product, overriding duplicate Product detection', 'woocommerce-product-importer' );
						$product->duplicate_exists = false;
						return false;
					}
				}
				return true;
			} else if( $import->advanced_log ) {
				if( $import->cron )
					$import->log .= "<br />>>> " . sprintf( __( 'Could not detect Product by SKU: %s', 'woocommerce-product-importer' ), $product->sku );
				else
					$import->log .= "<br />>>>>>> " . sprintf( __( 'Could not detect Product by SKU: %s', 'woocommerce-product-importer' ), $product->sku );
			}
		} else if( $import->advanced_log ) {
			if( $import->cron )
				$import->log .= "<br />>>> " . __( 'Skipping SKU Product detection', 'woocommerce-product-importer' );
			else
				$import->log .= "<br />>>>>>> " . __( 'Skipping SKU Product detection', 'woocommerce-product-importer' );
		}

		// Check for duplicate Product by Product Name if present
		if( isset( $product->name ) && !$product->duplicate_exists ) {
			$post_type = 'product';
			// get_page_by_title is limited to a single Post Type
			$products = get_page_by_title( $product->name, false, $post_type );
			if( $products !== null ) {
				$product->duplicate_exists = ( isset( $products->ID ) ? $products->ID : false );
				if( $product->duplicate_exists && $import->advanced_log ) {
					if( $import->cron )
						$import->log .= "<br />>>> " . sprintf( __( 'Detected %s (#%d) by Product Name: %s', 'woocommerce-product-importer' ), $product->name, $product->duplicate_exists, $product->name );
					else
						$import->log .= "<br />>>>>>> " . sprintf( __( 'Detected %s (#%d) by Product Name: %s', 'woocommerce-product-importer' ), $product->name, $product->duplicate_exists, $product->name );
				}
				return true;
			} else if( $import->advanced_log ) {
				if( $import->cron )
					$import->log .= "<br />>>> " . sprintf( __( 'Could not detect Product by Product Name: %s', 'woocommerce-product-importer' ), $product->name );
				else
					$import->log .= "<br />>>>>>> " . sprintf( __( 'Could not detect Product by Product Name: %s', 'woocommerce-product-importer' ), $product->name );
			}
			unset( $products );
		} else if( $import->advanced_log ) {
			if( $import->cron )
				$import->log .= "<br />>>> " . __( 'Skipping Product Name Product detection', 'woocommerce-product-importer' );
			else
				$import->log .= "<br />>>>>>> " . __( 'Skipping Product Name Product detection', 'woocommerce-product-importer' );
		}

		// Check if we have a Variation with a Parent SKU
		if( $product->is_variation && ( isset( $product->post_parent ) || isset( $product->post_parent_sku ) || isset( $product->name ) ) && !$product->duplicate_exists ) {
			$pieces = false;
			$post_parent = false;
			if( !empty( $product->name ) )
				$pieces = explode( ' - ', $product->name );

			// Find the Post Parent by Parent ID if available
			if( !empty( $product->post_parent ) ) {
				$post_type = 'product';
				$args = array(
					'post_type' => $post_type,
					'post__in' => array( $product->post_parent ),
					'numberposts' => 1,
					'post_status' => 'any',
					'fields' => 'ids'
				);
				$products = new WP_Query( $args );
				if( !empty( $products->found_posts ) ) {
					// Check if the Post Parent is a Variable
					$product_type = wp_get_object_terms( $product->ID, 'product_type', array( 'fields' => 'slugs' ) );
					if( $product_type == 'variable' ) {
						$post_parent = $product->post_parent;
						// Try to fetch the Post Parent SKU if empty
						if( empty( $product->post_parent_sku ) )
							$product->post_parent_sku = get_post_meta( $post_parent, '_sku', true );
					}
					unset( $product_type );
				}
				unset( $products );
			}

			// Fallback, find the Post Parent by Parent SKU if available
			if( !$post_parent && !empty( $product->post_parent_sku ) ) {
				$post_parent = woo_pd_get_product_id_by_sku( $product->post_parent_sku );
				if( $import->advanced_log ) {
					$product_title = get_the_title( $product->duplicate_exists );
					$import->log .= "<br />>>> " . sprintf( __( 'Detected %s (#%d) by Product Name: %s', 'woocommerce-product-importer' ), $product_title, $product->duplicate_exists, $product->name );
				}
			}

			// Fallback, find the Post Parent by Product Name if available
			if( !$post_parent && !empty( $pieces ) ) {
				$post_type = 'product';
				$products = get_page_by_title( $pieces[0], false, $post_type );
				// People do like putting dashes in Product Names...
				if( is_null( $products ) && isset( $pieces[1] ) )
					$products = get_page_by_title( $pieces[0] . ' - ' . $pieces[1], false, $post_type );
				if( $products !== null )
					$post_parent = ( isset( $products->ID ) ? $products->ID : false );
				unset( $products );
			}

			// If we have a Post Parent let's proceed...
			if( !empty( $post_parent ) ) {
				// Find the Attribute and Variation
				$product_attributes = maybe_unserialize( get_post_meta( $post_parent, '_product_attributes', true ) );
				if( !empty( $product_attributes ) ) {
					// Fetch the Attribute names within the Product Name
					$variation_pieces = explode( $import->category_separator, $pieces[1] );
					if( !empty( $variation_pieces ) ) {
						$meta_keys = array();
						// Loop through each Product Attribute within the Product Name
						foreach( $variation_pieces as $variation_piece ) {
							$attribute_pieces = explode( ':', $variation_piece );
							if( !empty( $attribute_pieces ) ) {

								$attribute_name = $attribute_pieces[0];
								$attribute_value = $attribute_pieces[1];

								// Convert the Attribute Label into a Attribute Name
								foreach( $import->attributes as $attribute ) {
									foreach( $product_attributes as $key => $product_attribute ) {
										if( sprintf( 'pa_%s', $attribute['name'] ) == $product_attribute['name'] ) {
											$product_attributes[$key]['label'] = $attribute['label'];
											break;
										}
									}
								}

								// Loop through the Product Attributes linked to the Variable Product
								foreach( $product_attributes as $product_attribute ) {
									if( !empty( $product_attribute['label'] ) ) {
										if( $product_attribute['label'] == $attribute_name ) {
											$meta_keys[] = array(
												'key' => sprintf( 'attribute_%s', $product_attribute['name'] ),
												'value' => $attribute_value,
												'compare' => 'IN'
											);
											break;
										}
									}
								}

							}
						}
						if( !empty( $meta_keys ) ) {
							// Find the Variation
							$post_type = 'product_variation';
							$args = array(
								'post_type' => $post_type,
								'post_parent' => $post_parent,
								'meta_query' => $meta_keys,
								'posts_per_page' => 1,
								'post_status' => 'any',
								'fields' => 'ids'
							);
							$products = new WP_Query( $args );
							if( !empty( $products->found_posts ) ) {
								// woo_pd_error_log( print_r( $args, true ) );
								$product->duplicate_exists = ( !empty( $products->posts[0] ) ? $products->posts[0] : false );
								// woo_pd_error_log( $product->duplicate_exists );
								// woo_pd_error_log( '---' );
								if( $product->duplicate_exists && $import->advanced_log ) {
									$product_title = get_the_title( $product->duplicate_exists );
									if( $import->cron )
										$import->log .= "<br />>>> " . sprintf( __( 'Detected %s (#%d) by Product Name: %s', 'woocommerce-product-importer' ), $product_title, $product->duplicate_exists, $product->name );
									else
										$import->log .= "<br />>>>>>> " . sprintf( __( 'Detected %s (#%d) by Product Name: %s', 'woocommerce-product-importer' ), $product_title, $product->duplicate_exists, $product->name );
								}
								return true;
							}
							unset( $products );
						}
					}
				}
				unset( $product_attributes );
			}
			unset( $pieces );
		} else if( $import->advanced_log ) {
			if( $import->cron )
				$import->log .= "<br />>>> " . __( 'Skipping Variation Product detection', 'woocommerce-product-importer' );
			else
				$import->log .= "<br />>>>>>> " . __( 'Skipping Variation Product detection', 'woocommerce-product-importer' );
		}

		if( $import->import_method == 'update' && !$product->duplicate_exists && $import->advanced_log ) {
			if( $import->cron )
				$import->log .= "<br />>>> " . __( 'Could not detect existing Product', 'woocommerce-product-importer' );
			else
				$import->log .= "<br />>>>>>> " . __( 'Could not detect existing Product', 'woocommerce-product-importer' );
		}
	}

}

function woo_pd_is_valid_switch( $input = null, $output_format = 'int' ) {

	if( $input !== null ) {
		$input = strtolower( $input );
		switch( $input ) {

			case '1':
			case 'yes':
			case 'on':
			case 'open':
			case 'active':
				$input = '1';
				break;

			case '0':
			case 'no':
			case 'off':
			case 'closed':
			case 'inactive':
				$input = '0';
				break;

		}
		$output = '';
		switch( $output_format ) {

			case 'int':
				$output = $input;
				break;

			case 'boolean':
				switch( $input ) {

					case '1':
						$output = 'on';
						break;

					case '0':
						$output = 'off';
						break;

				}
				break;

		}
		return $output;
	}

}

// Validates the given Quantity
function woo_pd_is_valid_quantity( $quantity = null ) {

	if( $quantity !== null ) {
		$quantity = strtolower( $quantity );
		switch( $quantity ) {

			case 'n/a':
			case '-':
				return false;
				break;

			default:
				return $quantity;

		}
	}

}

// Validates the given Product Status
function woo_pd_is_valid_post_status( $status = null ) {

	$status = strtolower( $status );
	switch( $status ) {

		case '0':
		case 'off':
		case 'draft':
			$output = 'draft';
			break;

		case 'pending':
		case 'future':
		case 'private':
		case 'trash':
		case 'auto-draft':
		case 'inherit':
			$output = $status;
			break;

		case '1':
		case 'on':
		case 'publish':
		case 'published':
		default:
			$output = 'publish';
			break;

	}
	return $output;

}

// Validates the given Comment Status
function woo_pd_is_valid_comment_status( $comment_status = null ) {

	$output = '';
	$comment_status = strtolower( $comment_status );
	switch( $comment_status ) {

		case '0':
		case 'off':
		case 'no':
		case 'closed':
			$output = 'closed';
			break;

		case '1':
		case 'on':
		case 'yes':
		case 'open':
		default:
			$output = 'open';
			break;

	}
	return $output;

}

// Validates the given Price value; Price, Sale Price, Shipping, etc.
function woo_pd_is_price_valid( $price = null, $product_type = 'simple' ) {

	// Return the first value from the Variable Price and Sale Price
	if( !is_null( $price ) && !is_null( $product_type ) ) {
		if( $product_type == 'variable' ) {
			$pieces = explode( '-', $price );
			$price = $pieces[0];
			unset( $pieces );
		}
	}

	if( function_exists( 'wc_get_price_decimal_separator' ) ) {
		$string = wc_get_price_decimal_separator();
		$separator = ($string === NULL) ? "." : $string;
		$price = preg_replace( "/[^0-9$separator]/", '', $price );
	} else {
		$price = preg_replace( '/[^0-9.]/', '', $price );
	}

	return $price;

}

function woo_pd_is_valid_post_date( $post_date = null ) {

	if( $post_date !== null ) {
		// Assume we're dealing with a European/Australian date
		$post_date = str_replace( '-', '/', $post_date );
		$post_date = explode( '/', $post_date );
		if(
			!empty( $post_date ) && 
			isset( $post_date[0] ) && 
			isset( $post_date[1] ) && 
			isset( $post_date[2] )
		) {
			// @mod - Check for multiple date formats
			$timestamp = mktime( 0, 0, 0, $post_date[1], $post_date[0], $post_date[2] );
			if( !empty( $timestamp ) ) {
				// Validate the given date
				return gmdate( 'Y-m-d H:i:s', $timestamp );
			}
		}
	}
	return null;

}

function woo_pd_is_valid_sale_date( $date = null ) {

	if( $output = strtotime( str_replace( '-', '/', $date ) ) ) {
		// Validate the given date
		if( $valid_date = date_parse( $date ) !== false ) {
			if( checkdate( $valid_date['month'], $valid_date['day'], $valid_date['year'] ) )
				return $output;
		}
	}
	return false;

}

function woo_pd_is_valid_manage_stock( $status = null ) {

	$status = trim( strtolower( $status ) );
	switch( $status ) {

		case '0':
		case 'off':
		case 'no':
		case 'n':
			$output = 'no';
			break;

		default:
		case '1':
		case 'on':
		case 'yes':
		case 'y':
			$output = 'yes';
			break;

	}
	return $output;

}

function woo_pd_is_valid_stock_status( $status = null ) {

	if( $status !== null ) {
		$status = strtolower( $status );
		switch( $status ) {

			case '1':
			case 'active':
			case 'in stock':
			case 'instock':
				$output = 'instock';
				return $output;
				break;

			case '0':
			case 'oos':
			case 'disabled':
			case 'out of stock':
			case 'outofstock':
				$output = 'outofstock';
				return $output;
				break;

		}
	}

}

function woo_pd_is_valid_allow_backorders( $status = null ) {

	if( $status !== null ) {
		$status = strtolower( $status );
		switch( $status ) {

			case '0':
			case 'no':
			case 'off':
			case 'do not allow':
				$output = 'no';
				return $output;
				break;

			case 'allow, but notify customer':
			case 'notify':
				$output = 'notify';
				return $output;
				break;

			case '1':
			case 'yes':
			case 'on':
			case 'allow':
				$output = 'yes';
				return $output;
				break;

		}
	}

}

function woo_pd_is_valid_tax_status( $status = null ) {

	if( $status !== null ) {
		$status = strtolower( $status );
		switch( $status ) {

			case 'taxable':
			case 'on':
			case 'yes':
				$output = 'taxable';
				return $output;
				break;

			case 'shipping only':
			case 'shipping':
				$output = 'shipping';
				return $output;
				break;

			case 'none':
			case 'off':
			case 'no':
				$output = 'none';
				return $output;
				break;

		}
	}

}

function woo_pd_is_valid_tax_class( $class = null ) {

	if( $class !== null ) {
		$class = strtolower( $class );
		switch( $class ) {

			case 'standard':
				$output = '';
				return $output;
				break;

			case 'reduced rate':
				$output = 'reduced-rate';
				return $output;
				break;

			case 'zero rate':
				$output = 'zero-rate';
				return $output;
				break;

			default :
				return sanitize_title_with_dashes( $class );
				break;

		}
	}

}

function woo_pd_is_valid_visibility( $status = null ) {

	if( $status !== null ) {
		$status = strtolower( $status );
		switch( $status ) {

			default:
			case '1':
			case 'on':
			case 'yes':
			case 'catalog & search':
			case 'catalog and search':
				$status = 'visible';
				break;

			case 'visible':
			case 'catalog':
			case 'search':
			case 'hidden':
				return $status;
				break;

			case '0':
			case 'off':
			case 'no':
				$status = 'hidden';
				break;

		}
	}
	return $status;

}

function woo_pd_is_valid_product_type( $product_type = null ) {

	global $import;

	$types = woo_pd_get_product_types();
	// woo_pd_error_log( print_r( $types, true ) );
	$product_types = array_keys( $types );
	// woo_pd_error_log( print_r( $product_types, true ) );
	// woo_pd_error_log( $product_type );
	$product_type = sanitize_key( $product_type );
	// woo_pd_error_log( $product_type );

	// WooCommerce Subscriptions
	if( woo_pd_detect_import_plugin( 'subscriptions' ) ) {
		if( strstr( $product_type, 'simple' ) && strstr( $product_type, 'subscription' ) ) {
			// Simple Subscription
			$product_type = 'subscription';
		} else if( strstr( $product_type, 'variable' ) && strstr( $product_type, 'subscription' ) ) {
			// Variable  Subscription
			$product_type = 'variable-subscription';
		} else if( strstr( $product_type, 'subscription' ) ) {
			// Simple Subscription
			$product_type = 'subscription';
		}
	}

	// Default the Product Type to Simple
	$output = 'simple';
	if( in_array( $product_type, $product_types ) )
		$output = $product_type;

	$output = apply_filters( 'woo_pd_is_valid_product_type', $output, $product_type );

	// woo_pd_error_log( 'output: ' . $output );
	// woo_pd_error_log( '...' );

	return $output;

}

function woo_pd_is_valid_featured( $status = null, $default = null ) {

	if( $status !== null ) {
		$status = strtolower( $status );
		$output = $default;
		switch( $status ) {

			case '0':
			case 'no':
			case 'n':
			case 'off':
				$output = 'no';
				break;

			case '1':
			case 'yes':
			case 'y':
			case 'on':
				$output = 'yes';
				break;

			default:
				if( $default !== null )
					$output = $default;
				break;

		}
		return $output;
	}

}

function woo_pd_is_valid_sold_individually( $status = null ) {

	if( $status !== null ) {
		$status = strtolower( $status );
		switch( $status ) {

			case '0':
			case 'no':
			case 'n':
			case 'off':
				$output = '';
				break;

			case '1':
			case 'yes':
			case 'y':
			case 'on':
				$output = 'yes';
				break;

		}
		return $output;
	}

}

function woo_pd_is_valid_list( $list = null, $type = '' ) {

	global $import, $product;

	if( strpos( $list, $import->category_separator ) !== false )
		$product->{$type} = explode( $import->category_separator, $list );
	else
		$product->{$type} = (array)$list;
	$size = count( $product->{$type} );
	switch( $type ) {

		case 'upsells':
		case 'crosssells':
			for( $i = 0; $i < $size; $i++ ) {
				// Are we dealing with a Product SKU
				if( is_string( $product->{$type}[$i] ) ) {
					$product_id = woo_pd_get_product_id_by_sku( $product->{$type}[$i] );
					if( !empty( $product_id ) )
						$product->{$type}[$i] = $product_id;
					else
						unset( $product->{$type}[$i] );
					unset( $product_id );
				// Maybe we are dealing with a Post ID
				} else if( is_numeric( $product->{$type}[$i] ) ) {
					$post_status = get_post_status( $product->{$type}[$i] );
					if( !is_string( $post_status ) )
						unset( $product->{$type}[$i] );
				}
			}
			$product->{$type} = array_values( $product->{$type} );
			break;

	}

	return $list;

}

function woo_pd_is_valid_download_files( $downloads = null ) {

	global $import, $product;

	if( strpos( $downloads, $import->category_separator ) )
		$product->download_files = explode( $import->category_separator, $downloads );
	else
		$product->download_files = (array)$downloads;
	return $downloads;

}

function woo_pd_is_valid_download_type( $download_type = null ) {

	if( $download_type ) {
		$download_type = strtolower( $download_type );
		switch( $status ) {

			case 'standard':
				$output = '';
				break;

			case 'application':
				$output = 'application';
				break;

			case 'music':
				$output = 'music';
				break;

		}
		return $output;
	}

}

// Advanced Google Product Feed integration

/*
 * Validates the given Google Product Feed availability value
 *
 * Since: -
 *
 */
function woo_pd_is_valid_gpf_availability( $availability ) {

	if( $availability ) {
		$availability = strtolower( $availability );
		switch( $availability ) {

			case 'in stock':
				$output = 'in stock';
				break;

			case 'available for order':
				$output = 'available for order';
				break;

			case 'preorder':
				$output = 'preorder';
				break;

		}
		return $output;
	}

}

/*
 * Validates the given Google Product Feed condition value
 *
 * Since: -
 *
 */
function woo_pd_is_valid_gpf_condition( $condition ) {

	if( $condition ) {
		$condition = strtolower( $condition );
		switch( $condition ) {

			case 'new':
				$output = 'new';
				break;

			case 'refurbished':
				$output = 'refurbished';
				break;

			case 'used':
				$output = 'used';
				break;

		}
		return $output;
	}

}

/*
 * Validates the given Google Product Feed gender value
 *
 * Since: -
 *
 */
function woo_pd_is_valid_gpf_gender( $gender ) {

	if( $gender ) {
		$gender = strtolower( $gender );
		switch( $gender ) {

			case 'male':
				$output = 'male';
				break;

			case 'female':
				$output = 'female';
				break;

			case 'unisex':
				$output = 'unisex';
				break;

		}
		return $output;
	}

}

/*
 * Validates the given Google Product Feed age group value
 *
 * Since: -
 *
 */
function woo_pd_is_valid_gpf_age_group( $age_group ) {

	if( $age_group ) {
		$age_group = strtolower( $age_group );
		switch( $age_group ) {

			case 'adult':
				$output = 'adult';
				break;

			case 'kids':
				$output = 'kids';
				break;

		}
		return $output;
	}

}

// WordPress SEO integration

function woo_pd_is_valid_meta_robots_noindex( $noindex ) {

	$noindex = strtolower( $noindex );
	switch( $noindex ) {

		case 'default':
		case '0':
		default:
			$output = null;
			break;

		case '1':
		case 'noindex':
			$output = 1;
			break;

		case '2':
		case 'index':
			$output = 2;
			break;

	}
	return $output;

}

function woo_pd_is_valid_meta_robots_nofollow( $nofollow ) {

	$nofollow = strtolower( $nofollow );
	switch( $nofollow ) {

		case 'follow':
		case '0':
		default:
			$output = null;
			break;

		case '1':
		case 'nofollow':
			$output = 1;
			break;

	}
	return $output;

}

function woo_pd_is_valid_meta_robots_adv( $advanced = null ) {

	global $import, $product;

	$allowed = array(
		'none',
		'noodp',
		'noydir',
		'noarchive',
		'nosnippet'
	);

	if( strpos( $advanced, $import->category_separator ) ) {
		$options = explode( $import->category_separator, $advanced );
		$size = count( $options );
		$product->wpseo_meta_robots_advs = array();
		for( $i = 0; $i < $size; $i++ ) {
			if( in_array( $options[$i], $allowed ) )
				$product->wpseo_meta_robots_advs[] = $options[$i];
		}
	} else {
		// Check if option is matched
		if( in_array( $advanced, $allowed ) )
			$product->wpseo_meta_robots_advs = (array)$advanced;
	}
	return $advanced;

}

// Include in HTML Sitemap & Authorship within WordPress SEO share the same options
function woo_pd_is_valid_sitemap_html_include( $include ) {

	$include = strtolower( $include );
	switch( $include ) {

		case 'default':
		case 'auto':
		case 'auto detect':
		default:
			$output = null;
			break;

		case 'never':
		case '0':
			$output = 'never';
			break;

		case 'always':
		case '1':
			$output = 'always';
			break;

	}
	return $output;

}

// Product validation check of required columns.
function woo_pd_validate_product() {

	global $import, $product;

	$status = false;
	$import_method = $import->import_method;
	$product->fail_requirements = false;
	$product->failed_reason = __( 'No specific reason was given, raise this as a Support issue.', 'woocommerce-product-importer' );
	$has_id = ( !empty( $product->ID ) ? true : false );
	$has_sku = ( !empty( $product->sku ) ? true : false );
	$has_name = ( !empty( $product->name ) ? true : false );
	$has_duplicate = ( !empty( $product->duplicate_exists ) ? true : false );

	if( in_array( $import_method, array( 'merge', 'update' ) ) ) {
		// Merge Product details - Only requires SKU and an existing Product
		if( $import_method == 'update' ) {
			if( 
				( ( ( !$has_sku && $has_id ) || ( !$has_id && $has_sku ) ) && !$has_duplicate ) || 
				!$product->duplicate_exists
			) {
				$status = true;
			}
		} else if( $import_method == 'merge' ) {
			$status = true;
			// Create new Product if an existing Product does not exist
			if( $has_duplicate == false ) {
				// Create new Product - Requires either Name or SKU
				if( ( $has_name && !$has_sku ) || ( $has_sku && !$has_name ) || ( $has_name && $has_sku ) )
					$status = false;
			} else {
				if( ( ( !$has_sku && $has_id ) || ( !$has_id && $has_sku ) ) )
					$status = false;
			}
		}
	} else if( $import_method == 'delete' ) {
		// Delete Product - Requires an existing Product
		if( !$product->duplicate_exists )
			$status = true;
	} else if( $import_method == 'new' ) {
		// Create new Product - Requires either Name or SKU and no existing Product
		if( ( !$has_name || !$has_sku ) || $has_duplicate ) {
			$status = true;
			if( ( $has_name && !$has_sku ) || ( $has_sku && !$has_name ) || ( $has_sku && $has_name ) && !$has_duplicate )
				$status = false;
			if( $product->duplicate_exists )
				$status = true;
		}
	}

	// Spin up the validation reason if status is true
	if( $status ) {
		$import->fail_requirements = true;
		$product->fail_requirements = true;
		$failed_reason = array();

		// Check for missing SKU on update/merge
		if( in_array( $import_method, array( 'merge', 'update' ) ) ) {
			if( $import_method == 'update' ) {
				if( ( !$has_id && !$has_sku ) )
					$failed_reason[] = __( 'No SKU was provided.', 'woocommerce-product-importer' );
			}
		}

		if( in_array( $import->import_method, array( 'merge', 'update' ) ) ) {
			if( $import->import_method == 'merge' && !$has_name ) {
				$failed_reason[] = __( 'No Product Name was provided.', 'woocommerce-product-importer' );
			} else if( $import->import_method == 'update' && !$has_duplicate ) {
				$reason = '';
				$reasons = array();
				if( $has_id )
					$reasons[] = sprintf( __( 'Post ID \'%d\'', 'woocommerce-product-importer' ), $product->ID );	
				if( $has_sku )
					$reasons[] = sprintf( __( 'SKU \'%s\'', 'woocommerce-product-importer' ), $product->sku );
				if( $has_name )
					$reasons[] = sprintf( __( 'Product Name \'%s\'', 'woocommerce-product-importer' ), $product->name );
				if( !empty( $reasons ) ) {
					$size = count( $reasons );
					for( $i = 0; $i < $size; $i++ ) {
						// SKU, Product Name or Post ID
						if( $size >= 3 ) {

							if( $i < ( $size - 1 ) ) {
								if( $i == ( $size - 1 ) )
									$reason .= $reasons[$i] . sprintf( ' %s ', __( 'or', 'woocommerce-product-importer' ) );
								else
									$reason .= $reasons[$i] . ', ';
							} else {
								$reason .= $reasons[$i];
							}

						// SKU or Product Name
						} else if( $size >= 2 ) {

							if( $i < ( $size - 1 ) )
								$reason .= $reasons[$i] . sprintf( ' %s ', __( 'or', 'woocommerce-product-importer' ) );
							else
								$reason .= $reasons[$i];

						// SKU
						} else {
							$reason = $reasons[$i];
						}
					}
					$failed_reason[] = sprintf( __( 'An existing Product matching the %s could not be found.', 'woocommerce-product-importer' ), $reason );
				} else {
					$failed_reason[] = __( 'An existing Product could not be found.', 'woocommerce-product-importer' );
				}
			}
		} else if( $import->import_method == 'delete' ) {
			if( !$product->duplicate_exists )
				$failed_reason[] = __( 'An existing Product could not be found.', 'woocommerce-product-importer' );
		} else {
			if( $product->duplicate_exists )
				$failed_reason[] = sprintf( __( 'A duplicate Product - %s - already exists.', 'woocommerce-product-importer' ), ( !empty( $product->sku ) ? $product->sku : $product->name ) );
			else
				$failed_reason[] = __( 'No Product details were detected on this row.', 'woocommerce-product-importer' );
		}

		// Default failed reason if none is found
		if( empty( $failed_reason ) ) {
			$failed_reason[] = __( 'No specific reason was given, Product validation details have been logged to WooCommerce > System Status > Logs > woo_pd..., raise this as a Support issue.', 'woocommerce-product-importer' );
			woo_pd_error_log( 'woo_pd_validate_product() failed to detect a valid validation reason' );
			woo_pd_error_log( 'import_method: ' . $import_method );
			woo_pd_error_log( '$product->ID: ' . absint( $has_id ) . ' - ' . $product->ID );
			woo_pd_error_log( '$product->sku: ' . absint( $has_sku ) . ' - ' . $product->sku );
			woo_pd_error_log( '$product->name: ' . absint( $has_name ) . ' - ' . $product->name );
			woo_pd_error_log( '$product->duplicate_exists: ' . absint( $has_duplicate ) . ' - ' . print_r( $product->duplicate_exists, true ) );
			woo_pd_error_log( '---' );
		}

		$size = count( $failed_reason );
		$product->failed_reason = $failed_reason[$size-1];

		$import->failed_products[] = array(
			'row' => $product->row_id,
			'sku' => $product->sku,
			'name' => $product->name,
			'price' => $product->price,
			'category' => str_replace( $import->category_separator, "<br />", str_replace( $import->parent_child_delimiter, ' &raquo; ', $product->category ) ),
			'reason' => $failed_reason
		);
		return true;
	}

}

function woo_pd_get_product_count() {

	// Limited to counting basic Products only
	$post_type = 'product';
	$count = 0;
	if( $statuses = wp_count_posts( $post_type ) ) {
		foreach( $statuses as $key => $status ) {
			// Ignore draft
			if( !in_array( $key, array( 'auto-draft' ) ) )
				$count = $count + $status;
		}
	}
	return $count;

}

function woo_pd_get_product_types() {

	$args = array(
		'hide_empty' => 0
	);
	$product_types = get_terms( 'product_type', $args );
	// Let's clean up the Terms a little by adding the Term slug as the array key
	if( !is_wp_error( $product_types ) && !empty( $product_types ) ) {
		foreach( $product_types as $key => $product_type ) {
			$product_types[$product_type->slug] = $product_type;
			unset( $product_types[$key] );
		}
		// Add the Variation Type to the list of Product Types
		$product_types['variation'] = (object)array(
			'name' => 'variation',
			'slug' => 'variation',
			'count' => 0
		);
		return $product_types;
	}

}

function woo_pd_get_product_attributes() {

	global $wpdb;

	// Fetch the global Product Attributes
	$attributes_sql = "SELECT `attribute_name` as name, `attribute_label` as label, `attribute_type` as type FROM `" . $wpdb->prefix . "woocommerce_attribute_taxonomies`";
	$attributes = $wpdb->get_results( $attributes_sql );
	$wpdb->flush();
	if( !empty( $attributes ) ) {
		$output = array();
		foreach( $attributes as $attribute ) {
			$output[] = array(
				'label' => $attribute->label,
				'name' => $attribute->name,
				'type' => $attribute->type
			);
		}
		unset( $attributes, $attribute );
		return $output;
	}

}

// Returns the Attribute Slug when passed a Attribute Name
function woo_pd_get_product_attribute_slug_by_name( $name = '', $term_taxonomy = '' ) {

	$output = false;
	if( !empty( $term_taxonomy ) ) {
		$term = get_term_by( 'name', esc_attr( $name ), $term_taxonomy );
		if( !empty( $term ) )
			$output = $term->slug;
		unset( $term );
	}
	return $output;

}

function woo_pd_get_product_id_by_sku( $sku = '' ) {

	if( !empty( $sku ) ) {
		$post_type = array( 'product', 'product_variation' );
		$meta_key = '_sku';
		$args = array(
			'post_type' => $post_type,
			'meta_key' => $meta_key,
			'meta_value' => $sku,
			'posts_per_page' => 1,
			'post_status' => 'any',
			'fields' => 'ids',
			'orderby' => 'ID',
			'order' => 'ASC'
		);
		$products = new WP_Query( $args );
		if( !empty( $products->found_posts ) ) {
			// Check for a corrupt Product
			$product = get_post( $products->posts[0] );
			if( $product !== false )
				return $products->posts[0];
		}
	}

}

function woo_pd_delete_product() {

	global $import, $product;

	$response = wp_delete_post( $product->duplicate_exists, true );
	if( $response !== false ) {
		if( function_exists( 'wc_delete_product_transients' ) )
			wc_delete_product_transients( $product->duplicate_exists );
		$import->products_deleted++;
		$product->deleted = true;
	} else {
		$import->products_failed++;
	}

}

function woo_pd_create_product_image( $filename = '', $has_filepath = false ) {

	global $import, $product;

	woo_pd_upload_directories();

	@error_reporting( 0 );
	// 5 minutes per image should be PLENTY
	@set_time_limit( 900 );

	$image = new stdClass;

	$image_exists = false;
	$duplicate_image_method = woo_pd_get_option( 'duplicate_image_method', 'new' );
	if( $duplicate_image_method == 'reuse' ) {
		// Check if the Attachment already exists
		$post_type = 'attachment';
		$args = array(
			'post_type' => $post_type,
			'post_status' => 'inherit',
			'meta_key' => '_wp_attached_file',
			'meta_value' => $filename,
			'numberposts' => 1,
			'cache_results' => false
		);
		$image_exists = get_posts( $args );
		if( WOO_PD_LOGGING ) {
			woo_pd_error_log( 'woo_pd_create_product_image( ' . $filename . ', ' . absint( $has_filepath ) . ' )' );
			woo_pd_error_log( 'args: ' . print_r( $args, true ) );
			woo_pd_error_log( 'response: ' . print_r( $image_exists, true ) );
		}
	}

/*
	// Set Image path for existing search
	if( isset( $import->date_directory ) && $import->date_directory )
		$image_rel_path = $import->date_directory . $filename;
	else
		$image_rel_path = $filename;

	// @mod - Let's not rely on our original_url meta just yet
	$post_type = 'attachment';
	$args = array(
		'post_type' => $post_type,
		'post_status' => 'inherit',
		'meta_key' => '_original_url',
		'meta_value' => $filename,
		'numberposts' => 1,
		'cache_results' => false
	);
	$image_exists = get_posts( $args );
*/

	if( $image_exists ) {

		$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Re-using Image: %s', 'woocommerce-product-importer' ), basename( $filename ) );
		return $image_exists[0]->ID;

/*
		// Duplicate existing Product image
		$i = 0;
		chdir( $import->uploads_path );
		$image->duplicate = substr( $filename, 0, -4 ) . '-' . $i . substr( $filename, -4, 4 );
		while( !file_exists( $image->duplicate ) ) {
			$i++;
			$image->duplicate = substr( $filename, 0, -4 ) . '-' . $i . substr( $filename, -4, 4 );
			@copy( $filename, $image->duplicate );
			if( $i == 10 ) {
				$import->log .= "<br />>>>>>> " . sprintf( __( 'Could not duplicate Image: %s', 'woocommerce-product-importer' ), $filename );
				break;
			}
		}
		// Re-set Image path with existing filename
		if( isset( $import->date_directory ) && $import->date_directory )
			$image_rel_path = $import->date_directory . $image->duplicate;
		else
			$image_rel_path = $image->duplicate;
		$image_save_path = $import->uploads_path . $image->duplicate;
		$image_attachment = array(
			'post_mime_type' => 'image/jpeg',
			'guid' => $image_exists[0]->guid,
			'post_parent' => $product->ID,
			'post_title' => $image_exists[0]->post_title,
			'post_content' => ''
		);
		if( $image->ID = wp_insert_attachment( $image_attachment, $image_rel_path, $product->ID ) ) {
			$attachment_metadata = wp_generate_attachment_metadata( $image->ID, $image_save_path );
			if( WOO_PD_DEBUG !== true ) {
				wp_update_attachment_metadata( $image->ID, $attachment_metadata );
				update_post_meta( $image->ID, '_woocommerce_exclude_image', '0' );
			}
			$import->log .= "<br />>>>>>> " . sprintf( __( 'Image Duplicated: %s', 'woocommerce-product-importer' ), $image->duplicate );
			return $image->ID;
		} else {
			$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Skipped Image: %s', 'woocommerce-product-importer' ), $image->duplicate );
		}
*/

	} else {

		// Generate new Product image

		if( $has_filepath ) {
			$image_rel_path = $filename;
		} else {
			if( isset( $import->date_directory ) && $import->date_directory )
				$image_rel_path = $import->date_directory . $filename;
			else
				$image_rel_path = $filename;
		}
		// Check what image filename method we are using
		switch( $import->image_method ) {

			case 'csv':
				if( $import->image_filename_method == 'uploads' ) {
					$image_rel_path = ltrim( $filename, '/' );
					$image_save_path = woo_pd_format_path( $import->uploads_basedir . $filename );
				} else if( $import->image_filename_method == 'base' ) {
					// Move the image to the Uploads directory to play nice with WordPress Media API
					$bits = file_get_contents( preg_replace( '#/+#', '/', ABSPATH . $filename ) );
					$upload = wp_upload_bits( $filename, null, $bits );
					$image_save_path = $import->uploads_path . $filename;
				}
				break;

			case 'external':
				if( $has_filepath )
					$image_save_path = $import->uploads_basedir . $filename;
				else
					$image_save_path = $import->uploads_path . $filename;
				break;

		}
		$image_url = sprintf( '%s/wp-content/uploads/%s', get_bloginfo( 'url' ), $image_rel_path );
		// Check the post_mime_type
		$post_mime_type = 'image/jpeg';
		$filetype = wp_check_filetype( basename( $filename ) );
		if( !empty( $filetype ) )
			$post_mime_type = ( !empty( $filetype['mime'] ) ? $filetype['mime'] : $post_mime_type );
		$post_title = ( $product->featured_image_title !== null ? $product->featured_image_title : preg_replace( '/\.[^.]+$/', '', basename( $filename ) ) );
		$post_excerpt = ( $product->featured_image_caption !== null ? $product->featured_image_caption : '' );
		$post_content = ( $product->featured_image_description !== null ? $product->featured_image_description : '' );
		$args = array(
			'post_mime_type' => $post_mime_type,
			'guid' => $image_url,
			'post_parent' => $product->ID,
			'post_title' => $post_title,
			'post_excerpt' => $post_excerpt,
			'post_content' => $post_content
		);
		if( $image->ID = wp_insert_attachment( $args, $image_rel_path, $product->ID ) ) {
			$attachment_metadata = wp_generate_attachment_metadata( $image->ID, $image_save_path );
			if( WOO_PD_DEBUG !== true ) {
				wp_update_attachment_metadata( $image->ID, $attachment_metadata );
				update_post_meta( $image->ID, '_woocommerce_exclude_image', '0' );
				if( $product->featured_image_alt_text !== null )
					update_post_meta( $image->ID, '_wp_attachment_image_alt', $product->featured_image_alt_text );
			}
			$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Linked Image: %s', 'woocommerce-product-importer' ), basename( $filename ) );
			return $image->ID;
		} else {
			$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Skipped Image: %s', 'woocommerce-product-importer' ), basename( $filename ) );
		}

	}

}

function woo_pd_download_product_image( $image = '' ) {

	global $import;

	if( !empty( $image ) ) {

		woo_pd_upload_directories();

		// Make consistant
		$site_url = trailingslashit( str_replace( 'www.', '', site_url() ) );
		$url = str_replace( 'www.', '', $image );

		// Check if allow_url_fopen is set
		$allow_url_fopen = ( function_exists( 'ini_get' ) ? ini_get( 'allow_url_fopen' ) : false );

		// Same host
		if( strstr( $url, $site_url ) && apply_filters( 'woo_pd_download_product_image_same_host', true ) ) {
			$filename = woo_pd_get_filename( $image );
			$filename = sanitize_file_name( $filename );
			$url = woo_pd_format_path( str_replace( $site_url, ABSPATH, $url ) );
			// Check if this is a Windows OS and sanitize the filename further
			if( defined( 'PHP_OS' ) ) {
				if( strtoupper( substr( PHP_OS, 0, 3) ) === 'WIN' )
					$filename = preg_replace( array('/\s/', '/\.[\.]+/', '/[^\w_\.\-]/'), array('_', '.', ''), $filename );
			}
			// Check if the Image already exists within the WordPress Uploads directory
			if( strstr( $url, $import->uploads_basedir ) ) {
				$url = str_replace( $import->uploads_basedir, '', $url );
				if( $allow_url_fopen ) {
					// Check if the supplied download is an image
					$size = @getimagesize( $import->uploads_basedir . $url );
				} else {
					$size = true;
					woo_pd_error_log( sprintf( '%s: Warning: %s', basename( woo_pd_get_option( 'csv' ) ), __( 'getimagesize(): http:// wrapper is disabled in the server configuration by allow_url_fopen=0', 'woocommerce-product-importer' ) ) );
					$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Warning: %s', 'woocommerce-product-importer' ), __( 'getimagesize(): http:// wrapper is disabled in the server configuration by allow_url_fopen=0', 'woocommerce-product-importer' ) );
				}
				if( $size ) {
					$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Re-using Attachment: %s', 'woocommerce-product-importer' ), $filename );
					return $url;
				}
			}
			$fp = fopen( $url, 'rb' );
			$img = '';
			if( $fp ) {
				while( !feof( $fp ) )
					$img = $img . fread( $fp, 1024 );
			}
			fclose( $fp );
			$nfile = $import->uploads_path . $filename;
			$fp2 = @fopen( $nfile, 'wb' );
			fwrite( $fp2, $img );
			fclose( $fp2 );
			if( $allow_url_fopen ) {
				// Check if the supplied download is an image
				$size = @getimagesize( $import->uploads_path . $filename );
			} else {
				$size = true;
				woo_pd_error_log( sprintf( '%s: Warning: %s', basename( woo_pd_get_option( 'csv' ) ), __( 'getimagesize(): http:// wrapper is disabled in the server configuration by allow_url_fopen=0', 'woocommerce-product-importer' ) ) );
				$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Warning: %s', 'woocommerce-product-importer' ), __( 'getimagesize(): http:// wrapper is disabled in the server configuration by allow_url_fopen=0', 'woocommerce-product-importer' ) );
			}
			if( $size ) {
				$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Downloaded Image: %s', 'woocommerce-product-importer' ), $filename );
				return $filename;
			} else {
				if( file_exists( $import->uploads_path . $filename ) )
					@unlink( $import->uploads_path . $filename );
				if( $import->advanced_log )
					$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Skipped Image download: %s - Error: %s', 'woocommerce-product-importer' ), $image, __( 'Could not detect the image dimensions', 'woocommerce-product-importer' ) );
				else
					$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Skipped Image download: %s', 'woocommerce-product-importer' ), $image );
			}
		} else {
			$bits = wp_remote_fopen( $image );
			$filename = woo_pd_get_filename( $image );
			$filename = sanitize_file_name( $filename );
			// Check if this is a Windows OS and sanitize the filename further
			if( defined( 'PHP_OS' ) ) {
				if( strtoupper( substr( PHP_OS, 0, 3) ) === 'WIN' )
					$filename = preg_replace( array('/\s/', '/\.[\.]+/', '/[^\w_\.\-]/'), array('_', '.', ''), $filename );
			}
			if( $allow_url_fopen ) {
				$size = @getimagesize( $image );

				// Allow Allow Plugin/Theme authors to force accept URL's as is
				$size = apply_filters( 'woo_pd_http_file_exists_force_exists', $size, $image );

			} else {
				$size = true;
				woo_pd_error_log( sprintf( '%s: Warning: %s', basename( woo_pd_get_option( 'csv' ) ), __( 'getimagesize(): http:// wrapper is disabled in the server configuration by allow_url_fopen=0', 'woocommerce-product-importer' ) ) );
				$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Warning: %s', 'woocommerce-product-importer' ), __( 'getimagesize(): http:// wrapper is disabled in the server configuration by allow_url_fopen=0', 'woocommerce-product-importer' ) );
			}
			// Check if the supplied download is an image
			if( $size ) {
				// Check if the filename and file is populated
				if( !empty( $filename ) && !empty( $bits ) ) {
					$upload = wp_upload_bits( $filename, null, $bits );
					if( $upload['error'] ) {
						$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Failed Image saving: %s - Error: %s', 'woocommerce-product-importer' ), $filename, $upload['error'] );
					} else {
						$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Downloaded Image: %s', 'woocommerce-product-importer' ), $filename );
						return $filename;
					}
				} else {
					if( $import->advanced_log )
						$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Failed Image download: %s - Error: %s', 'woocommerce-product-importer' ), $image, __( 'Image filename or image data were empty', 'woocommerce-product-importer' ) );
					else
						$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Failed Image download: %s', 'woocommerce-product-importer' ), $image );
				}
			} else {
				if( $import->advanced_log )
					$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Failed Image download: %s - Error: %s', 'woocommerce-product-importer' ), $image, __( 'Could not detect the image dimensions', 'woocommerce-product-importer' ) );
				else
					$import->log .= "<br />>>>>>>>>> " . sprintf( __( 'Failed Image download: %s', 'woocommerce-product-importer' ), $image );
			}
		}

	}

}
?>