<div id="content" class="woo_pd_page_options">
	<?php woo_pd_total_columns(); ?>
	<p><?php _e( 'Using the drop down menu match each column in your import file to a Product detail, then click Upload file and import.', 'woocommerce-product-importer' ); ?></p>
	<form enctype="multipart/form-data" method="post" action="<?php echo add_query_arg( 'action', null ); ?>" class="options">
		<table class="wp-list-table widefat page striped fixed">
			<thead>

				<tr>
					<!-- <th class="manage-column column-equals">&nbsp;</th> -->
					<th class="manage-column order_status column-order_status"><span class="status_head tips"><?php _e( 'Status', 'woocommerce-product-importer' ); ?></span></th>
					<th class="manage-column column-row text-align-right"><?php _e( 'First Row', 'woocommerce-product-importer' ); ?></th>
					<th class="manage-column column-equals">&nbsp;</th>
					<th class="manage-column"><?php _e( 'Import file', 'woocommerce-product-importer' ); ?> &raquo; <?php _e( 'WooCommerce', 'woocommerce-product-importer' ); ?> (<a href="javascript:void(0)" id="cell-unselectall" class="unselectall" title="<?php _e( 'Unselect all linked import fields', 'woocommerce-product-importer' ); ?>"><?php _e( 'Unselect all', 'woocommerce-product-importer' ); ?></a>)</th>
					<th class="manage-column"><?php _e( 'Second Row', 'woocommerce-product-importer' ); ?> <small>(*)</small></th>
				</tr>

			</thead>
			<tbody>

<?php if( !empty( $first_row ) ) { ?>
	<?php foreach( $first_row as $key => $cell ) { ?>
				<tr id="import_field_row-<?php echo $key; ?>">
					<!-- <th class="manage-column column-equals"><input type="checkbox" name="import_row[]" value="<?php echo $key; ?>" /></th> -->
					<th class="manage-column order_status column-order_status">
						<mark id="import_field_status-<?php echo $key; ?>" class="on-hold tips">...</mark>
					</th>
					<th class="text-align-right" valign="top">
						<input type="hidden" name="column[]" value="<?php echo $key + 1; ?>" />
						<code><?php echo $cell; ?></code>
					</th>
					<td class="text-align-center column-equals"><strong>=</strong></td>
					<td>
						<select id="import_field_select-<?php echo $key; ?>" name="value_name[]" data-key="<?php echo $key; ?>">
							<option value=""><?php _e( 'Unlinked', 'woocommerce-product-importer' ); ?></option>
							<option disabled>---</option>
		<?php if( !empty( $import->options ) ) { ?>
			<?php foreach( $import->options as $option ) { ?>
							<?php woo_pd_options_open_optgroup( $option ); ?>
							<option value="<?php echo $option['name']; ?>"<?php selected( woo_pd_search_column( $option, woo_pd_format_column( $cell ) ), woo_pd_format_column( $cell ) ); ?><?php if( isset( $option['disabled'] ) ) { disabled( $option['disabled'], 1 ); } ?>><?php echo $option['label']; ?></option>
							<?php woo_pd_options_close_optgroup( $option ); ?>
			<?php } ?>
		<?php } ?>
						</select>
						<a href="javascript:void(0)" class="clear-link" title="<?php _e( 'Unselect this linked import field', 'woocommerce-product-importer' ); ?>" data-key="<?php echo $key; ?>"><span class="dashicons dashicons-no-alt"></span></a>
					</td>
					<td>
						<code><?php woo_pd_format_cell_preview( $second_row[$key], $key, $cell ); ?></code>
					</td>
				</tr>
	<?php } ?>
<?php } ?>

			</tbody>
		</table>
		<p class="description"><?php _e( '<small>(*)</small> If your import file contains special characters - such as &aelig;, &szlig;, &eacute;, etc. - they may display weird under the First and Second Row above, please continue regardless.', 'woocommerce-product-importer' ); ?></p>

		<div id="poststuff">
			<div class="postbox">
				<h3 class="hndle"><?php _e( 'Import Options', 'woocommerce-product-importer' ); ?></h3>
				<div class="inside">
					<table class="form-table">

						<tr>
							<td>
								<label for="import_method"><strong><?php _e( 'Import method', 'woocommerce-product-importer' ); ?></strong></label>
								<div>
									<p><label><input type="radio" name="import_method" value="new"<?php checked( $import->import_method, 'new' ); ?> /><?php _e( 'Import new Products only', 'woocommerce-product-importer' ); ?></label></p>
									<p><label><input type="radio" name="import_method" value="delete"<?php disabled( $products, 0 ); ?><?php checked( $import->import_method, 'delete' ); ?> /><?php _e( 'Delete matching Products', 'woocommerce-product-importer' ); ?></label></p>
									<p><label><input type="radio" name="import_method" value="merge"<?php checked( $import->import_method, 'merge' ); ?> /><?php _e( 'Import new Products and merge Product changes', 'woocommerce-product-importer' ); ?></label></p>
									<p><label><input type="radio" name="import_method" value="update"<?php disabled( $products, 0 ); ?><?php checked( $import->import_method, 'update' ); ?> /><?php _e( 'Merge Product changes only', 'woocommerce-product-importer' ); ?></label></p>
								</div>
								<p class="description">
									<?php _e( 'Adjust the import method to suit your import needs. Deleted and merged Product changes are matched by the SKU.', 'woocommerce-product-importer' ); ?>
<?php if( !$products ) { ?>
									<?php _e( 'The <em>Delete matching Products</em> and <em>Merge Product changes only</em> import methods have been disabled till a Product exists within your store.', 'woocommerce-product-importer' ); ?>
<?php } ?>
								</p>
							</td>
						</tr>

						<tr id="image_import_method">
							<td>
								<label><strong><?php _e( 'Image import method', 'woocommerce-product-importer' ); ?></strong></label>
								<p>
									<label>
										<input type="radio" id="image_method_csv" name="image_method" value="csv"<?php checked( $import->image_method, 'csv' ); ?> /> <?php _e( 'Assigned an image filename column for Products in the import file', 'woocommerce-product-importer' ); ?><br />
										<span class="description"><?php _e( 'Image filename and path is relative to the image filename method set below. For instance', 'woocommerce-product-importer' ); ?>: product-1a.jpg<?php echo $import->category_separator; ?>product-1b.jpg<?php echo $import->category_separator; ?>product-1c.jpg</span>
									</label>
								</p>
								<p>
									<label>
										<input type="radio" id="image_method_external" name="image_method" value="external"<?php checked( $import->image_method, 'external' ); ?> /> <?php _e( 'Assigned an external URL column for Products in the import file', 'woocommerce-product-importer' ); ?><br />
										<span class="description"><?php _e( 'External URL\'s must be absolute - full URI - and accessible by WordPress. For instance', 'woocommerce-product-importer' ); ?>: http://www.domain.com/images/product-1a.jpg<?php echo $import->category_separator; ?>http://www.domain.com/images/product-1b.jpg<?php echo $import->category_separator; ?>http://www.domain.com/images/product-1c.jpg</span>
									</label>
								</p>
								<hr class="description" />
								<p>
									<label>
										<input type="radio" id="image_method_none" name="image_method" value=""<?php checked( $import->image_method, '' ); ?> /> <?php _e( 'I am not uploading Product images', 'woocommerce-product-importer' ); ?>
									</label>
								</p>
							</td>
						</tr>

						<tr id="image_filename_method">
							<td>
								<label><strong><?php _e( 'Image filename method', 'woocommerce-product-importer' ); ?></strong></label>
								<p>
									<label>
										<input type="radio" id="image_filename_uploads" name="image_filename_method" value="uploads"<?php checked( $import->image_filename_method, 'uploads' ); ?> /> <?php _e( 'Image filenames are relative to the WordPress Uploads directory', 'woocommerce-product-importer' ); ?><br />
										<span class="description"><?php printf( __( 'Images need to be uploaded to: %s...', 'woocommerce-product-importer' ), $import->uploads_path ); ?></span>
									</label>	
								</p>
								<p>
									<label>
										<input type="radio" id="image_filename_base" name="image_filename_method" value="base"<?php checked( $import->image_filename_method, 'base' ); ?> /> <?php _e( 'Image filenames are relative to the WordPress base directory', 'woocommerce-product-importer' ); ?><br />
										<span class="description"><?php printf( __( 'Images need to be uploaded below: %s... For instance: ', 'woocommerce-product-importer' ), ABSPATH ); ?> product_images/product-1a.jpg<?php echo $import->category_separator; ?>product_images/product-1b.jpg<?php echo $import->category_separator; ?>product_images/product-1c.jpg</span>
									</label>
								</p>
								<p class="description"><?php _e( 'If you are using the <em>Assigned an image filename for Products in the import file</em> image import method then adjust the image filename method based on your image file path.', 'woocommerce-product-importer' ); ?></p>
							</td>
						</tr>

						<tr id="duplicate_image_method">
							<td>
								<label><strong><?php _e( 'Duplicate image control', 'woocommerce-product-importer' ); ?></strong></label>
								<p>
									<label>
										<input type="radio" id="duplicate_image_new" name="duplicate_image_method" value="new"<?php checked( $import->duplicate_image_method, 'new' ); ?> /> <?php _e( 'Create new media items for each duplicate Product image', 'woocommerce-product-importer' ); ?><br />
										<span class="description"><?php _e( 'Create a separate media item where each duplicate Product image is detected.', 'woocommerce-product-importer' ); ?></span>
									</label>	
								</p>
								<p>
									<label>
										<input type="radio" id="duplicate_image_reuse" name="duplicate_image_method" value="reuse"<?php checked( $import->duplicate_image_method, 'reuse' ); ?> /> <?php _e( 'Re-use existing media items where duplicate Product images are detected', 'woocommerce-product-importer' ); ?><br />
										<span class="description"><?php _e( 'Re-use the existing media item for all duplicate Products where a duplicate Product image is detected.', 'woocommerce-product-importer' ); ?></span>
									</label>
								</p>
								<p class="description"><?php _e( 'Use these options to control how Product Importer Deluxe should deal with duplicate Product images.', 'woocommerce-product-importer' ); ?></p>
							</td>
						</tr>

						<tr>
							<td>
								<p><strong><?php _e( 'Advanced options', 'woocommerce-product-importer' ); ?></strong></p>
								<ul>
									<li>
										<label><input type="checkbox" name="skip_first" class="checkbox"<?php checked( $import->skip_first, 1 ); ?> value="1" /> <?php _e( 'Skip first row', 'woocommerce-product-importer' ); ?></label>
										<p class="description"><?php _e( 'Skip the first row of the import file if it contains column headers. Product Importer Deluxe detects columns headers at upload time and toggles this option if neccesary.', 'woocommerce-product-importer' ); ?>
									</li>
									<li>
										<label><input type="checkbox" name="skip_category" class="checkbox"<?php checked( $import->skip_category, 1 ); ?> value="1" /> <?php _e( 'Skip Category generation', 'woocommerce-product-importer' ); ?></label>
										<p class="description"><?php _e( 'Skip the generation of new Categories as part of the import process.', 'woocommerce-product-importer' ); ?>
									</li>
									<li>
										<label><input type="checkbox" name="skip_product_tag" class="checkbox"<?php checked( $import->skip_product_tag, 1 ); ?> value="1" /> <?php _e( 'Skip Product Tag generation', 'woocommerce-product-importer' ); ?></label>
										<p class="description"><?php _e( 'Skip the generation of new Product Tags as part of the import process.', 'woocommerce-product-importer' ); ?>
									</li>
									<li>
										<label><input type="checkbox" name="skip_shipping_class" class="checkbox"<?php checked( $import->skip_shipping_class, 1 ); ?> value="1" /> <?php _e( 'Skip Shipping Class generation', 'woocommerce-product-importer' ); ?></label>
										<p class="description"><?php _e( 'Skip the generation of new Shipping Classes as part of the import process.', 'woocommerce-product-importer' ); ?>
									</li>
									<li>
										<label><input type="checkbox" name="skip_brand" class="checkbox"<?php checked( $import->skip_brand, 1 ); ?> value="1" /> <?php _e( 'Skip Brand generation', 'woocommerce-product-importer' ); ?></label>
										<p class="description"><?php _e( 'Skip the generation of new Brands as part of the import process.', 'woocommerce-product-importer' ); ?>
									</li>
									<li>
										<label><input type="checkbox" name="advanced_log"<?php checked( $import->advanced_log, 1 ); ?> value="1" />&nbsp;<?php _e( 'Advanced import reporting', 'woocommerce-product-importer' ); ?></label>
										<p class="description"><?php _e( 'This option will provide a more detailed import log but comes at the expense of a slower import process. Default is off.', 'woocommerce-product-importer' ); ?></p>
									</li>
									<li>
										<label><input type="checkbox" name="special_category_assignment"<?php checked( $import->special_category_assignment, 1 ); ?> value="1" />&nbsp;<?php _e( 'Assign Products to lowest level sub-Category only', 'woocommerce-product-importer' ); ?></label>
										<p class="description"><?php printf( __( 'This option controls whether Products should be assigned to all Categories within the branch (e.g. %s), or just to the lowest level sub-Category (e.g. Cabbages). Default is off.', 'woocommerce-product-importer' ), __( 'Vegetables', 'woocommerce-product-importer' ) . $import->parent_child_delimiter . __( 'Greens', 'woocommerce-product-importer' ) . $import->parent_child_delimiter . __( 'Cabbages', 'woocommerce-product-importer' ) ); ?></p>
									</li>
									<li>
										<label><input type="checkbox" name="force_refresh_images"<?php checked( $import->force_refresh_images, 1 ); ?> value="1" />&nbsp;<?php _e( 'Force refresh Featured Image and Product Gallery', 'woocommerce-product-importer' ); ?></label>
										<p class="description"><?php printf( __( 'This option controls whether Featured Image and Product Gallery values are force refreshed (e.g. where an Image has corrupted on import and needs to be re-imported). Default is off.', 'woocommerce-product-importer' ) ); ?></p>
									</li>
<?php if( !ini_get( 'safe_mode' ) ) { ?>
									<li>
										<label for="timeout"><?php _e( 'Script timeout', 'woocommerce-product-importer' ); ?>: </label>
										<select id="timeout" name="timeout">
											<option value="600"<?php selected( $import->timeout, 600 ); ?>><?php printf( __( '%d minutes', 'woocommerce-product-importer' ), 10 ); ?></option>
											<option value="1800"<?php selected( $import->timeout, 1800 ); ?>><?php printf( __( '%d minutes', 'woocommerce-product-importer' ), 30 ); ?></option>
											<option value="3600"<?php selected( $import->timeout, 3600 ); ?>><?php printf( __( '%d hour', 'woocommerce-product-importer' ), 1 ); ?></option>
											<option value="0"<?php selected( $import->timeout, 0 ); ?>><?php _e( 'Unlimited', 'woocommerce-product-importer' ); ?></option>
										</select>
										<p class="description"><?php _e( 'Script timeout defines how long Product Importer Deluxe is \'allowed\' to process your import file, once the time limit is reached the import process halts. Default is Unlimited.', 'woocommerce-product-importer' ); ?></p>
									</li>
<?php } ?>
								</ul>
							</td>
						</tr>

					</table>
					<!-- .form-table -->
				</div>
				<!-- .inside -->
			</div>
			<!-- .postbox -->
		</div>
		<!-- #poststuff -->
		<?php wp_nonce_field( 'update-options' ); ?>
		<input type="hidden" name="action" value="save" />
		<input type="hidden" name="delimiter" value="<?php echo $import->delimiter; ?>" />
		<input type="hidden" name="category_separator" value="<?php echo $import->category_separator; ?>" />
		<input type="hidden" name="parent_child_delimiter" value="<?php echo $import->parent_child_delimiter; ?>" />
		<p class="submit">
			<input type="submit" value="<?php _e( 'Upload file and import', 'woocommerce-product-importer' ); ?>" class="button-primary" />
		</p>
		<p><?php printf( __( '<strong>Note</strong>: If the following screen goes blank simply hit your browser\'s Refresh (F5) button to continue the import process. If this fails please consult the <a href="%s" target="_blank">Usage page</a> of this Plugin for further assistance.', 'woocommerce-product-importer' ), $troubleshooting_url ); ?></p>
	</form>
	<!-- .options -->
</div>
<!-- #content -->