<ul class="subsubsub">
	<li><a href="#upload-csv"><?php _e( 'Upload Products', 'woocommerce-product-importer' ); ?></a> |</li>
	<li><a href="#import-options"><?php _e( 'Import Options', 'woocommerce-product-importer' ); ?></a> |</li>
	<li><a href="#past-imports"><?php _e( 'Past Imports', 'woocommerce-product-importer' ); ?></a> |</li>
	<li><a href="#custom-fields"><?php _e( 'Custom Import Fields', 'woocommerce-product-importer' ); ?></a></li>
</ul>
<!-- .subsubsub -->
<br class="clear" />

<p><strong><?php _e( 'G\'day, mate! Upload your Product catalog - formatted as a CSV, TXT or TSV file - and we\'ll import your Products into WooCommerce.', 'woocommerce-product-importer' ); ?></strong></p>
<p><?php printf( __( 'To help you get started, you can download the latest %s and %s any time from the Plugin detail page on our website.', 'woocommerce-product-importer' ), '<a href="' . $csv_sample_link . '" target="_blank">' . __( 'sample CSV\'s', 'woocommerce-product-importer' ) . '</a>', '<a href=" ' . $csv_template_link . '" target="_blank">' . __( 'CSV templates', 'woocommerce-product-importer' ) . '</a>' ); ?></p>
<form id="upload_form" enctype="multipart/form-data" method="post">
	<div id="poststuff">

		<?php do_action( 'woo_pd_before_upload' ); ?>

		<div id="upload-csv" class="postbox">
			<h3 class="hndle"><?php _e( 'Upload Products', 'woocommerce-product-importer' ); ?></h3>
			<div class="inside">
				<p><?php _e( 'Select from one of the below import methods, then click Upload file to import.', 'woocommerce-product-importer' ); ?></p>

				<p><label><input type="radio" name="upload_method" id="file-filters-upload" value="upload"<?php checked( $import->upload_method, 'upload' ); ?> /> <?php _e( 'Choose a file from your computer', 'woocommerce-product-importer' ); ?></label></p>
				<div id="import-products-filters-upload" class="upload-method separator">
					<label for="file_upload"><strong><?php _e( 'Choose a file from your computer', 'woocommerce-product-importer' ); ?></strong>:</label> <input type="file" id="csv_file" name="csv_file" size="25" />
					<p class="description"><?php printf( __( 'Choose your Product Catalogue/CSV (.csv) to upload, maximum size: %sMB.', 'woocommerce-product-importer' ), $upload_mb ); ?></p>
				</div>
				<!-- #import-products-filters-upload -->

				<p><label><input type="radio" name="upload_method" id="file-filters-file_path" value="file_path"<?php checked( $import->upload_method, 'file_path' ); ?> /> <?php _e( 'Import by file path', 'woocommerce-product-importer' ); ?></label></p>
				<div id="import-products-filters-file_path" class="upload-method separator">
					<label for="csv_file_path"><strong><?php _e( 'Import by file path', 'woocommerce-product-importer' ); ?></strong>:</label>
					<p><code><?php echo $file_path; ?></code><input type="text" id="csv_file_path" name="csv_file_path" size="25" class="regular-text code" value="<?php echo $file_path_relative; ?>" /></p>
					<p class="description"><?php printf( __( 'Enter the relative file path to a CSV file. This is case sensitive. Example: <code>%s</code>', 'woocommerce-product-importer' ), ( !empty( $import->date_directory ) ? $import->date_directory : '' ) . 'import.csv' ); ?></p>
				</div>
				<!-- #import-products-filters-file_path -->

				<p><label><input type="radio" name="upload_method" id="file-filters-url" value="url"<?php checked( $import->upload_method, 'url' ); ?> /> <?php _e( 'Import from file URL', 'woocommerce-product-importer' ); ?></label></p>
				<div id="import-products-filters-url" class="upload-method separator">
					<label for="file_url"><strong><?php _e( 'Import from file URL', 'woocommerce-product-importer' ); ?></strong>:</label>
					<p><input type="text" id="csv_file_url" name="csv_file_url" size="50" class="large-text code" value="<?php echo $file_url; ?>" /></p>
					<p class="description"><?php _e( 'Enter the full URL to a CSV file. This is case sensitive. Example: <code>http://www.domain.com/wp-content/uploads/imports/import.csv</code>', 'woocommerce-product-importer' ); ?></p>
				</div>
				<!-- #import-products-filters-url -->

				<p><label><input type="radio" name="upload_method" id="file-filters-ftp" value="ftp"<?php checked( $import->upload_method, 'ftp' ); ?> /> <?php _e( 'Import from remote FTP', 'woocommerce-product-importer' ); ?></label></p>
				<div id="import-products-filters-ftp" class="upload-method upload-method-last separator">
					<p><strong><?php _e( 'Import from remote FTP', 'woocommerce-product-importer' ); ?></strong>:</p>
					<label for="file_ftp_host"><?php _e( 'Host', 'woocommerce-product-importer' ); ?>:</label> <input type="text" id="file_ftp_host" name="csv_file_ftp[host]" size="15" class="regular-text code" value="<?php echo $file_ftp_host; ?>" /><br />
					<label for="file_ftp_user"><?php _e( 'Username', 'woocommerce-product-importer' ); ?>:</label> <input type="text" id="file_ftp_user" name="csv_file_ftp[user]" size="15" class="regular-text code" value="<?php echo $file_ftp_user; ?>" /><br />
					<label for="file_ftp_pass"><?php _e( 'Password', 'woocommerce-product-importer' ); ?>:</label> <input type="password" id="file_ftp_pass" name="csv_file_ftp[pass]" size="15" class="regular-text code" value="<?php echo $file_ftp_pass; ?>" /><br />
					<label for="file_ftp_port"><?php _e( 'Port', 'woocommerce-product-importer' ); ?>:</label> <input type="text" id="file_ftp_port" name="csv_file_ftp[port]" size="5" class="short-text code" value="<?php echo $file_ftp_port; ?>" maxlength="5" /><br />
					<label for="file_ftp_file_path"><?php _e( 'File path', 'woocommerce-product-importer' ); ?>:</label> <input type="text" id="file_ftp_file_path" name="csv_file_ftp[remote_file_path]" size="25" class="regular-text code" value="<?php echo $file_ftp_path; ?>" /><br />
					<label for="file_ftp_passive"><?php _e( 'Transfer mode', 'woocommerce-product-importer' ); ?>:</label>
					<select id="file_ftp_passive" name="csv_file_ftp[passive]">
						<option value="auto" selected="selected"><?php _e( 'Auto', 'woocommerce-product-importer' ); ?></option>
						<option value="active"><?php _e( 'Active', 'woocommerce-product-importer' ); ?></option>
						<option value="passive"><?php _e( 'Passive', 'woocommerce-product-importer' ); ?></option>
					</select><br />
					<label for="file_ftp_timeout"><?php _e( 'Timeout', 'woocommerce-product-importer' ); ?>:</label> <input type="text" id="file_ftp_timeout" name="csv_file_ftp[timeout]" size="5" class="short-text code" value="<?php echo $file_ftp_timeout; ?>" /><br />
					<p class="description"><?php _e( 'Enter the FTP host, login details and path to a CSV file. For file path example: <code>wp-content/uploads/imports/import.csv</code>', 'woocommerce-product-importer' ); ?></p>
				</div>
				<!-- #import-products-filters-ftp -->

				<p class="submit">
					<input type="submit" value="<?php _e( 'Upload file and import', 'woocommerce-product-importer' ); ?>" class="button-primary" />
					<input type="reset" value="<?php _e( 'Reset', 'woocommerce-product-importer' ); ?>" class="button" />
				</p>
			</div>
			<!-- .inside -->
		</div>
		<!-- #upload-csv -->

		<?php do_action( 'woo_pd_after_upload' ); ?>
		<?php do_action( 'woo_pd_before_options' ); ?>

		<div id="import-options" class="postbox">
			<h3 class="hndle"><?php _e( 'Import Options', 'woocommerce-product-importer' ); ?></h3>
			<div class="inside">
				<table class="form-table">

					<tr>
						<th>
							<label for="delimiter"><?php _e( 'Field delimiter', 'woocommerce-product-importer' ); ?></label>
						</th>
						<td>
							<input type="text" size="3" id="delimiter" name="delimiter" value="<?php echo $import->delimiter; ?>" size="1" class="text" />
							<p class="description"><?php _e( 'The field delimiter is the character separating each cell in your CSV. This is typically the \',\' (comma) character.', 'woocommerce-product-importer' ); ?></p>
						</td>
					</tr>

					<tr>
						<th>
							<label for="category_separator"><?php _e( 'Product Category separator', 'woocommerce-product-importer' ); ?></label>
						</th>
						<td>
							<input type="text" size="3" id="category_separator" name="category_separator" value="<?php echo $import->category_separator; ?>" size="1" class="text" />
							<p class="description"><?php _e( 'The Product Category separator allows you to assign individual Products to multiple Product Categories/Tags/Images at a time. It is suggested to use the \'|\' (vertical pipe) character between each item. For instance: <code>Clothing|Mens|Shirts</code>.', 'woocommerce-product-importer' ); ?></p>
						</td>
					</tr>

					<tr>
						<th>
							<label for="parent_child_delimiter"><?php _e( 'Product Category heirachy delimiter', 'woocommerce-product-importer' ); ?></label>
						</th>
						<td>
							<input type="text" size="3" id="parent_child_delimiter" name="parent_child_delimiter" value="<?php echo $import->parent_child_delimiter; ?>" size="1" class="text" />
							<p class="description"><?php _e( 'The Product Category heirachy delimiter links Products Categories in parent/child relationships. It is suggested to use the \'>\' character between each Product Category. For instance: <code>Clothing>Mens>Shirts</code>', 'woocommerce-product-importer' ); ?>.</p>
						</td>
					</tr>

				</table>
			</div>
			<!-- .inside -->
		</div>
		<!-- #import-options -->

		<?php do_action( 'woo_pd_after_options' ); ?>
		<?php do_action( 'woo_pd_before_past_imports' ); ?>

		<div id="past-imports" class="postbox">
			<h3 class="hndle">
				<?php _e( 'Past Imports', 'woocommerce-product-importer' ); ?>
			</h3>
			<div class="inside">

<?php if( $past_imports ) { ?>
				<p><?php _e( 'Select an existing CSV to re-import that Product Catalogue CSV.', 'woocommerce-product-importer' ); ?></p>
				<table class="widefat page fixed past_imports">
					<thead>
						<tr>
							<th class="manage-column"><?php _e( 'Filename', 'woocommerce-product-importer' ); ?></th>
							<th class="manage-column"><?php _e( 'Date Imported', 'woocommerce-product-importer' ); ?></th>
							<th class="manage-column separator">&nbsp;</th>
						</tr>
					</thead>
					<tbody>
	<?php foreach( $past_imports as $key => $past_import ) { ?>
						<tr>
							<td class="past_import">
								<label>
									<input type="radio" name="past_import" value="<?php echo $past_import['filename']; ?>" />
									<code><?php echo basename( $past_import['filename'] ); ?></code>
								</label>
							</td>
							<td>
								<?php printf( __( '%s ago', 'woocommerce-product-importer' ), human_time_diff( strtotime( $past_import['date'] ) ) ); ?><br /><small><?php echo mysql2date( get_option('date_format'), $past_import['date'] ); ?></small>
							</td>
							<td class="remove">
								<a href="<?php echo add_query_arg( array( 'page' => 'woo_pd', 'action' => 'remove_past_import', 'file_id' => $key, '_wpnonce' => wp_create_nonce( 'woo_pd_remove_past_import' ) ), 'admin.php' ); ?>"><?php _e( 'Remove', 'woocommerce-product-importer' ); ?></a>
							</td>
						</tr>
	<?php } ?>
					</tbody>
				</table>
				<p class="submit">
					<input type="submit" value="<?php _e( 'Import existing CSV', 'woocommerce-product-importer' ); ?>" class="button-primary" />
					<input type="reset" value="<?php _e( 'Reset', 'woocommerce-product-importer' ); ?>" class="button" />
				</p>
<?php } else { ?>
				<p><?php _e( 'No past imports have been saved.', 'woocommerce-product-importer' ); ?></p>
<?php } ?>
<?php if( $import->delete_file == '1' ) { ?>
				<p class="description"><?php _e( '\'Delete temporary CSV after import\' within Import Options below must be set to No to enable past imports.', 'woocommerce-product-importer' ); ?></p>
<?php } ?>
			</div>
			<!-- .inside -->
		</div>
		<!-- #past-imports -->

		<?php do_action( 'woo_pd_after_past_imports' ); ?>

	</div>
	<!-- #poststuff -->

	<input type="hidden" name="action" value="upload" />
	<input type="hidden" name="page_options" value="csv_file" />
	<?php wp_nonce_field( 'update-options' ); ?>
</form>
<form id="custom_fields" method="post">
	<div id="poststuff">

		<?php do_action( 'woo_pd_before_custom_fields' ); ?>

		<div id="custom-fields" class="postbox">
			<h3 class="hndle"><?php _e( 'Custom Import Fields', 'woocommerce-product-importer' ); ?></h3>
			<div class="inside">
				<p class="description"><?php _e( 'To include additional custom Product meta and custom Product Attributes in the list of available import fields fill the appropriate text box then click Save Custom Fields.', 'woocommerce-product-importer' ); ?></p>
				<table class="form-table">

					<tr>
						<th>
							<label><?php _e( 'Product meta', 'woocommerce-product-importer' ); ?></label>
						</th>
						<td>
							<textarea name="custom_products" rows="5" cols="70"><?php echo esc_textarea( $custom_products ); ?></textarea>
							<p class="description"><?php _e( 'Include additional custom Product meta to be imported by adding each custom Product meta name to a new line above.', 'woocommerce-product-importer' ); ?><br /><?php _e( 'For example', 'woocommerce-product-importer' ); ?>: <code>_custom_field</code> (new line) <code>Custom Field</code></p>
						</td>
					</tr>

					<tr>
						<th>
							<label><?php _e( 'Custom Attributes', 'woocommerce-product-importer' ); ?></label>
						</th>
						<td>
							<textarea name="custom_attributes" rows="5" cols="70"><?php echo esc_textarea( $custom_attributes ); ?></textarea>
							<p class="description"><?php _e( 'Include additional custom Product Attributes to be imported by adding each custom Attribute name (not the Attribute title) to a new line above.', 'woocommerce-product-importer' ); ?><br /><?php _e( 'For example', 'woocommerce-product-importer' ); ?>: <code>colour</code> (new line) <code>year-of-birth</code></p>
						</td>
					</tr>

					<?php do_action( 'woo_pd_extend_custom_fields' ); ?>

				</table>

				<p class="submit">
					<input type="submit" value="<?php _e( 'Save Custom Fields', 'woocommerce-product-importer' ); ?>" class="button-primary" />
				</p>

			</div>
			<!-- .inside -->
		</div>
		<!-- #custom-fields -->

		<?php do_action( 'woo_pd_after_custom_fields' ); ?>
		<?php do_action( 'woo_pd_before_modules' ); ?>
		<?php do_action( 'woo_pd_after_modules' ); ?>

	</div>
	<!-- #poststuff -->

	<input type="hidden" name="action" value="update" />
	<input type="hidden" name="page_options" value="csv_file" />
	<?php wp_nonce_field( 'update-options' ); ?>
</form>