<div id="content" class="woo_pd_page_options">
	<?php woo_pd_total_columns(); ?>
	<p><?php _e( 'Using the drop down menu match each column in your CSV to a Product detail, then click Upload file and import.', 'woo_pd' ); ?></p>
	<form enctype="multipart/form-data" method="post" action="<?php echo add_query_arg( 'action', null ); ?>" class="options">
		<table class="widefat page fixed">
			<thead>
				<tr>
					<th class="manage-column text-align-right"><?php _e( 'First Row', 'woo_pd' ); ?></th>
					<th class="manage-column column-equals">&nbsp;</th>
					<th class="manage-column"><?php _e( 'CSV', 'woo_pd' ); ?> -> <?php _e( 'WooCommerce', 'woo_pd' ); ?></th>
					<th class="manage-column"><?php _e( 'Second Row', 'woo_pd' ); ?> <small>(*)</small></th>
				</tr>
			</thead>
<?php foreach( $first_row as $key => $cell ) { ?>
			<tr>
				<th class="vertical-align-middle text-align-right" valign="top">
					<input type="hidden" name="column[]" value="<?php echo $key+1; ?>" />
					<code><?php echo $cell; ?></code>
				</th>
				<td class="vertical-align-middle text-align-center column-equals"><strong>=</strong></td>
				<td class="vertical-align-middle">
					<select name="value_name[]">
						<option></option>
	<?php for( $k = 0; $k < $import->options_size; $k++ ) { ?>
						<option value="<?php echo $import->options[$k][0]; ?>"<?php selected( woo_pd_prepare_column( $import->options[$k][1] ), woo_pd_prepare_column( $cell ) ); ?>><?php echo $import->options[$k][1]; ?></option>
	<?php } ?>
					</select>
				</td>
				<td class="vertical-align-middle">
	<?php if( $import->user_locale ) { ?>
					<code><?php echo utf8_encode( $second_row[$key] ); ?></code>
	<?php } else { ?>
					<code><?php echo $second_row[$key]; ?></code>
	<?php } ?>
				</td>
			</tr>
<?php } ?>
		</table>
		<p class="description"><?php _e( '<small>(*)</small> If your CSV contains special characters - such as &aelig;, &szlig;, &eacute;, etc. - they may display weird under the First and Second Row above, please continue regardless.', 'woo_pd' ); ?></p>
		<div id="poststuff">
			<div class="postbox">
				<h3 class="hndle"><?php _e( 'Import Options', 'woo_pd' ); ?></h3>
				<div class="inside">
					<table class="form-table">

						<tr>
							<td>
								<label><input type="checkbox" name="skip_first" class="checkbox"<?php checked( $import->skip_first ); ?> /> <?php _e( 'Skip first row', 'woo_pd' ); ?></label>
							</td>
						</tr>

						<tr>
							<td>
								<label for="import_method"><?php _e( 'Import Method', 'woo_pd' ); ?></label>
								<select id="import_method" name="import_method">
									<option value="new"<?php selected( $import->import_method, 'new' ); ?>><?php _e( 'Import new Products only', 'woo_pd' ); ?></option>
									<option value="merge"<?php disabled( $products, 0 ); ?><?php selected( $import->import_method, 'merge' ); ?>><?php _e( 'Import new Products and merge Product changes', 'woo_pd' ); ?></option>
									<option value="update"<?php disabled( $products, 0 ); ?><?php selected( $import->import_method, 'update' ); ?>><?php _e( 'Merge Product changes only', 'woo_pd' ); ?></option>
								</select>
								<p class="description"><?php _e( 'Adjust the import method to suit your import needs. Merged Product changes are linked by the SKU.', 'woo_pd' ); ?></p>
							</td>
						</tr>

						<tr>
							<td>
								<label><input type="checkbox" name="import_images" class="checkbox" onclick="toggleBlock(this, &#039;toggle_imageoptions&#039; );" <?php if( $import->images_method ) { ?> checked="checked"<?php } ?> /> <?php _e( 'Are you importing images?', 'woo_pd' ); ?></label>
								<div class="toggle" id="toggle_imageoptions"<?php if( !$import->images_method ) { ?> style="display:none;"<?php } ?>>
									<table class="form-table">
										<tr>
											<td style="vertical-align:top;">
												<label><?php _e( 'What method are you using to upload Product images?', 'woo_pd' ); ?></label>
												<fieldset style="margin-top:0.5em;">
													<label><input type="radio" id="images_method_csv" name="images_method" value="csv"<?php checked( $import->images_method, 'csv' ); ?> /> <?php _e( 'Assigned an image column above for Product image filenames in the CSV file, and uploaded the images to: ', 'woo_pd' ); ?><code><?php echo $import->uploads_directory; ?></code></label>
													<p class="description"><?php _e( 'For instance', 'woo_pd' ); ?>: product-1a.jpg<?php echo $import->category_separator; ?>product-1b.jpg<?php echo $import->category_separator; ?>product-1c.jpg</p>
													<label><input type="radio" id="images_method_external" name="images_method" value="external"<?php checked( $import->images_method, 'external' ); ?> /> <?php _e( 'Assigned an external URL column for Products in the CSV file', 'woo_pd' ); ?></label>
													<p class="description"><?php _e( 'For instance', 'woo_pd' ); ?>: http://www.domain.com/images/product-1a.jpg<?php echo $import->category_separator; ?>http://www.domain.com/images/product-1b.jpg<?php echo $import->category_separator; ?>http://www.domain.com/images/product-1c.jpg</p>
													<hr class="description" />
													<label><input type="radio" id="images_method_csv" name="images_method" value="" /> <?php _e( 'I am not uploading Product images', 'woo_pd' ); ?></label><br />
												</fieldset>
											</td>
										</tr>
									</table>
								</div>
							</td>
						</tr>

<?php if( !ini_get( 'safe_mode' ) ) { ?>
						<tr>
							<td>
								<label for="timeout"><?php _e( 'Script Timeout', 'woo_pd' ); ?>: </label>
								<select id="timeout" name="timeout">
									<option value="600"<?php selected( $import->timeout, 600 ); ?>><?php printf( __( '%d minutes', 'woo_pd' ), 10 ); ?></option>
									<option value="1800"<?php selected( $import->timeout, 1800 ); ?>><?php printf( __( '%d minutes', 'woo_pd' ), 30 ); ?></option>
									<option value="3600"<?php selected( $import->timeout, 3600 ); ?>><?php printf( __( '%d hour', 'woo_pd' ), 1 ); ?></option>
									<option value="0"<?php selected( $import->timeout, 0 ); ?>><?php _e( 'Unlimited', 'woo_pd' ); ?></option>
								</select>
								<p class="description"><?php _e( 'Script timeout defines how long Product Importer Deluxe is \'allowed\' to process your CSV file, once the time limit is reached the import process halts. Default is 10 minutes.', 'woo_pd' ); ?></p>
							</td>
						</tr>

<?php } ?>
						<tr>
							<td>
								<label><input type="checkbox" name="advanced_log"<?php checked( $import->advanced_log ); ?> />&nbsp;<?php _e( 'Advanced Import Reporting', 'woo_pd' ); ?></label>
								<p class="description"><?php _e( 'This option will provide a more detailed import log but comes at the expense of a slower import process. Default is off.', 'woo_pd' ); ?></p>
							</td>
						</tr>

						<tr>
							<td>
								<label><input type="checkbox" name="special_category_assignment"<?php checked( $import->special_category_assignment ); ?> />&nbsp;<?php _e( 'Assign Products to lowest level sub-Category only', 'woo_pd' ); ?></label>
								<p class="description"><?php printf( __( 'This option controls whether Products should be assigned to all Categories within the branch (e.g. %s), or just to the lowest level sub-Category (e.g. Cabbages). Default is off.', 'woo_pd' ), __( 'Vegetables', 'woo_pd' ) . $import->parent_child_delimiter . __( 'Greens', 'woo_pd' ) . $import->parent_child_delimiter . __( 'Cabbages', 'woo_pd' ) ); ?></p>
							</td>
						</tr>

					</table>
				</div>
			</div>
		</div>
		<?php wp_nonce_field( 'update-options' ); ?>
		<input type="hidden" name="action" value="save" />
		<input type="hidden" name="delimiter" value="<?php echo $import->delimiter; ?>" />
		<input type="hidden" name="category_separator" value="<?php echo $import->category_separator; ?>" />
		<input type="hidden" name="parent_child_delimiter" value="<?php echo $import->parent_child_delimiter; ?>" />
		<input type="hidden" name="delete_temporary_csv" value="<?php echo $import->delete_temporary_csv; ?>" />
		<p class="submit">
			<input type="submit" value="<?php _e( 'Upload file and import', 'woo_pd' ); ?>" class="button-primary" />
		</p>
		<p><?php _e( '<strong>Note</strong>: If the following screen goes blank simply hit your browser\'s Refresh (F5) button to continue the import process. If this fails please consult the <a href="' . $usage_page_url . '" target="_blank">Usage page</a> of this Plugin for further assistance.', 'woo_pd' ); ?></p>
	</form>
</div>