<h2 class="nav-tab-wrapper">
	<a data-tab-id="import" class="nav-tab nav-tab-active" href="<?php echo add_query_arg( 'tab', null ); ?>"><?php _e( 'Import', 'woo_pd' ); ?></a>
	<a data-tab-id="settings" class="nav-tab" href="<?php echo add_query_arg( 'tab', 'settings' ); ?>"><?php _e( 'Settings', 'woo_pd' ); ?></a>
</h2>

<p><strong><?php _e( 'G\'day, mate! Upload your Product spreadsheet - formatted as a CSV file - and we\'ll import your Products into WooCommerce.', 'woo_pd' ); ?></strong></p>
<p><?php printf( __( 'To help you get started, you can download the latest %s and %s any time from the Plugin detail page on our website.', 'woo_pd' ), '<a href="' . $csv_sample_link . '" target="_blank">' . __( 'sample CSV\'s', 'woo_pd' ) . '</a>', '<a href=" ' . $csv_template_link . '" target="_blank">' . __( 'CSV templates', 'woo_pd' ) . '</a>' ); ?></p>
<form enctype="multipart/form-data" method="post">
	<div id="poststuff">

		<?php do_action( 'woo_pd_before_upload' ); ?>

		<div id="upload-csv" class="postbox">
			<h3 class="hndle"><?php _e( 'Upload Products', 'woo_pd' ); ?></h3>
			<div class="inside">
				<p><?php _e( 'Select from one of the below import methods, then click Upload file to import.', 'woo_pd' ); ?></p>
				<ul>
					<li class="separator">
						<label for="csv_file"><strong><?php _e( 'Choose a file from your computer', 'woo_pd' ); ?></strong>:</label> <input type="file" id="csv_file" name="csv_file" size="25" />
						<p class="description"><?php _e( 'Choose your Product Catalogue CSV to upload, maximum size: ' . $upload_mb . 'MB.', 'woo_pd' ); ?></p>
					</li>
					<li class="separator">
						<label for="csv_file_path"><strong><?php _e( 'Import by file path', 'woo_pd' ); ?></strong>:</label><br /><code><?php echo $file_path; ?></code><input type="text" id="csv_file_path" name="csv_file_path" size="25" class="regular-text code" value="<?php echo $file_path_relative; ?>" />
						<p class="description"><?php _e( 'Enter the relative file path to a CSV file.', 'woo_pd' ); ?></p>
					</li>
<!--
					<li>
						<label for="csv_file_url"><?php _e( 'Import by file URL', 'woo_pd' ); ?>:</label> <input type="text" id="csv_file_url" name="csv_file_url" size="25" class="regular-text code" />
						<p class="description"><?php _e( 'Enter the full URL to a CSV file.', 'woo_pd' ); ?></p>
					</li>
-->
				</ul>
				<?php wp_nonce_field( 'update-options' ); ?>
				<input type="hidden" name="MAX_FILE_SIZE" value="5000000" />
				<input type="hidden" name="action" value="upload" />
				<input type="hidden" name="page_options" value="csv_file" />
				<p class="submit">
					<input type="submit" value="<?php _e( 'Upload file and import', 'woo_pd' ); ?>" class="button-primary" />
					<input type="reset" value="<?php _e( 'Reset', 'woo_pd' ); ?>" class="button" />
				</p>
			</div>
		</div>
		<!-- .postbox -->

		<?php do_action( 'woo_pd_after_upload' ); ?>
		<?php do_action( 'woo_pd_before_past_imports' ); ?>

		<div class="postbox">
			<h3 class="hndle"><?php _e( 'Past Imports', 'woo_pd' ); ?></h3>
			<div class="inside">

<?php if( $past_imports ) { ?>
				<p><?php _e( 'Select an existing CSV to re-import that Product Catalogue CSV.', 'woo_pd' ); ?></p>
				<table class="widefat page fixed past_imports">
					<thead>
						<tr>
							<th class="manage-column"><?php _e( 'Filename', 'woo_pd' ); ?></th>
							<th class="manage-column"><?php _e( 'Date Imported', 'woo_pd' ); ?></th>
							<th class="manage-column separator">&nbsp;</th>
						</tr>
					</thead>
					<tbody>
	<?php foreach( $past_imports as $key => $past_import ) { ?>
						<tr>
							<td class="past_import">
								<label>
									<input type="radio" name="past_import" value="<?php echo $past_import['filename']; ?>" />
									<code><?php echo basename( $past_import['filename'] ); ?></code>
								</label>
							</td>
							<td>
								<?php printf( __( '%s ago', 'woo_pd' ), human_time_diff( strtotime( $past_import['date'] ) ) ); ?><br /><small><?php echo mysql2date( get_option('date_format'), $past_import['date'] ); ?></small>
							</td>
							<td class="remove">
								<a href="<?php echo add_query_arg( array( 'page' => 'woo_pd', 'action' => 'remove_past_import', 'file_id' => $key ), 'admin.php' ); ?>"><?php _e( 'Remove', 'woo_pd' ); ?></a>
							</td>
						</tr>
	<?php } ?>
					</tbody>
				</table>
				<p class="submit">
					<input type="submit" value="<?php _e( 'Import existing CSV', 'woo_pd' ); ?>" class="button-primary" />
					<input type="reset" value="<?php _e( 'Reset', 'woo_pd' ); ?>" class="button" />
				</p>
<?php } else { ?>
				<p><?php _e( 'No past imports have been saved.', 'woo_pd' ); ?></p>
<?php } ?>
<?php if( $import->delete_temporary_csv == '1' ) { ?>
				<p class="description"><?php _e( '\'Delete temporary CSV after import\' within Import Options below must be set to No to enable past imports.', 'woo_pd' ); ?></p>
<?php } ?>
			</div>
		</div>
		<!-- .postbox -->

		<?php do_action( 'woo_pd_after_past_imports' ); ?>
		<?php do_action( 'woo_pd_before_modules' ); ?>

		<div class="postbox">
			<h3 class="hndle"><?php _e( 'Import Modules', 'woo_pd' ); ?></h3>
			<div class="inside">
				<p><?php _e( 'Import and merge Product details from other WooCommerce and WordPress Plugins, simply install and activate one of the below Plugins to enable those additional import options.', 'woo_pd' ); ?></p>
<?php if( $modules ) { ?>
				<div class="table table_content">
					<table class="woo_vm_version_table">
	<?php foreach( $modules as $module ) { ?>
						<tr>
							<td class="import_module">
		<?php if( $module['description'] ) { ?>
								<strong><?php echo $module['title']; ?></strong>: <span class="description"><?php echo $module['description']; ?></span>
		<?php } else { ?>
								<strong><?php echo $module['title']; ?></strong>
		<?php } ?>
							</td>
							<td class="status">
								<span class="<?php woo_pd_modules_status_class( $module['status'] ); ?>">
		<?php if( $module['status'] == 'active' ) { ?>
									<?php woo_pd_modules_status_label( $module['status'] ); ?>
		<?php } else { ?>
			<?php if( is_array( $module['url'] ) ) { ?>
									<?php _e( 'Install', 'woo_pd' ); ?> <a href="<?php echo $module['url'][0]; ?>" target="_blank">[1]</a> <a href="<?php echo $module['url'][1]; ?>" target="_blank">[2]</a>
			<?php } else { ?>
									<a href="<?php echo $module['url']; ?>" target="_blank"><?php woo_pd_modules_status_label( $module['status'] ); ?></a>
			<?php } ?>
		<?php } ?>
								</span>
							</td>
						</tr>
	<?php } ?>
					</table>
				</div>
				<!-- .table -->
<?php } else { ?>
				<p><?php _e( 'No import modules are available at this time.', 'woo_pd' ); ?></p>
<?php } ?>
			</div>
		</div>
		<!-- .postbox -->

		<?php do_action( 'woo_pd_after_modules' ); ?>
		<?php do_action( 'woo_pd_before_options' ); ?>

		<div class="postbox">
			<h3 class="hndle"><?php _e( 'Import Options', 'woo_pd' ); ?></h3>
			<div class="inside">
				<table class="form-table">

					<tr>
						<th>
							<label for="delimiter"><?php _e( 'Field delimiter', 'woo_pd' ); ?></label>
						</th>
						<td>
							<input type="text" size="3" id="delimiter" name="delimiter" value="<?php echo $import->delimiter; ?>" size="1" class="text" />
							<p class="description"><?php _e( 'The field delimiter is the character separating each cell in your CSV. This is typically the \',\' (comma) character.', 'woo_pd' ); ?></p>
						</td>
					</tr>

					<tr>
						<th>
							<label for="category_separator"><?php _e( 'Product Category separator', 'woo_pd' ); ?></label>
						</th>
						<td>
							<input type="text" size="3" id="category_separator" name="category_separator" value="<?php echo $import->category_separator; ?>" size="1" class="text" />
							<p class="description"><?php _e( 'The Product Category separator allows you to assign individual Products to multiple Product Categories/Tags/Images at a time. It is suggested to use the \'|\' (vertical pipe) character between each item. For instance: <code>Clothing|Mens|Shirts</code>.', 'woo_pd' ); ?></p>
						</td>
					</tr>

					<tr>
						<th>
							<label for="parent_child_delimiter"><?php _e( 'Product Category heirachy delimiter', 'woo_pd' ); ?></label>
						</th>
						<td>
							<input type="text" size="3" id="parent_child_delimiter" name="parent_child_delimiter" value="<?php echo $import->parent_child_delimiter; ?>" size="1" class="text" />
							<p class="description"><?php _e( 'The Product Category heirachy delimiter links Products Categories in parent/child relationships. It is suggested to use the \'>\' character between each Product Category. For instance: <code>Clothing>Mens>Shirts</code>', 'woo_pd' ); ?>.</p>
						</td>
					</tr>

					<tr>
						<th>
							<label for="delete_temporary_csv"><?php _e( 'Delete temporary CSV after import', 'woo_pd' ); ?></label>
						</th>
						<td>
<?php if( $delete_csv_options ) { ?>
							<select id="delete_temporary_csv" name="delete_temporary_csv">
	<?php foreach( $delete_csv_options as $key => $delete_csv_option ) { ?>
								<option value="<?php echo $key; ?>"<?php selected( $key, $import->delete_temporary_csv ); ?>><?php echo $delete_csv_option; ?>&nbsp;</option>
	<?php } ?>
							</select>
<?php } ?>
						</td>
					</tr>

					<tr>
						<th>
							<label for="user_locale"><?php _e( 'Set Locale', 'woo_pd' ); ?></label>
						</th>
						<td>
							<input type="text" id="user_locale" name="user_locale" size="8" maxlength="8" value="<?php echo $import->user_locale; ?>" />
							<p class="description"><?php _e( 'If your CSV contains special characters - such as &aelig;, &szlig;, &eacute;, etc. - set this to a locale compatible with those characters. This is typically empty.', 'woo_pd' ); ?></p>
						</td>
					</tr>
				</table>
			</div>
		</div>
		<!-- .postbox -->

		<?php do_action( 'woo_pd_after_options' ); ?>
		<?php do_action( 'woo_pd_before_tools' ); ?>

		<div class="postbox">
			<h3 class="hndle"><?php _e( 'Tools', 'woo_pd' ); ?></h3>
			<div class="inside">
				<table class="form-table">

					<tr>
						<td>
							<a href="<?php echo $woo_ce_url; ?>"<?php echo $woo_ce_target; ?>><?php _e( 'Export Products to CSV', 'woo_ce' ); ?></a>
							<p class="description"><?php _e( 'Export store details out of WooCommerce and into a CSV-formatted file.', 'woo_ce' ); ?></p>
						</td>
					</tr>

				</table>
			</div>
		</div>
		<!-- .postbox -->

		<?php do_action( 'woo_pd_after_tools' ); ?>

	</div>
</form>